package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class BaseButton extends Component {

public  BaseButton () {
mState = ((int)0);


    InitBaseButton();

}


public  BaseButton (Viewport viewport) {
super();
mState = ((int)0);


	SetViewport(viewport);
    InitBaseButton();

}


public  BaseButton (Viewport viewport, String caption, Font buttonFont, int stateFlags) {
super();
mState = (ButtonState.STATE_NORMAL);


	SetViewport(viewport);
    InitBaseButton();
     int i = 0;

     int flagCheck = 0x00001;


    for(i = 0;i < ButtonState.STATE_TOTAL;i ++)
    {
        if((stateFlags & flagCheck) != 0)
        {
			mStateMap[i] = mStateCount;
			mStateCount++;
        }

        flagCheck = flagCheck << 4;
    }


	CreateArrays();

	if(buttonFont != null)
	{
		for(i = 0;i < mStateCount;i ++)
		{
			mFonts[i] = buttonFont;
		}
	}

    if(!caption.IsEmpty())
    {
        SetCaption(caption);
    }

}


public void destruct() {








mFonts = null;
	mAligns = null;

    mOpacity = null;
mTextCaption = null;

}


public void SetCaption ( String caption, boolean isMultiline) {



	if(mTextCaption == null)
	{
		mTextCaption = new Text(null, null, new String(caption), mRect_left, mRect_top, mRect_width, mRect_height, Alignment.LEFT);
	}
	
	mTextCaption.SetFont(mFonts[mStateIndex]);
	mTextCaption.SetAlignment(mAligns[mStateIndex]);
	mTextCaption.OnRectChange();

	mTextCaption.SetMultiline(isMultiline);
	mTextCaption.SetCaption(new String(caption));
	mTextCaption.SetVisible(true);
	Invalidate();

}


public String GetCaption () {

	if(mTextCaption == null)
	{
		mTextCaption = new Text(null, null, new String(), mRect_left, mRect_top, mRect_width, mRect_height, Alignment.LEFT);
	}
	return  mTextCaption.GetCaption();

}


public void SetFont ( Font font, int state) {



	mFonts[mStateMap[state]] = font;

	if(mTextCaption != null && state == mState) 
	{
		mTextCaption.SetFont(font);
	}

}


public Font GetFont (int state) {


	return mFonts[mStateMap[state]];

}


public void SetAlignment ( byte align, int state) {



	mAligns[mStateMap[state]] = align;

	if(mTextCaption != null && state == mState) 
	{
		mTextCaption.SetAlignment(align);
	}

}


public byte GetAlignment (int state) {


	return mAligns[mStateMap[state]];

}


public void SetState (int state) {



	mState = state;
	mStateIndex = mStateMap[state];
	if(mStateIndex == -1)
	{
		mStateIndex = 0;
	}
	if(mTextCaption != null)
	{
		mTextCaption.SetFont(mFonts[mStateIndex]);
		mTextCaption.SetAlignment(mAligns[mStateIndex]);
		mTextCaption.OnRectChange(); 
	}
	OnStateChange(state);
	Invalidate();

}


public int GetState () {

	return  (int)mState;

}


public Text GetTextSubComponent () {

	return  mTextCaption;

}


public void Activate () {

	GetViewport().OnChildEvent(this);

}


public boolean OnDefaultMsg (Component source, int msg, int intParam) {

	if((msg < keyUpMsg) || (msg > keyDownOrRepeatMsg) ||

	   ((int)intParam != Key.SELECT)


)
	{
		return  super.OnDefaultMsg(source, msg, intParam);
	}

	if(msg != keyDownOrRepeatMsg)
	{
		OnPress(msg == keyUpMsg);
	}
	return  true;

}


public void OnPress (boolean up) {

	if(IsVisible() && GetState() != ButtonState.STATE_DISABLED)
	{
		if(up)
		{
			SetState(ButtonState.STATE_NORMAL);
			Activate();
		}
		else 
		{
			SetState(ButtonState.STATE_PUSHED);
		}
	}

}


public void OnStateChange(int a24) {
 
}


public void OnDraw (DisplayContext displayContext) {

	if(mTextCaption != null && mTextCaption.IsVisible())
	{
		mTextCaption.OnDraw(displayContext);
	}

}


public void OnRectChange () {

	if(mTextCaption != null)
	{
		mTextCaption.SetRect(mRect_left, mRect_top, mRect_width, mRect_height);
	}

}


public short GetOpacity(int state) {
 return mOpacity[mStateMap[state]]; 
}


public void SetOpacity (int state, short opacity) {

	 short[] curOpacity = mOpacity;
	 int stateIndex = mStateMap[state];

	if(opacity != curOpacity[stateIndex])
	{
		curOpacity[stateIndex] = opacity;
		Invalidate();
	}

	if(mTextCaption != null)
	{
		mTextCaption.SetOpacity(opacity);
	}

}


public void InitBaseButton () {

    for(int i = 0;i < ButtonState.STATE_TOTAL;i ++)
    {
		mStateMap[i] = -1;
    }

}


public void CreateArrays () {

	mFonts = new Font[mStateCount];
	mAligns = new byte[mStateCount];
	int i;






mOpacity = new short[mStateCount];
	for(i = 0;i < mStateCount;i ++) 
	{
		mOpacity[i] = 255;		
	}

}


public Font[] mFonts = null;
public byte[] mAligns = null;
public byte mStateCount;
public byte[] mStateMap = new byte[ButtonState.STATE_TOTAL];

public Text mTextCaption;
public int mState;
public byte mStateIndex;
public short[] mOpacity = null;
public void SetCaption(String caption)
{
	SetCaption(caption, false);
}

/* One dimension array */
public static BaseButton[] InstArrayBaseButton(int size) {
	BaseButton[] newArray = new BaseButton[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new BaseButton();
	return newArray; }

/* Two dimension array */
public static BaseButton[][] InstArrayBaseButton(int size1, int size2) {
	BaseButton[][] newArray = new BaseButton[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new BaseButton[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new BaseButton(); }
	return newArray; }

/* Three dimension array */
public static BaseButton[][][] InstArrayBaseButton(int size1, int size2, int size3) {
	BaseButton[][][] newArray = new BaseButton[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new BaseButton[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new BaseButton[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new BaseButton(); } }
	return newArray; }



}

