package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class BitmapMap extends BitmapGroup {

public static BitmapMap Cast(Object o, BitmapMap _) {
 return  (BitmapMap)o; 
}


 final public static byte typeNumber = TypeIDOfType_BitmapMap.v;
 final public static byte typeID = TypeIDOfType_BitmapMap.w;
 public static final boolean supportsDynamicSerialization = true; public byte GetTypeID() {
 return  typeID; 
}


public static Class AsClass() {
 return  null; 
}


public  BitmapMap () {



}


public void destruct() {

	mBlob = null;
	mReferenceBitmap = null;

}


public short GetPublicSizeXAt (int index) {




	return  mBlob.mDataMatrix[(index << 3) + BitmapMapBlob.publicSizeX];

}


public short GetPublicSizeYAt (int index) {




	return  mBlob.mDataMatrix[(index << 3) + BitmapMapBlob.publicSizeY];

}


public short GetOffsetXAt (int index) {




	return  mBlob.mDataMatrix[(index << 3) + BitmapMapBlob.offsetX];

}


public short GetOffsetYAt (int index) {




	return  mBlob.mDataMatrix[(index << 3) + BitmapMapBlob.offsetY];

}


public short GetSourceLeftAt (int index) {




	return  mBlob.mDataMatrix[(index << 3) + BitmapMapBlob.sourceLeft];

}


public short GetSourceTopAt (int index) {




	return  mBlob.mDataMatrix[(index << 3) + BitmapMapBlob.sourceTop];

}


public short GetSourceWidthAt (int index) {




	return  mBlob.mDataMatrix[(index << 3) + BitmapMapBlob.sourceWidth];

}


public short GetSourceHeightAt (int index) {




	return  mBlob.mDataMatrix[(index << 3) + BitmapMapBlob.sourceHeight];

}


public void CopyFrom (BitmapMap source) {

	mReferenceBitmap = source.mReferenceBitmap;

	mBlob = null;
	SetBitmapMapBlob(new BitmapMapBlob(source.mBlob));

}


public int GetBitmapCount() {
 return  mBlob.GetBitmapCount(); 
}


public void DrawElementAt (int index, DisplayContext dc, short destRect_left, short destRect_top, short destRect_width, short destRect_height, short opacity, boolean tileInX, boolean tileInY) {





 int baseIndex = (index << 3);

	 short offsetedDestPosX = 0;

	 short offsetedDestPosY = 0;

	 short[] dataMatrix = mBlob.mDataMatrix;	










{
		offsetedDestPosX = (short)(destRect_left + dataMatrix[baseIndex + BitmapMapBlob.offsetX]);
	}










{
		offsetedDestPosY = (short)(destRect_top + dataMatrix[baseIndex + BitmapMapBlob.offsetY]);
	}


	if(tileInX || tileInY)
	{
		dc.DrawTiledBitmapSection(mReferenceBitmap, (short)dataMatrix[baseIndex + BitmapMapBlob.publicSizeX], (short)dataMatrix[baseIndex + BitmapMapBlob.publicSizeY], (short)(offsetedDestPosX - destRect_left), (short)(offsetedDestPosY - destRect_top), dataMatrix[baseIndex + BitmapMapBlob.sourceLeft], dataMatrix[baseIndex + BitmapMapBlob.sourceTop], dataMatrix[baseIndex + BitmapMapBlob.sourceWidth], dataMatrix[baseIndex + BitmapMapBlob.sourceHeight], destRect_left, destRect_top, destRect_width, destRect_height, opacity);	
		return ;
	}
dc.DrawBitmapSection(mReferenceBitmap, offsetedDestPosX, offsetedDestPosY, dataMatrix[baseIndex + BitmapMapBlob.sourceLeft], dataMatrix[baseIndex + BitmapMapBlob.sourceTop], dataMatrix[baseIndex + BitmapMapBlob.sourceWidth], dataMatrix[baseIndex + BitmapMapBlob.sourceHeight], opacity);

}


public void DrawElementAt(int index, DisplayContext dc, short destLeft, short destTop, short opacity) {
 DrawElementAt(index, dc, destLeft, destTop, (short)0, (short)0, opacity, false, false);
	
}


public void SetAsGrid (int numCol, int numRow) {




	 short[] dataMatrix = mBlob.mDataMatrix;
	 int sizeX = mReferenceBitmap.GetWidth() / numCol;

	 int sizeY = mReferenceBitmap.GetHeight() / numRow;


	 int baseIndex = 0;

	 int bitmapIndex = 0;

	for(int j = 0;j < numRow;j ++)
	{
		for(int i = 0;i < numCol;i ++)
		{			
			baseIndex = (bitmapIndex << 3);
			dataMatrix[baseIndex + BitmapMapBlob.sourceLeft] = (short)(i * sizeX);
			dataMatrix[baseIndex + BitmapMapBlob.sourceTop] = (short)(j * sizeY);
			dataMatrix[baseIndex + BitmapMapBlob.sourceWidth] = (short)sizeX;
			dataMatrix[baseIndex + BitmapMapBlob.sourceHeight] = (short)sizeY;
			dataMatrix[baseIndex + BitmapMapBlob.publicSizeX] = (short)sizeX;
			dataMatrix[baseIndex + BitmapMapBlob.publicSizeY] = (short)sizeY;
			dataMatrix[baseIndex + BitmapMapBlob.offsetX] = (short)0;
			dataMatrix[baseIndex + BitmapMapBlob.offsetY] = (short)0;

			bitmapIndex++;
		}
	}

}


public void OnSerialize (Package p) {

	(mBlob)= mBlob.Cast((p).SerializePointer((mBlob).typeNumber, (mBlob).supportsDynamicSerialization, false), null);
    (mReferenceBitmap)= mReferenceBitmap.Cast((p).SerializePointer((mReferenceBitmap).typeNumber, (mReferenceBitmap).supportsDynamicSerialization, false), null);

}


public void SetReferenceBitmap (Bitmap bitmap) {
	
	mReferenceBitmap = bitmap;	

}


public Bitmap GetReferenceBitmap() {
 return mReferenceBitmap; 
}


public short[] GetDataMatrix() {
 return  mBlob.mDataMatrix; 
}


public void SetBitmapMapBlob (BitmapMapBlob blob) {



mBlob = blob;

}


public Bitmap mReferenceBitmap;
public BitmapMapBlob mBlob;

/* One dimension array */
public static BitmapMap[] InstArrayBitmapMap(int size) {
	BitmapMap[] newArray = new BitmapMap[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new BitmapMap();
	return newArray; }

/* Two dimension array */
public static BitmapMap[][] InstArrayBitmapMap(int size1, int size2) {
	BitmapMap[][] newArray = new BitmapMap[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new BitmapMap[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new BitmapMap(); }
	return newArray; }

/* Three dimension array */
public static BitmapMap[][][] InstArrayBitmapMap(int size1, int size2, int size3) {
	BitmapMap[][][] newArray = new BitmapMap[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new BitmapMap[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new BitmapMap[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new BitmapMap(); } }
	return newArray; }



}

