package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class BitmapMapBlob {

public static BitmapMapBlob Cast(Object o, BitmapMapBlob _) {
 return  (BitmapMapBlob)o; 
}


 final public static byte typeNumber = TypeIDOfType_BitmapMapBlob.v;
 final public static byte typeID = TypeIDOfType_BitmapMapBlob.w;
 public static final boolean supportsDynamicSerialization = false; public final static byte publicSizeX = 6;
public final static byte publicSizeY = 7;
public final static byte offsetX = 4;
public final static byte offsetY = 5;
public final static byte sourceWidth = 2;
public final static byte sourceHeight = 3;
public final static byte sourceLeft = 0;
public final static byte sourceTop = 1;

public BitmapMapBlob () {


}


public void destruct() {

	mDataMatrix = null;

}


public BitmapMapBlob (int bitmapCount) {



mDataMatrix = new short[bitmapCount << 3];

}


public BitmapMapBlob ( BitmapMapBlob original) {



if(original.mDataMatrix != null)
	{

		
		int arraySize = original.mDataMatrix.length;
		


mDataMatrix = new short[arraySize];
		Memory.Copy(mDataMatrix, original.mDataMatrix, arraySize);
	}
	else
	{
		mDataMatrix = null;
	}

}


public void SetFrameData (int frameIndex, short framePublicSizeX, short framePublicSizeY, short frameOffsetX, short frameOffsetY, short frameWidth, short frameHeight, short frameLeft, short frameTop) {
	
	 short[] dataMatrix = mDataMatrix;

	 int baseIndex = (frameIndex << 3);

	dataMatrix[baseIndex + publicSizeX] = framePublicSizeX;
	dataMatrix[baseIndex + publicSizeY] = framePublicSizeY;
	dataMatrix[baseIndex + offsetX] = frameOffsetX;
	dataMatrix[baseIndex + offsetY] = frameOffsetY;
	dataMatrix[baseIndex + sourceWidth] = frameWidth;
	dataMatrix[baseIndex + sourceHeight] = frameHeight;
	dataMatrix[baseIndex + sourceLeft] = frameLeft;
	dataMatrix[baseIndex + sourceTop] = frameTop;

}


public int GetBitmapCount () {


	
	return mDataMatrix.length >> 3;
	



}


public BitmapMapBlob OnSerialize (Package p) {


	 short mBitmapCount = 0;
 
(mBitmapCount)= (p).SerializeIntrinsic(mBitmapCount);








{

		(mDataMatrix)= (p).SerializeIntrinsics(mDataMatrix, mBitmapCount << 3);

	}
	return  this;

}


public short[] mDataMatrix = null;

/* One dimension array */
public static BitmapMapBlob[] InstArrayBitmapMapBlob(int size) {
	BitmapMapBlob[] newArray = new BitmapMapBlob[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new BitmapMapBlob();
	return newArray; }

/* Two dimension array */
public static BitmapMapBlob[][] InstArrayBitmapMapBlob(int size1, int size2) {
	BitmapMapBlob[][] newArray = new BitmapMapBlob[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new BitmapMapBlob[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new BitmapMapBlob(); }
	return newArray; }

/* Three dimension array */
public static BitmapMapBlob[][][] InstArrayBitmapMapBlob(int size1, int size2, int size3) {
	BitmapMapBlob[][][] newArray = new BitmapMapBlob[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new BitmapMapBlob[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new BitmapMapBlob[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new BitmapMapBlob(); } }
	return newArray; }



}

