package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class Button extends BaseButton {

public static Button Cast(Object o, Button _) {
 return  (Button)o; 
}


 final public static byte typeNumber = TypeIDOfType_Button.v;
 final public static byte typeID = TypeIDOfType_Button.w;
 public static final boolean supportsDynamicSerialization = true; public byte GetTypeID() {
 return  typeID; 
}


public static Class AsClass() {
 return  null; 
}


public Button () {
mStateImage = new BitmapMap();


}


public  Button (Viewport viewport) {
super(viewport);
mStateImage = new BitmapMap();



}


public  Button (Viewport viewport, short rect_left, short rect_top, short rect_width, short rect_height, String caption, Font buttonFont, Bitmap inBitmap, int stateFlags) {
super(viewport, caption, buttonFont, stateFlags);
mStateImage = new BitmapMap();


	 BitmapMapBlob blob = new BitmapMapBlob((short)mStateCount);
	mStateImage.SetBitmapMapBlob(blob);

	if(inBitmap != null)
	{
		SetBitmap(inBitmap);
	}

	SetRect(rect_left, rect_top, rect_width, rect_height);

}


public void SetBitmap (Bitmap image) {

	mStateImage.SetReferenceBitmap(image);	
	mStateImage.SetAsGrid((short)1, mStateCount);
	Invalidate();

}


public Bitmap GetBitmap () {

	return mStateImage.GetReferenceBitmap();

}


public void OnDraw (DisplayContext displayContext) {
	


	if(mStateImage.GetReferenceBitmap() != null)
	{
		 int stateBitmapIndex = mStateMap[mState];


		if(stateBitmapIndex == -1)
		{
			stateBitmapIndex = mStateMap[ButtonState.STATE_NORMAL];
		}

		if(stateBitmapIndex != -1)
		{			
			mStateImage.DrawElementAt(stateBitmapIndex, displayContext, mRect_left, mRect_top, mStateImage.GetPublicSizeXAt(stateBitmapIndex), mStateImage.GetPublicSizeYAt(stateBitmapIndex), mOpacity[mStateIndex], false, false);
		}
	}

	super.OnDraw(displayContext);

}


public void OnSerialize (Package p) {

    super.OnSerialize(p);
    (mStateImage).OnSerialize(p);

    int i;

    for(i = 0;i < ButtonState.STATE_TOTAL;i ++)
    {
        (mStateMap[i])= (p).SerializeIntrinsic(mStateMap[i]);
    }

	(mStateCount)= (p).SerializeIntrinsic(mStateCount);
	if(p.IsReading())
	{
		CreateArrays();
	}
	for(i = 0;i < mStateCount;i ++)
	{
		(mFonts[i])= mFonts[i].Cast((p).SerializePointer((mFonts[i]).typeNumber, (mFonts[i]).supportsDynamicSerialization, false), null);
		 byte alignment = (byte)mAligns[i];

		(alignment)= (p).SerializeIntrinsic(alignment);
		mAligns[i] = (byte)alignment;
	}

    (mTextCaption)= mTextCaption.Cast((p).SerializePointer((mTextCaption).typeNumber, (mTextCaption).supportsDynamicSerialization, false), null);
	 int state = mState;

    (state)= (p).SerializeIntrinsic(state);
	mState = (int)state;

}


public BitmapMap mStateImage;

/* One dimension array */
public static Button[] InstArrayButton(int size) {
	Button[] newArray = new Button[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new Button();
	return newArray; }

/* Two dimension array */
public static Button[][] InstArrayButton(int size1, int size2) {
	Button[][] newArray = new Button[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Button[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new Button(); }
	return newArray; }

/* Three dimension array */
public static Button[][][] InstArrayButton(int size1, int size2, int size3) {
	Button[][][] newArray = new Button[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Button[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new Button[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new Button(); } }
	return newArray; }



}

