package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class Characters {

public final static byte space = (byte)' ';
public final static byte tabulation = (byte)'\t';
public final static byte endOfString = (byte)'\u0000';
public final static byte hardReturn = (byte)'\r';
public final static byte carriageReturn = (byte)'\r';
public final static byte lineFeed = (byte)'\n';
public final static byte pageBreak = (byte)'\u000C';
public final static byte optionalWordBreak = (byte)'\u001F';
public final static byte softHyphenChar = (byte)'\u00AD';
public final static byte zeroWidthSpace = (byte)'\u001D';
public final static byte nonBreakingSpace = (byte)'\u00A0'	;

public final static short typeInfoCanWrapBefore = 0x0002;
public final static short typeInfoCanWrapAfter = 0x0004;
public final static short typeInfoIsWordSeparator = 0x0008;
public final static short typeInfoIsLineSeparator = 0x0010;
public final static short typeInfoIsOptionalWordBreak = 0x0020;
public final static short typeInfoIsFullwidth = 0x0040;
public final static short typeInfoIsAlphabet = 0x0080;
public final static short typeInfoIsAsianCharacter = 0x0100;
public final static short typeInfoIsLetter = 0x0200;
public final static short typeInfoIsNumber = 0x0400;
public final static short typeInfoIsSymbol = 0x0800;

public final static int typeOptionalWordBreak = typeInfoIsOptionalWordBreak;
public final static int typeWordSeparator = typeInfoIsWordSeparator | typeInfoCanWrapBefore | typeInfoCanWrapAfter;
public final static int typeCarriageReturn = typeWordSeparator | typeInfoIsLineSeparator;
public final static int typeLineSeparator = typeWordSeparator | typeInfoIsLineSeparator;
public final static int typeEndOfString = typeInfoIsWordSeparator | typeInfoCanWrapBefore | typeInfoCanWrapAfter;
public final static int typeAlphabetLetter = typeInfoIsAlphabet | typeInfoIsLetter | typeInfoCanWrapAfter;
public final static int typeAlphabetNumber = typeInfoIsAlphabet | typeInfoIsNumber | typeInfoCanWrapAfter;
public final static int typeAlphabetSymbol = typeInfoIsAlphabet | typeInfoIsSymbol | typeInfoCanWrapAfter;
public final static int typeFullwidthAlphabetLetter = typeInfoIsAlphabet | typeInfoIsLetter | typeInfoCanWrapBefore | typeInfoCanWrapAfter;
public final static int typeFullwidthAlphabetNumber = typeInfoIsAlphabet | typeInfoIsNumber | typeInfoCanWrapBefore | typeInfoCanWrapAfter;
public final static int typeFullwidthAlphabetSymbol = typeInfoIsAlphabet | typeInfoIsSymbol | typeInfoCanWrapBefore | typeInfoCanWrapAfter;
public final static int typeFullwidthPunctuation = typeInfoIsAlphabet | typeInfoIsSymbol | typeInfoCanWrapAfter;
public final static int typeThaiConsonant = typeInfoCanWrapBefore | typeInfoCanWrapAfter;
public final static int typeThaiLeadingVowel = typeInfoCanWrapBefore | typeInfoCanWrapAfter;
public final static int typeThaiFollowingVowel = typeInfoCanWrapBefore | typeInfoCanWrapAfter;
public final static int typeThaiBelowVowel = typeInfoCanWrapAfter;
public final static int typeThaiAboveVowel = typeInfoCanWrapAfter;
public final static int typeThaiTonemark = typeInfoCanWrapAfter;
public final static int typeThaiAboveDiacritic = typeInfoCanWrapAfter;
public final static int typeThaiBelowDiacritic = typeInfoCanWrapAfter;
public final static int typeThaiDigit = typeInfoIsNumber | typeInfoCanWrapBefore | typeInfoCanWrapAfter;
public final static int typeThaiSpecialCharacter = typeInfoCanWrapBefore | typeInfoCanWrapAfter;
public final static int typeAsianCharacter = typeInfoIsAsianCharacter | typeInfoCanWrapAfter;
public final static int typeHalfWidthAsianCharacter = typeAsianCharacter;
public final static int typeFullWidthAsianCharacter = typeAsianCharacter | typeInfoIsFullwidth;
public final static int typeAsianPunctuation = typeFullWidthAsianCharacter;
public final static int typeAsianIdeogram = typeFullWidthAsianCharacter | typeInfoCanWrapBefore | typeInfoCanWrapAfter;
public final static int typeChineseHanzi = typeAsianIdeogram;
public final static int typeJapaneseKanji = typeAsianIdeogram;
public final static int typeJapaneseHiragana = typeAsianIdeogram;
public final static int typeJapaneseKatakana = typeAsianIdeogram;
public final static int typeJapaneseHalfWidthKatakana = typeHalfWidthAsianCharacter	;

public static int GetCharType (byte cAsChar) {

	int returnValue;


	
	 int c = CharToInt(cAsChar);





if(cAsChar == endOfString)
	{
		returnValue = typeEndOfString;
	}
	else if (	cAsChar == space ||

			cAsChar == zeroWidthSpace ||
			cAsChar == softHyphenChar ||
cAsChar == tabulation)
	{
		returnValue = typeWordSeparator;
	}
	else if (cAsChar == hardReturn ||
			cAsChar == lineFeed ||
			cAsChar == carriageReturn)
	{
		returnValue = typeLineSeparator;
	}

	else if(cAsChar == optionalWordBreak)
	{
		returnValue = typeOptionalWordBreak;
	}
else if(cAsChar == carriageReturn)
	{
		returnValue = typeCarriageReturn;
	}

	
	
	
	

	
	
	
	
	
	
	
	
	

	else if(c <= '/') returnValue = typeAlphabetSymbol;
	else if(c <= '9') returnValue = typeAlphabetNumber;
	else if(c <= '@') returnValue = typeAlphabetSymbol;
	else if(c <= 'Z') returnValue = typeAlphabetLetter;
	else if(c <= '`') returnValue = typeAlphabetSymbol;
	else if(c <= 'z') returnValue = typeAlphabetLetter;

	
	
	else if(c <= 0xBF) returnValue = typeAlphabetSymbol;

	
	
	
	else if(c <= 0xFF) returnValue = typeAlphabetLetter;

	
	
	








































































































































































else
	{

		returnValue = typeAlphabetSymbol; 
	}

	return  returnValue;



}


public static boolean CanWrapAfter (int characterType) {

	return  TypesFlagAndTest(characterType, typeInfoCanWrapAfter);

}


public static boolean CanWrapBefore (int characterType) {

	return  TypesFlagAndTest(characterType, typeInfoCanWrapBefore);

}


public static boolean IsOptionalWordBreak (int characterType) {

	return  TypesFlagAndTest(characterType, typeInfoIsOptionalWordBreak);

}


public static boolean IsWordSeparator (int characterType) {

	return  TypesFlagAndTest(characterType, typeInfoIsWordSeparator);

}


public static boolean IsLineSeparator (int characterType) {

	return  TypesFlagAndTest(characterType, typeInfoIsLineSeparator);

}


public static int CharToInt (byte c) {



return  c & 0xFF;

}


public static boolean TypesFlagAndTest (int characterType, int flags) {

	return  0!= (characterType & flags);

}


public static boolean TypesFlagOrTest (int characterType, int flags) {

	return  0!= (characterType | flags);

}



/* One dimension array */
public static Characters[] InstArrayCharacters(int size) {
	Characters[] newArray = new Characters[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new Characters();
	return newArray; }

/* Two dimension array */
public static Characters[][] InstArrayCharacters(int size1, int size2) {
	Characters[][] newArray = new Characters[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Characters[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new Characters(); }
	return newArray; }

/* Three dimension array */
public static Characters[][][] InstArrayCharacters(int size1, int size2, int size3) {
	Characters[][][] newArray = new Characters[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Characters[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new Characters[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new Characters(); } }
	return newArray; }

public Characters () { 
}




}

