package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public abstract class Component extends TimeControlled {

public static Component Cast(Object o, Component _) {
 return  (Component)o; 
}


 final public static byte typeNumber = TypeIDOfType_Component.v;
 final public static byte typeID = TypeIDOfType_Component.w;
 public static final boolean supportsDynamicSerialization = true; public byte GetTypeID() {
 return  typeID; 
}


public static Class AsClass() {
 return  null; 
}


public final static byte focusMsg = -128;
public final static byte selectedMsg = -127;
public final static byte enabledMsg = -126;
public final static byte pushedMsg = -125;
public final static byte synchronizeSelectorMsg = -124;
public final static byte buttonMsg = -123;
public final static byte attachMsg = -122;
public final static byte keyUpMsg = -121;
public final static byte keyDownMsg = -120;
public final static byte keyDownOrRepeatMsg = -119;
public final static byte penUpMsg = -118;
public final static byte penDownMsg = -117;
public final static byte penDragMsg = -116;
public final static byte penDragOutMsg = -115;
public final static byte penMgrDeactivatedMsg = -114;
public final static byte returnedFromSceneMsg = -113;
public final static byte startTransitionMsg = -112;
public final static byte completedTransitionMsg = -111;
public final static byte quitTransitionMsg = -110;
public final static byte resetAncestorScrollerMsg = -109;
public final static byte slideMsg = -108;
public final static byte slideStateMsg = -107;
public final static byte scrollerUpdatedMsg = -106;
public final static byte textFieldInputMsg = -105;
public final static byte quitRequestMsg = -104;
public final static byte reservedMsg = 0;
public final static byte firstApplicationMsg = 1;

public final static byte isDetached = 0;
public final static byte isAttached = 1;

public final static byte isLeaving = 0;
public final static byte isEntering = 1;

public  Component () {
mVisible = (true);
mPassThrough = (true);


	


}


public  Component (Viewport viewport) {
mVisible = (true);
mPassThrough = (true);


	

SetViewport(viewport);
	
	


}


public void destruct() {







if(IsTrackingPen()) ReleasePen();
	if(m_pViewport != null)
	{
		SetViewport(null);
	}

}


public void SetViewport (Viewport newViewport) {

	 Viewport oldViewport = m_pViewport;
	if(oldViewport != null)
	{
		UpdateAttach(false);
		oldViewport.RemoveChild(this);
	}

	m_pViewport = newViewport;

	if(newViewport != null)
	{
		newViewport.AddChild(this);
		UpdateAttach(true);
	}

}


public Viewport GetViewport() {
 return  m_pViewport; 
}


public void TakeFocus () {

	Application.GetInstance().SetCurrentFocus(this);

}


public void OnFocusChange (boolean entering) {

	SendMsg(this, focusMsg, entering ? isEntering : isLeaving);

}


public Component ForwardFocus() {
 return  this; 
}


public boolean DescendentOrSelfHasFocus () {

	 Component component = Application.GetInstance().GetCurrentFocus();
	return  IsSelfOrAncestorOf(component);

}


public boolean IsSelfOrAncestorOf (Component component) {

	while(component != null)
	{
		if(component == this) return  true;
		component = component.GetViewport();
	}
	return  false;

}


public int GetDepth () {

	 Component component = this;
	 int depth = 0;

	do {depth++;
		component = component.GetViewport();} while (component != null);
	
	return  depth;

}


public void SendMsg (Component source, int msg, int intParam) {

	 Component handler = this;
	do
	{
		if(handler.OnMsg(source, msg, intParam)) return ;        
		if(handler.OnDefaultMsg(source, msg, intParam)) return ; 
		handler = handler.GetViewport();
	}
	while(handler != null);

}


public boolean OnMsg(Component source, int msg, int intParam) {
 ; ; ; return  false; 
}


public boolean OnDefaultMsg(Component source, int msg, int intParam) {
 ; ; ; return  false; 
}


public void SetRect (short rect_left, short rect_top, short rect_width, short rect_height) {

	Invalidate();
	mRect_left = rect_left; mRect_top = rect_top; mRect_width = rect_width; mRect_height = rect_height;;
	OnRectChange();
	Invalidate();

}


public short GetRectLeft() {
 return  mRect_left; 
}


public short GetRectTop() {
 return  mRect_top; 
}


public short GetRectWidth() {
 return  mRect_width; 
}


public short GetRectHeight() {
 return  mRect_height; 
}


public void SetRect(FlRect r) {
 SetRect(r.GetLeft(), r.GetTop(), r.GetWidth(), r.GetHeight()); 
}


public FlRect GetRect() {
 return  new FlRect(mRect_left, mRect_top, mRect_width, mRect_height); 
}


public void SetTopLeft(Vector2_short topLeft) {
 SetTopLeft(topLeft.GetX(), topLeft.GetY()); 
}


public Vector2_short GetSize() {
 return  new Vector2_short(GetRectWidth(), GetRectHeight()); 
}


public void SetSize(Vector2_short size) {
 SetSize(size.GetX(), size.GetY()); 
}


public Vector2_short GetTopLeft() {
 return  new Vector2_short(GetRectLeft(), GetRectTop()); 
}


public Vector2_short GetAbsoluteTopLeft() {
 return  new Vector2_short(GetAbsoluteLeft(), GetAbsoluteTop()); 
}


public void SetTopLeft (short left, short top) {

	Invalidate();
	mRect_left = left;
	mRect_top = top;
	OnRectChange();
	Invalidate();

}


public short GetAbsoluteTop () {

	 Viewport viewport = m_pViewport;
	if(viewport != null)
	{
		return  (short)(mRect_top + viewport.GetAbsoluteTop() - viewport.GetOffsetY());
	}
	else
	{
		return  mRect_top;
	}

}


public short GetAbsoluteLeft () {

	 Viewport viewport = m_pViewport;
	if(viewport != null)
	{
		return  (short)(mRect_left + viewport.GetAbsoluteLeft() - viewport.GetOffsetX());
	}
	else
	{
		return   mRect_left;
	}

}


public Vector2_short GetRelativeCoord ( Vector2_short absoluteCoord) {

	 int relativeX = absoluteCoord.GetX();

	 int relativeY = absoluteCoord.GetY();


	 Viewport viewport = GetViewport();
	while(viewport != null)
	{
		relativeX = relativeX - viewport.GetRectLeft() + viewport.GetOffsetX();
		relativeY = relativeY - viewport.GetRectTop() + viewport.GetOffsetY();
		viewport = viewport.GetViewport();
	}

	return  new Vector2_short((short)(relativeX - mRect_left), (short)(relativeY - mRect_top));

}


public void SetCenter (short x, short y) {

	Invalidate();
	mRect_left = (short)(x - mRect_width / 2); mRect_top = (short)(y - mRect_height / 2);
	OnRectChange();
	Invalidate();

}


public void SetBottomRight (short right, short bottom) {

	Invalidate();
	mRect_width = (short)(right + 1- mRect_left); mRect_height = (short)(bottom + 1- mRect_top);;
	OnRectChange();
	Invalidate();

}


public short GetBottom () {
	
	return  (short)(mRect_top + mRect_height - 1);

}


public short GetRight () {

	return  (short)(mRect_left + mRect_width - 1);

}


public void CenterInRect (short rect_left, short rect_top, short rect_width, short rect_height) {

	mRect_left = (short)(rect_left + ((rect_width - mRect_width) >> 1));
	mRect_top = (short)(rect_top + ((rect_height - mRect_height) >> 1));

}


public void SetSize (short width, short height) {

	Invalidate();
	mRect_width = width; mRect_height = height;;
	OnRectChange();
	Invalidate();

}


public void SetVisible (boolean visible) {

	if(mVisible != visible)
	{
		mVisible = visible;
		OnVisibilityChange();
		Invalidate();
	}

}


public boolean IsVisible() {
 return  mVisible; 
}


public boolean IsGloballyVisible () {

	 Viewport viewport = m_pViewport;
	if(viewport != null)
	{
		return  IsVisible() && viewport.IsGloballyVisible();
	}

	return  IsVisible();

}


public Component GetPreviousSiblingComponent() {
 return  m_pPreviousSibling; 
}


public void BringToFront () {


	m_pViewport.BringComponentToFront(this);
	Invalidate();

}


public void SendToBack () {


	m_pViewport.SendComponentToBack(this);
	Invalidate();

}


public void PutBehind (Component inCompoment) {


	m_pViewport.PutComponentBehind(this, inCompoment);
	Invalidate();

}


public void PutInFront (Component inCompoment) {


	m_pViewport.PutComponentInFront(this, inCompoment);
	Invalidate();

}


public boolean IsAttached () {

	
	
	
	 Component parent = this;
	 Component ancestor = null;
	do
	{
		ancestor = parent;
		parent = ancestor.GetViewport();
	}
	while(parent != null);
	
	return  (ancestor == (Application.GetInstance()));

}


public void OnAttach (boolean attach) {

	if(!attach)
	{
		
		 Application application = Application.GetInstance();
		if(application.GetCurrentFocus() == this) application.TakeFocus();
	}

}


public void Invalidate () {

	
		DisplayManager.GetMainDisplayContext().AddDirtyComponent(this);
	


}


public abstract void OnDraw(DisplayContext a19);



public boolean IsPassThrough() {
 return  mPassThrough ? true : false; 
}


public void SetPassThrough (boolean inIsPassThrough) {

		mPassThrough = inIsPassThrough;
	
}


public Component GetHitTestComponent (short ptX, short ptY) {

	if(!IsPassThrough() && IsVisible() && HitTest(ptX, ptY))
	{
		return  this;
	}
	
	return  null;

}


public void OnMouseRightDown ( Vector2_short a17) {


}


public void OnMouseOver () {


}


public void OnMouseOut () {


}


public void OnMouseRightUp ( Vector2_short a18) {


}


public void OnMouseRightDrag ( Vector2_short a19) {


}


public boolean IsTrackingPen () {

	
		return  (FrameworkGlobals.GetInstance().penTracker == this);
	


}


public boolean IsTrackingMouse () {

	

return  false;
	
}


public void OnSerialize (Package p) {

	(mRect_left)= (p).SerializeIntrinsic(mRect_left); (mRect_top)= (p).SerializeIntrinsic(mRect_top); (mRect_width)= (p).SerializeIntrinsic(mRect_width); (mRect_height)= (p).SerializeIntrinsic(mRect_height);;

     byte members = 0;

	






{
        (members)= (p).SerializeIntrinsic(members);
		mVisible = (members & 0x1) != 0;
		
			mPassThrough = (members & 0x2) != 0;
		}

}


public void ControlValue (int valueControlCode, boolean setValue, Controller controller) {
	
	if(setValue)
	{
		 short coordValueX = 0;

		 short coordValueY = 0;

		if (valueControlCode == componentPosition ||
			valueControlCode == componentSize ||
			valueControlCode == componentSizeCentered)
		{
			coordValueX = controller.GetCoord2ValueX();
			coordValueY = controller.GetCoord2ValueY();
		}

		switch(valueControlCode)
		{
		case componentPosition : 
			{
				SetTopLeft(coordValueX, coordValueY);
			}
			return ;
		case componentSize : 
			{
				SetSize(coordValueX, coordValueY);
			}
			return ;
		case componentSizeCentered : 
			{
				
				 short left = (short)(GetRectLeft() + (GetRectWidth() >> 1) - (coordValueX >> 1));

				 short top = (short)(GetRectTop() + (GetRectHeight() >> 1) - (coordValueY >> 1));

				SetRect(left, top, coordValueX, coordValueY);				
			}
			return ;
		case componentRect : 
			{
				 FlRect r = controller.GetRectValue();
				SetRect(r.GetLeft(), r.GetTop(), r.GetWidth(), r.GetHeight());
			}
			return ;
		case componentVisibility :
			{
				SetVisible(controller.GetBoolValue());
			}
			return ;
		}
	}
	else
	{
		switch(valueControlCode)
		{
		case componentPosition : 
			{
				controller.SetValue(mRect_left, mRect_top);
			}
			return ;
		case componentSize : 
		case componentSizeCentered : 
			{
				controller.SetValue(mRect_width, mRect_height);
			}
			return ;
		case componentRect : 
			{
				controller.SetValue(mRect_left, mRect_top, mRect_width, mRect_height);
			}
			return ;
		case componentVisibility :
			{
				controller.SetValue(IsVisible());
			}
			return ;
		}
	}

	super.ControlValue(valueControlCode, setValue, controller);

}


public void ResetAncestorScroller () {

	SendMsg(this, resetAncestorScrollerMsg, 0);

}


public void TrackPen () {

	

		FrameworkGlobals.GetInstance().penTracker = this;
		



}


public void ReleasePen () {

	

		FrameworkGlobals.GetInstance().penTracker = FrameworkGlobals.GetInstance().application;
		



}


public void TrackMouse () {

	


}


public void ReleaseMouse () {

	


}


public boolean HitTest (short ptX, short ptY) {

	
	return  FlRect.Contains(mRect_left, mRect_top, mRect_width, mRect_height, ptX, ptY);

}


public void OnVisibilityChange () {


}


public void OnRectChange () {

	


}


public short mRect_left;
public short mRect_top;
public short mRect_width;
public short mRect_height;
public void UpdateAttach (boolean attach) {

	
	if(IsAttached())
	{
		Invalidate();
		OnAttach(attach);
	}

}


public Viewport m_pViewport;
public boolean mVisible;
public boolean mPassThrough;
public Component m_pPreviousSibling;



}

