package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public abstract class DisplayContext {

public final static byte resolutionPortrait = 0;
public final static byte resolutionLandscape = 1;
public final static byte resolutionCount = 2;
public final static byte resolutionInvalid = 3;

public  DisplayContext ( VideoMode mode) {
mDirtyRectIndex = (-1);
mDirtyRectsEnabled = (true);
mVideoMode = new VideoMode(mode);
mScreenRect = new FlRect((short)0, (short)0, (short)mode.GetWidth(), (short)mode.GetHeight());




mDirtyRectMergePixelThreshold = mode.GetWidth();
	
	



}


public void destruct() {




}


public void DrawString ( String string, short rect_left, short rect_top, short rect_width, short rect_height, Font font, byte alignment, int startIndex, int nChars, short lineWidth, short opacity) {



	if(string.GetCharAt(startIndex) == 0)
	{

		return ;
	}





 short clippedRect_left = (short)(rect_left + mCumulativeOffsetX);
  short clippedRect_top = (short)(rect_top + mCumulativeOffsetY);
  short clippedRect_width = rect_width;
  short clippedRect_height = rect_height;

 short clipRect_left = mClipRect_left;
  short clipRect_top = mClipRect_top;
  short clipRect_width = mClipRect_width;
  short clipRect_height = mClipRect_height;


	if(FlRect.Contains(clipRect_left, clipRect_top, clipRect_width, clipRect_height, clippedRect_left, clippedRect_top, clippedRect_width, clippedRect_height))
	{
		mBypassClipping = true;
	}
	else if(!FlRect.Intersects(clipRect_left, clipRect_top, clipRect_width, clipRect_height, clippedRect_left, clippedRect_top, clippedRect_width, clippedRect_height))
	{

		return ;
	}

	 int offsetSizeX = Alignment.GetOffsetX(alignment, rect_width, (short)lineWidth);




font.DrawString(this, string, (short)(rect_left + offsetSizeX), rect_top, lineWidth, startIndex, nChars, opacity);

	mBypassClipping = false;



}


public void DrawMultilineString ( String string, int [] lines, int totalLineCount, short textBoxRect_left, short textBoxRect_top, short textBoxRect_width, short textBoxRect_height, int topLine, Font font, byte alignment, short [] linesWidth, short opacity) {

	if(font == null)
	{
		return ;
	}

	 int interlinedHeight = font.GetLineHeight();

	 int fontHeight = interlinedHeight - font.GetLeading();


	 short dcTextBoxRect_left = textBoxRect_left;
  short dcTextBoxRect_top = textBoxRect_top;
  short dcTextBoxRect_width = textBoxRect_width;
  short dcTextBoxRect_height = textBoxRect_height;
 	
	dcTextBoxRect_left = (short)(dcTextBoxRect_left + mCumulativeOffsetX);

		
		
		 short yOffset = mCumulativeOffsetY;

	dcTextBoxRect_top = (short)(dcTextBoxRect_top + yOffset);;

	 boolean canBypassHorizClipping = ((dcTextBoxRect_left >= mClipRect_left) && ((short)(dcTextBoxRect_left + dcTextBoxRect_width - 1) <= (short)(mClipRect_left + mClipRect_width - 1)));


	 int dcClipRectTop = mClipRect_top;

	 int dcClipRectBottom = (short)(mClipRect_top + mClipRect_height - 1);

	 int dcTextBoxRectTop = dcTextBoxRect_top;

	 int dcTextBoxRectBottom = (short)(dcTextBoxRect_top + dcTextBoxRect_height - 1);


	 int flushedTopSpace = dcClipRectTop - dcTextBoxRectTop;
		
	 int myFirstLineToDraw = topLine;

	 int firstPixelToDraw = dcTextBoxRectTop;


	if(flushedTopSpace > 0)
	{
		firstPixelToDraw += flushedTopSpace;

		if(flushedTopSpace > fontHeight)
		{
			myFirstLineToDraw++;
			flushedTopSpace -= fontHeight;


			myFirstLineToDraw += flushedTopSpace / (interlinedHeight);

			fontHeight = interlinedHeight;
		}
	}

	if(myFirstLineToDraw > totalLineCount - 1)
	{
		return ;
	}

	 int lastPixelToDraw = dcTextBoxRectBottom;

	if(lastPixelToDraw > dcClipRectBottom)
	{
		lastPixelToDraw = dcClipRectBottom;
	}

	 int linesYOffset = ((myFirstLineToDraw - topLine) * interlinedHeight);


	 short posX = (short)0;

	 short posY = (short)(dcTextBoxRect_top - mCumulativeOffsetY + linesYOffset);


	
	firstPixelToDraw -= yOffset;
	lastPixelToDraw -= yOffset;

	 int cLine = myFirstLineToDraw;

	 int cPixel = textBoxRect_top + linesYOffset;

	 int nextPixel = cPixel + fontHeight;

	 int nChars = 0;

	 int start = 0;

	 int textBoxRectLeft = textBoxRect_left;


	fontHeight = interlinedHeight;

	do
	{
		mBypassClipping = (canBypassHorizClipping && cPixel >= firstPixelToDraw && nextPixel - 1<= lastPixelToDraw);

		start = ((lines[cLine])& 0xFFFF);
		nChars = ((int)(lines[cLine]) >> 16) - start + 1;
		posX = (short)(textBoxRectLeft + Alignment.GetOffsetX(alignment, textBoxRect_width, linesWidth[cLine]));



font.DrawString(this, string, posX, posY, linesWidth[cLine], start, nChars, opacity);

		posY = (short)(posY + fontHeight);
		cLine++;
		cPixel = nextPixel;
		nextPixel = cPixel + fontHeight;
	}
	while(cLine < totalLineCount && cPixel <= lastPixelToDraw);

	mBypassClipping = false;

}


public abstract void DrawFrame(short a14, short a13, short a12, short a11, Color888 a10, short a9);



public abstract void DrawRectangle(short a23, short a22, short a21, short a20, boolean a19, int a18, int a17, int a16, short a15);



public void DrawAbsoluteSolidRectangle (short rect_left, short rect_top, short rect_width, short rect_height, int colorRed, int colorGreen, int colorBlue, short opacity) {

	
	DrawRectangle((short)(rect_left - mCumulativeOffsetX), (short)(rect_top - mCumulativeOffsetY), (short)rect_width, (short)rect_height, true, colorRed, colorGreen, colorBlue, opacity);

}


public abstract void DrawLine(short a29, short a28, short a27, short a26, Color888 a25, short a24);



public abstract void DrawPixel(short a32, short a31, Color888 a30);



public abstract void DrawCircle(Vector2_short a37, short a36, boolean a35, Color888 a34, Color888 a33);



public abstract void DrawArc(Vector2_short a41, short a40, short a39, short a38);



public abstract void Clear(Color888 a42);



public abstract void ClearFullscreen(Color888 a43);



public void DrawBitmapSection ( Bitmap bitmap, short posX, short posY, short sourceRect_left, short sourceRect_top, short sourceRect_width, short sourceRect_height, short opacity) {


	 short destLeft = (short)(posX + mCumulativeOffsetX);

	 short destTop = (short)(posY + mCumulativeOffsetY);


	 short clippedRect_left = destLeft;
  short clippedRect_top = destTop;
  short clippedRect_width = sourceRect_width;
  short clippedRect_height = sourceRect_height;


	if(!mBypassClipping)
	{
		 short clipRect_left = mClipRect_left;
  short clipRect_top = mClipRect_top;
  short clipRect_width = mClipRect_width;
  short clipRect_height = mClipRect_height;

		{  int clipperRight = (clipRect_left + clipRect_width);
  int clippedRight = (clippedRect_left + clippedRect_width);
  int clipperBottom = (clipRect_top + clipRect_height);
  int clippedBottom = (clippedRect_top + clippedRect_height);
 if(clipRect_left > clippedRect_left) clippedRect_left = clipRect_left; if(clipRect_top > clippedRect_top) clippedRect_top = clipRect_top; if(clipperRight < clippedRight) clippedRight = clipperRight; if(clipperBottom < clippedBottom) clippedBottom = clipperBottom; clippedRect_width = (short)(clippedRight - clippedRect_left); clippedRect_height = (short)(clippedBottom - clippedRect_top); };
	}








if((clippedRect_width <= 0|| clippedRect_height <= 0))
	{

		return ;
	}

	 short destClippedRect_left = clippedRect_left;
  short destClippedRect_top = clippedRect_top;
  short destClippedRect_width = clippedRect_width;
  short destClippedRect_height = clippedRect_height;


	 int sourceClippedLeft = sourceRect_left;

	 int sourceClippedTop = sourceRect_top;


	 byte transform = BitmapTransform.Identity;
















{
		sourceClippedLeft += destClippedRect_left - destLeft;
	}















{
		sourceClippedTop += destClippedRect_top - destTop;
	}

	 Bitmap absBitmap = bitmap;
























DrawAbsoluteBitmapSection(absBitmap, destClippedRect_left, destClippedRect_top, sourceClippedLeft, sourceClippedTop, destClippedRect_width, destClippedRect_height, transform, opacity);


}


public void DrawTiledBitmapSection ( Bitmap bitmap, short publicSourceWidth, short publicSourceHeight, short sourceOffsetX, short sourceOffsetY, short sourceRect_left, short sourceRect_top, short sourceRect_width, short sourceRect_height, short destRect_left, short destRect_top, short destRect_width, short destRect_height, short opacity) {
	

	
	 short cumulativeOffsetX = mCumulativeOffsetX;

	 short cumulativeOffsetY = mCumulativeOffsetY;


	 short offsetClippedDestRect_left = (short)(destRect_left + cumulativeOffsetX);
  short offsetClippedDestRect_top = (short)(destRect_top + cumulativeOffsetY);
  short offsetClippedDestRect_width = destRect_width;
  short offsetClippedDestRect_height = destRect_height;

{  int clipperRight = (mClipRect_left + mClipRect_width);
  int clippedRight = (offsetClippedDestRect_left + offsetClippedDestRect_width);
  int clipperBottom = (mClipRect_top + mClipRect_height);
  int clippedBottom = (offsetClippedDestRect_top + offsetClippedDestRect_height);
 if(mClipRect_left > offsetClippedDestRect_left) offsetClippedDestRect_left = mClipRect_left; if(mClipRect_top > offsetClippedDestRect_top) offsetClippedDestRect_top = mClipRect_top; if(clipperRight < clippedRight) clippedRight = clipperRight; if(clipperBottom < clippedBottom) clippedBottom = clipperBottom; offsetClippedDestRect_width = (short)(clippedRight - offsetClippedDestRect_left); offsetClippedDestRect_height = (short)(clippedBottom - offsetClippedDestRect_top); };

	if((offsetClippedDestRect_width <= 0|| offsetClippedDestRect_height <= 0))
	{

		return ;
	}

	 int clippedDestRectLeft = offsetClippedDestRect_left - cumulativeOffsetX;

	 int clippedDestRectRight = clippedDestRectLeft + offsetClippedDestRect_width;

	 int destTopIndex = offsetClippedDestRect_top - cumulativeOffsetY;

	 int clippedDestRectBottom = destTopIndex + offsetClippedDestRect_height;

	
	while(destTopIndex < clippedDestRectBottom)
	{
		
		 int tileTop = (destTopIndex - destRect_top) % publicSourceHeight;

		 int tileBottom = FlMath.Minimum((int)publicSourceHeight, clippedDestRectBottom - destTopIndex + tileTop);

		 int tileHeightToDraw = tileBottom - tileTop;

		 int destTopOffset = FlMath.Maximum(0, sourceOffsetY - tileTop);

		 int sourceTopOffset = FlMath.Maximum(0, tileTop - sourceOffsetY);

		 int sourceBottomOffset = FlMath.Minimum((int)sourceRect_height, tileBottom - sourceOffsetY);

		 int sourceHeightToDraw = FlMath.Maximum(0, sourceBottomOffset - sourceTopOffset);

		
		 int destLeftIndex = clippedDestRectLeft;

		while(destLeftIndex < clippedDestRectRight)
		{
			
			
			 int tileLeft = (destLeftIndex - destRect_left) % publicSourceWidth;

			 int tileRight = FlMath.Minimum((int)publicSourceWidth, clippedDestRectRight - destLeftIndex + tileLeft);

			 int tileWidthToDraw = tileRight - tileLeft;

			 int destLeftOffset = FlMath.Maximum(0, sourceOffsetX - tileLeft);

			 int sourceLeftOffset = FlMath.Maximum(0, tileLeft - sourceOffsetX);

			 int sourceRightOffset = FlMath.Minimum((int)sourceRect_width, tileRight - sourceOffsetX);

			 int sourceWidthToDraw = FlMath.Maximum(0, sourceRightOffset - sourceLeftOffset);


			mBypassClipping = true;

			DrawBitmapSection(bitmap, (short)(destLeftIndex + destLeftOffset), (short)(destTopIndex + destTopOffset), (short)(sourceRect_left + sourceLeftOffset), (short)(sourceRect_top + sourceTopOffset), (short)sourceWidthToDraw, (short)sourceHeightToDraw, opacity);

			destLeftIndex += tileWidthToDraw;
		}
		destTopIndex += tileHeightToDraw;
	}

	mBypassClipping = false;



}


public void DrawTiledBitmapSection(Bitmap bitmap, short sourceRect_left, short sourceRect_top, short sourceRect_width, short sourceRect_height, short destRect_left, short destRect_top, short destRect_width, short destRect_height, short opacity) {
 DrawTiledBitmapSection(bitmap, sourceRect_width, sourceRect_height, (short)0, (short)0, sourceRect_left, sourceRect_top, sourceRect_width, sourceRect_height, destRect_left, destRect_top, destRect_width, destRect_height, opacity);
	
}


public abstract void DrawAbsoluteBitmapSection(Bitmap a52, int a51, int a50, int a49, int a48, int a47, int a46, byte a45, short a44);



public void DrawAbsoluteBitmapBypassClipping ( Bitmap bitmap, int desLeft, int desTop) {

	
	DrawBitmapSection(bitmap, (short)(desLeft - mCumulativeOffsetX), (short)(desTop - mCumulativeOffsetY), (short)0, (short)0, bitmap.GetWidth(), bitmap.GetHeight(), (short)255);

}


public void DrawAbsoluteBitmap ( Bitmap bitmap, int desLeft, int desTop) {

	ResetClip();
	DrawAbsoluteBitmapBypassClipping(bitmap, desLeft, desTop);

}


public void ResetClip() {
 
}


public void OffsetBy (short inDeltax, short inDeltay) {

	ForceInline.v();

	mCumulativeOffsetX = (short)(mCumulativeOffsetX + inDeltax);
	mCumulativeOffsetY = (short)(mCumulativeOffsetY + inDeltay);

}


public boolean ApplicationIsPortrait () {

	return  IsResolution(false, resolutionPortrait);

}


public boolean ApplicationIsLandscape () {

	return  IsResolution(false, resolutionLandscape);

}


public boolean DeviceIsPortrait () {

	return  IsResolution(true, resolutionPortrait);

}


public boolean DeviceIsLandscape () {

	return  IsResolution(true, resolutionLandscape);

}


public boolean IsResolution (boolean forDevice, byte screenResolution) {

	return  (GetResolution(forDevice) == screenResolution);

}


public byte GetResolution (boolean forDevice) {




	 VideoMode videoMode = null;

	
		if(forDevice)
		{
			videoMode = DisplayManager.GetInstance().GetWindowVideoMode();
		}
		else
	{
			videoMode = GetVideoMode();
		}
if(videoMode.GetWidth() <= videoMode.GetHeight())
	{
		return  resolutionPortrait;
	}
	return  resolutionLandscape;

}


public short GetClippingRectLeft() {
 return  (short)(GetAbsoluteClippingRectLeft() - GetCumulativeOffsetX()); 
}


public short GetClippingRectTop() {
 return  (short)(GetAbsoluteClippingRectTop() - GetCumulativeOffsetY()); 
}


public short GetClippingRectWidth() {
 return  GetAbsoluteClippingRectWidth(); 
}


public short GetClippingRectHeight() {
 return  GetAbsoluteClippingRectHeight(); 
}


public void SetClippingRect(short rect_left, short rect_top, short rect_width, short rect_height) {
 SetAbsoluteClippingRect((short)(rect_left + GetCumulativeOffsetX()), (short)(rect_top + GetCumulativeOffsetY()), rect_width, rect_height);
	
}


public short GetAbsoluteClippingRectTop() {
 return  mClipRect_top; 
}


public short GetAbsoluteClippingRectLeft() {
 return  mClipRect_left; 
}


public short GetAbsoluteClippingRectWidth() {
 return  mClipRect_width; 
}


public short GetAbsoluteClippingRectHeight() {
 return  mClipRect_height; 
}


public void SetAbsoluteClippingRect(short rect_left, short rect_top, short rect_width, short rect_height) {
 mClipRect_left = rect_left; mClipRect_top = rect_top; mClipRect_width = rect_width; mClipRect_height = rect_height;; 
}


public void BeginScene () {





mDirtyRectIndex = 0;

}


public void EndScene () {




	mDirtyRectIndex = -1;
	

{
		ClearDirtyRects();
	}


}


public void RenderApplication () {


	{		

		if(!IsDirtyRectsEnabled())
		{
			ClearDirtyRects();
			AddDirtyRect((short)0, (short)0, (short)GetVideoMode().GetWidth(), (short)GetVideoMode().GetHeight());
		}
	




 short tmpUnionRect_left = 0;
  short tmpUnionRect_top = 0;
  short tmpUnionRect_width = 0;
  short tmpUnionRect_height = 0;

		 int[] dirtyRectsAreas = mDirtyRectsAreas;

		for(int i = 0;i < mSlotsUsed - 1;i ++)
		{
			short firstDirtyRect_left;
 short firstDirtyRect_top;
 short firstDirtyRect_width;
 short firstDirtyRect_height;
;
			firstDirtyRect_left = mDirtyRects_left[i]; firstDirtyRect_top = mDirtyRects_top[i]; firstDirtyRect_width = mDirtyRects_width[i]; firstDirtyRect_height = mDirtyRects_height[i];;
			for(int j = i + 1;j < mSlotsUsed;j ++)
			{
				short secondDirtyRect_left;
 short secondDirtyRect_top;
 short secondDirtyRect_width;
 short secondDirtyRect_height;
;
				secondDirtyRect_left = mDirtyRects_left[j]; secondDirtyRect_top = mDirtyRects_top[j]; secondDirtyRect_width = mDirtyRects_width[j]; secondDirtyRect_height = mDirtyRects_height[j];;
				tmpUnionRect_left = FlMath.Minimum(firstDirtyRect_left, secondDirtyRect_left); tmpUnionRect_top = FlMath.Minimum(firstDirtyRect_top, secondDirtyRect_top); tmpUnionRect_width = (short)(FlMath.Maximum((short)(firstDirtyRect_left + firstDirtyRect_width), (short)(secondDirtyRect_left + secondDirtyRect_width)) - tmpUnionRect_left); tmpUnionRect_height = (short)(FlMath.Maximum((short)(firstDirtyRect_top + firstDirtyRect_height), (short)(secondDirtyRect_top + secondDirtyRect_height)) - tmpUnionRect_top);;

				 int tmpUnionArea = (tmpUnionRect_width * tmpUnionRect_height);


				if(tmpUnionArea - (mDirtyRectsAreas[i] + mDirtyRectsAreas[j]) <= mDirtyRectMergePixelThreshold)
				{
					mDirtyRects_left[i] = tmpUnionRect_left; mDirtyRects_top[i] = tmpUnionRect_top; mDirtyRects_width[i] = tmpUnionRect_width; mDirtyRects_height[i] = tmpUnionRect_height;;
					dirtyRectsAreas[i] = tmpUnionArea;
					for(int k = j + 1;k < mSlotsUsed;k ++)
					{
						mDirtyRects_left[k - 1] = mDirtyRects_left[k];
						mDirtyRects_top[k - 1] = mDirtyRects_top[k];
						mDirtyRects_width[k - 1] = mDirtyRects_width[k];
						mDirtyRects_height[k - 1] = mDirtyRects_height[k];
						dirtyRectsAreas[k - 1] = dirtyRectsAreas[k];
					}
					firstDirtyRect_left = mDirtyRects_left[i]; firstDirtyRect_top = mDirtyRects_top[i]; firstDirtyRect_width = mDirtyRects_width[i]; firstDirtyRect_height = mDirtyRects_height[i];;
					mSlotsUsed--;
					j--;
				}
			}
		}

{

			BeginScene();

		}
		
		{




 short baseRect_left = mClipRect_left;
  short baseRect_top = mClipRect_top;
  short baseRect_width = mClipRect_width;
  short baseRect_height = mClipRect_height;


			while(SetNextDirtyRect())
			{
				if((mClipRect_width <= 0|| mClipRect_height <= 0))
				{
					SetAbsoluteClippingRect(baseRect_left, baseRect_top, baseRect_width, baseRect_height);
					continue;
				}

	

Application.GetInstance().OnDraw(this);
	SetAbsoluteClippingRect(baseRect_left, baseRect_top, baseRect_width, baseRect_height);
			}



















		}
		
		{

			EndScene();

		}
	}

	Application.GetInstance().SetDirty(false);


}


public short GetCumulativeOffsetX() {
 return  mCumulativeOffsetX; 
}


public short GetCumulativeOffsetY() {
 return  mCumulativeOffsetY; 
}


public VideoMode GetVideoMode() {
 return  mVideoMode; 
}


public void SetVideoMode(VideoMode mode) {
 mVideoMode = mode; 
}


public FlRect GetScreenRect() {
 return  mScreenRect; 
}


public void UpdateOrientation ( VideoMode newMode) {

	mScreenRect.Assign(new FlRect((short)0, (short)0, (short)newMode.GetWidth(), (short)newMode.GetHeight()));
	mVideoMode = newMode;

	mDirtyRectMergePixelThreshold = newMode.GetWidth();

}


public abstract byte GetDisplayAPI();



public boolean InvertedLandscape() {
 return  mInvertedLandscape; 
}


public void SetInvertedLandscape (boolean inverted) {

	mInvertedLandscape = inverted;




}


public void EnableCoverageCheck(boolean enable) {

	
}


public static DisplayContext CreateContext ( VideoMode mode) {

		return  new FlAndroidDisplayContextImp(mode);
	
}


public void AddDirtyRect (short newRect_left, short newRect_top, short newRect_width, short newRect_height) {



	if((newRect_width <= 0|| newRect_height <= 0))
	{
		return ;
	}

	 short tmpUnionRect_left = 0;
  short tmpUnionRect_top = 0;
  short tmpUnionRect_width = 0;
  short tmpUnionRect_height = 0;

	int tmpUnionArea;


	 boolean bestUnionIsBetweenOldRects = false;

	 short bestUnionRect_left = 0;
  short bestUnionRect_top = 0;
  short bestUnionRect_width = 0;
  short bestUnionRect_height = 0;

	 int bestUnionArea = 2000000;
 
	 int bestUnionRect1 = 0;

	 int bestUnionRect2 = 1;

	int i;

	int j;

	 int newRectArea = (newRect_width * newRect_height);

	short currentDirtyRect_left;
 short currentDirtyRect_top;
 short currentDirtyRect_width;
 short currentDirtyRect_height;
;

	 int [] dirtyRectsAreas = mDirtyRectsAreas;
	 int slotsUsed = mSlotsUsed;


	
	for(i = 0;i < slotsUsed;i ++)
	{
		currentDirtyRect_left = mDirtyRects_left[i]; currentDirtyRect_top = mDirtyRects_top[i]; currentDirtyRect_width = mDirtyRects_width[i]; currentDirtyRect_height = mDirtyRects_height[i];;
		tmpUnionRect_left = FlMath.Minimum(currentDirtyRect_left, newRect_left); tmpUnionRect_top = FlMath.Minimum(currentDirtyRect_top, newRect_top); tmpUnionRect_width = (short)(FlMath.Maximum((short)(currentDirtyRect_left + currentDirtyRect_width), (short)(newRect_left + newRect_width)) - tmpUnionRect_left); tmpUnionRect_height = (short)(FlMath.Maximum((short)(currentDirtyRect_top + currentDirtyRect_height), (short)(newRect_top + newRect_height)) - tmpUnionRect_top);;

		tmpUnionArea = (tmpUnionRect_width * tmpUnionRect_height);

		
		if(tmpUnionArea - (mDirtyRectsAreas[i] + newRectArea) <= mDirtyRectMergePixelThreshold)
		{
			mDirtyRects_left[i] = tmpUnionRect_left; mDirtyRects_top[i] = tmpUnionRect_top; mDirtyRects_width[i] = tmpUnionRect_width; mDirtyRects_height[i] = tmpUnionRect_height;;
			dirtyRectsAreas[i] = tmpUnionArea;
			return ;
		}
		else
		{
			
			if(tmpUnionArea < bestUnionArea)
			{
				bestUnionArea = tmpUnionArea;
				bestUnionRect_left = tmpUnionRect_left; bestUnionRect_top = tmpUnionRect_top; bestUnionRect_width = tmpUnionRect_width; bestUnionRect_height = tmpUnionRect_height;;
				bestUnionRect1 = i;
			}
		}
	}

	
	if(slotsUsed < 3)
	{
		mDirtyRects_left[slotsUsed] = newRect_left; mDirtyRects_top[slotsUsed] = newRect_top; mDirtyRects_width[slotsUsed] = newRect_width; mDirtyRects_height[slotsUsed] = newRect_height;;
		dirtyRectsAreas[slotsUsed] = (newRect_width * newRect_height);
		mSlotsUsed++;
	}
	else 
	{
		short dirtyRectI_left;
 short dirtyRectI_top;
 short dirtyRectI_width;
 short dirtyRectI_height;
;
		short dirtyRectJ_left;
 short dirtyRectJ_top;
 short dirtyRectJ_width;
 short dirtyRectJ_height;
;

		
		for(i = 0;i < 3- 1;i ++)
		{
			for(j = i + 1;j < 3;j ++)
			{
				dirtyRectI_left = mDirtyRects_left[i]; dirtyRectI_top = mDirtyRects_top[i]; dirtyRectI_width = mDirtyRects_width[i]; dirtyRectI_height = mDirtyRects_height[i];;
				dirtyRectJ_left = mDirtyRects_left[j]; dirtyRectJ_top = mDirtyRects_top[j]; dirtyRectJ_width = mDirtyRects_width[j]; dirtyRectJ_height = mDirtyRects_height[j];;

				tmpUnionRect_left = FlMath.Minimum(dirtyRectI_left, dirtyRectJ_left); tmpUnionRect_top = FlMath.Minimum(dirtyRectI_top, dirtyRectJ_top); tmpUnionRect_width = (short)(FlMath.Maximum((short)(dirtyRectI_left + dirtyRectI_width), (short)(dirtyRectJ_left + dirtyRectJ_width)) - tmpUnionRect_left); tmpUnionRect_height = (short)(FlMath.Maximum((short)(dirtyRectI_top + dirtyRectI_height), (short)(dirtyRectJ_top + dirtyRectJ_height)) - tmpUnionRect_top);;
				tmpUnionArea = (tmpUnionRect_width * tmpUnionRect_height);

				if(tmpUnionArea < bestUnionArea)
				{
					bestUnionIsBetweenOldRects = true;
					bestUnionArea = tmpUnionArea;
					bestUnionRect_left = tmpUnionRect_left; bestUnionRect_top = tmpUnionRect_top; bestUnionRect_width = tmpUnionRect_width; bestUnionRect_height = tmpUnionRect_height;;
					bestUnionRect1 = i;
					bestUnionRect2 = j;
				}
			}
		}

		mDirtyRects_left[bestUnionRect1] = bestUnionRect_left; mDirtyRects_top[bestUnionRect1] = bestUnionRect_top; mDirtyRects_width[bestUnionRect1] = bestUnionRect_width; mDirtyRects_height[bestUnionRect1] = bestUnionRect_height;;
		dirtyRectsAreas[bestUnionRect1] = bestUnionArea;

		if(bestUnionIsBetweenOldRects)
		{
			
			mDirtyRects_left[bestUnionRect2] = newRect_left; mDirtyRects_top[bestUnionRect2] = newRect_top; mDirtyRects_width[bestUnionRect2] = newRect_width; mDirtyRects_height[bestUnionRect2] = newRect_height;;
			dirtyRectsAreas[bestUnionRect2] = (newRect_width * newRect_height);
		}
	}

}


public void AddDirtyComponent ( Component dirtyComponent) {

	 short clipped_left = dirtyComponent.GetRectLeft();
  short clipped_top = dirtyComponent.GetRectTop();
  short clipped_width = dirtyComponent.GetRectWidth();
  short clipped_height = dirtyComponent.GetRectHeight();

 Viewport curParent = dirtyComponent.GetViewport();
	if(curParent != null)
	{
		 Component lastObject = dirtyComponent;
	
		 short parentOffsetX = 0;

		 short parentOffsetY = 0;

	while(curParent != null)
		{
			if(!curParent.IsVisible())
			{
				return ;
			}
	














parentOffsetX = (short)(parentOffsetX + curParent.GetRectLeft() - curParent.GetOffsetX());
			parentOffsetY = (short)(parentOffsetY + curParent.GetRectTop() - curParent.GetOffsetY());
	lastObject = curParent;
			curParent = curParent.GetViewport();

		}

		if(Application.GetInstance() != lastObject)
		{
			return ;
		}

	
		clipped_left = (short)(clipped_left + parentOffsetX);; clipped_top = (short)(clipped_top + parentOffsetY);;;

		 short parentRect_left = (short)(parentOffsetX + dirtyComponent.GetViewport().GetOffsetX());
  short parentRect_top = (short)(parentOffsetY + dirtyComponent.GetViewport().GetOffsetY());
  short parentRect_width = dirtyComponent.GetViewport().GetRectWidth();
  short parentRect_height = dirtyComponent.GetViewport().GetRectHeight();

{  int clipperRight = (parentRect_left + parentRect_width);
  int clippedRight = (clipped_left + clipped_width);
  int clipperBottom = (parentRect_top + parentRect_height);
  int clippedBottom = (clipped_top + clipped_height);
 if(parentRect_left > clipped_left) clipped_left = parentRect_left; if(parentRect_top > clipped_top) clipped_top = parentRect_top; if(clipperRight < clippedRight) clippedRight = clipperRight; if(clipperBottom < clippedBottom) clippedBottom = clipperBottom; clipped_width = (short)(clippedRight - clipped_left); clipped_height = (short)(clippedBottom - clipped_top); };
	AddDirtyRect(clipped_left, clipped_top, clipped_width, clipped_height);
	}
	else
	{
		if(dirtyComponent == Application.GetInstance())
		{
			AddDirtyRect(clipped_left, clipped_top, clipped_width, clipped_height);
		}
	}

}


public boolean HasDirtyRects () {

	return  mSlotsUsed > 0;

}


public void ClearDirtyRects () {

	mSlotsUsed = 0;

}


public boolean SetNextDirtyRect () {

	if(mDirtyRectIndex >= mSlotsUsed)
	{
		return  false;
	}
	else
	{
		short r_left;
 short r_top;
 short r_width;
 short r_height;
;
		 int rectIndex = mDirtyRectIndex;

		r_left = mDirtyRects_left[rectIndex]; r_top = mDirtyRects_top[rectIndex]; r_width = mDirtyRects_width[rectIndex]; r_height = mDirtyRects_height[rectIndex];
		
		{  int clipperRight = (r_left + r_width);
  int clippedRight = (mClipRect_left + mClipRect_width);
  int clipperBottom = (r_top + r_height);
  int clippedBottom = (mClipRect_top + mClipRect_height);
 if(r_left > mClipRect_left) mClipRect_left = r_left; if(r_top > mClipRect_top) mClipRect_top = r_top; if(clipperRight < clippedRight) clippedRight = clipperRight; if(clipperBottom < clippedBottom) clippedBottom = clipperBottom; mClipRect_width = (short)(clippedRight - mClipRect_left); mClipRect_height = (short)(clippedBottom - mClipRect_top); };
		mDirtyRectIndex++;
		return  true;
	}

}


public void SetDirtyRectsEnable (boolean enable) {

	mDirtyRectsEnabled = enable;

}


public boolean IsDirtyRectsEnabled() {
 return  mDirtyRectsEnabled; 
}


public int mDirtyRectIndex;
public boolean mDirtyRectsEnabled;
public short[] mDirtyRects_left = new short[3];

public short[] mDirtyRects_top = new short[3];

public short[] mDirtyRects_width = new short[3];

public short[] mDirtyRects_height = new short[3];

public int[] mDirtyRectsAreas = new int[3];

public int mSlotsUsed;
public int mDirtyRectMergePixelThreshold;
public VideoMode mVideoMode;
public boolean mInvertedLandscape;
public short mClipRect_left;
public short mClipRect_top;
public short mClipRect_width;
public short mClipRect_height;
public boolean mBypassClipping;
public short mCumulativeOffsetX;
public short mCumulativeOffsetY;
public FlRect mScreenRect;



}

