package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;

//#define INST_FROM_PRIMITIVE 0


public class FQuaternionT_F32 {

public final static byte QUATERNION_FP = 28;

public FQuaternionT_F32 () {
s = new F32();
v_x = new F32();
v_y = new F32();
v_z = new F32();


}


public  FQuaternionT_F32 ( F32 scalarPart, FVec3T_F32 vectorPart, int point) {
s = new F32(scalarPart);
v_x = new F32(vectorPart.x);
v_y = new F32(vectorPart.y);
v_z = new F32(vectorPart.z);


	DestructiveNormalize(point);

}


public  FQuaternionT_F32 ( FQuaternionT_F32 other) {
s = new F32(other.s);
v_x = new F32(other.v_x);
v_y = new F32(other.v_y);
v_z = new F32(other.v_z);



}


public FQuaternionT_F32 ( FVec3T_F32 normalizedAxis, F32 rotationAngle, int point) {
s = new F32();
v_x = new F32();
v_y = new F32();
v_z = new F32();

	Init(normalizedAxis, rotationAngle, point);

}


public void Init ( FVec3T_F32 normalizedAxis, F32 rotationAngle, int point) {



	 int dp = QUATERNION_FP - point;


	 F32 halfAngle = new F32(rotationAngle.DivPower2(1));


	 F32 sin = new F32(halfAngle.Sin(point));

	 F32 cos = new F32(halfAngle.Cos(point));


	s = cos.IncreasePrecision(dp);

	v_x = normalizedAxis.x; v_y = normalizedAxis.y; v_z = normalizedAxis.z;; 
	v_x = v_x.Mul(sin, point); v_y = v_y.Mul(sin, point); v_z = v_z.Mul(sin, point);;   
	v_x = v_x.IncreasePrecision(dp); v_y = v_y.IncreasePrecision(dp); v_z = v_z.IncreasePrecision(dp);; 

}


public FQuaternionT_F32 ( FVec3T_F32 rotationAsAngularVelocityTimeIn, int point) {
s = new F32();
v_x = new F32();
v_y = new F32();
v_z = new F32();



	 F32 rotationAngle = new F32(rotationAsAngularVelocityTimeIn.LengthHP(point));


	if(rotationAngle.LessThan(F32.Epsilon(point)))
	{
		s = F32.One(QUATERNION_FP);
		v_x = F32.Zero(QUATERNION_FP); v_y = F32.Zero(QUATERNION_FP); v_z = F32.Zero(QUATERNION_FP);;
	}
	else 
	{
		 int dp = QUATERNION_FP - point;

		 F32 halfAngle = new F32(rotationAngle.DivPower2(1));


		 F32 sin = new F32(halfAngle.Sin(point));

		 F32 cos = new F32(halfAngle.Cos(point));


		s = cos.IncreasePrecision(dp);

		v_x = rotationAsAngularVelocityTimeIn.x; v_y = rotationAsAngularVelocityTimeIn.y; v_z = rotationAsAngularVelocityTimeIn.z;;
		v_x = v_x.Div(rotationAngle, point); v_y = v_y.Div(rotationAngle, point); v_z = v_z.Div(rotationAngle, point);;
		v_x = v_x.Mul(sin, point); v_y = v_y.Mul(sin, point); v_z = v_z.Mul(sin, point);;
		v_x = v_x.IncreasePrecision(dp); v_y = v_y.IncreasePrecision(dp); v_z = v_z.IncreasePrecision(dp);;
	}

}


public static FQuaternionT_F32 GetRotationBetweenNormalizedVectors ( FVec3T_F32 source, FVec3T_F32 destination, FQuaternionT_F32 quat180, int point) {

	 FQuaternionT_F32 retval = FQuaternionT_F32.Get();;
	if(GetRotationBetweenNormalizedVectors(retval, source, destination, point))
	{
		return  retval;
	}
	else
	{
		return  quat180;
	}

}


public static FQuaternionT_F32 GetRotationBetweenNormalizedVectors ( FVec3T_F32 source, FVec3T_F32 destination, int point) {

	 FQuaternionT_F32 retval = FQuaternionT_F32.Get();;
	GetRotationBetweenNormalizedVectors(retval, source, destination, point);
	return  retval;

}


public static boolean GetRotationBetweenNormalizedVectors (FQuaternionT_F32 out, FVec3T_F32 source, FVec3T_F32 destination, int point) {



	 int dp = QUATERNION_FP - point;


	 FVec3T_F32 sourceHP = new FVec3T_F32(source.IncreasePrecision(dp));

	 FVec3T_F32 destHP = new FVec3T_F32(destination.IncreasePrecision(dp));

	
	
	sourceHP.DestructiveNormalizeHP(QUATERNION_FP);
	destHP.DestructiveNormalizeHP(QUATERNION_FP);

	
	
	
	 F32 dot = new F32(sourceHP.Dot(destHP, QUATERNION_FP));
	
	F32 s = new F32();
 

	if(dot.GreaterThan(F32.One(QUATERNION_FP))) 
	{
		s = F32.One(QUATERNION_FP);
	}
	else if(dot.LessThan(F32.One(QUATERNION_FP).Neg()))
	{
		s = F32.Zero(QUATERNION_FP);
	}
	else
	{
		s = F32.Half(QUATERNION_FP).Mul(F32.One(QUATERNION_FP).Add(dot), QUATERNION_FP).Sqrt(QUATERNION_FP);
	}

	if(s.LessThan(F32.Epsilon(QUATERNION_FP)))
	{
		
		out.Init(source.GetAPerpendicularUnitVector(point), F32.Pi(point), point);
		return  false;
	}

	
	
	
	
	
	
	
	
	out.s = s;

	out.v_x = sourceHP.y.Mul(destHP.z, QUATERNION_FP).Sub(sourceHP.z.Mul(destHP.y, QUATERNION_FP)); out.v_y = sourceHP.z.Mul(destHP.x, QUATERNION_FP).Sub(sourceHP.x.Mul(destHP.z, QUATERNION_FP)); out.v_z = sourceHP.x.Mul(destHP.y, QUATERNION_FP).Sub(sourceHP.y.Mul(destHP.x, QUATERNION_FP));;
	 F32 scalar = new F32(s.MulPower2(1));

	out.v_x = out.v_x.Div(scalar, QUATERNION_FP); out.v_y = out.v_y.Div(scalar, QUATERNION_FP); out.v_z = out.v_z.Div(scalar, QUATERNION_FP);;

	return  true;

}


public FQuaternionT_F32 Mul ( FQuaternionT_F32 q2) {

	 FQuaternionT_F32 result = FQuaternionT_F32.Get();;
	Mul(result, q2);
	return  result;

}


public void Mul (FQuaternionT_F32 result, FQuaternionT_F32 q2In) {

	 F32 q2_s = new F32(q2In.s);

	 F32 q2_v_x = new F32(q2In.v_x);
  F32 q2_v_y = new F32(q2In.v_y);
  F32 q2_v_z = new F32(q2In.v_z);


	 F32 dotP = new F32(v_x.Mul(q2_v_x, QUATERNION_FP).Add(v_y.Mul(q2_v_y, QUATERNION_FP)).Add(v_z.Mul(q2_v_z, QUATERNION_FP)));

	result.s = s.Mul(q2_s, QUATERNION_FP).Sub(dotP);
	result.v_x = s.Mul(q2_v_x, QUATERNION_FP).Add(v_x.Mul(q2_s, QUATERNION_FP)).Add(v_y.Mul(q2_v_z, QUATERNION_FP)).Sub(v_z.Mul(q2_v_y, QUATERNION_FP));
	result.v_y = s.Mul(q2_v_y, QUATERNION_FP).Add(v_y.Mul(q2_s, QUATERNION_FP)).Sub(v_x.Mul(q2_v_z, QUATERNION_FP)).Add(v_z.Mul(q2_v_x, QUATERNION_FP));
	result.v_z = s.Mul(q2_v_z, QUATERNION_FP).Add(v_z.Mul(q2_s, QUATERNION_FP)).Add(v_x.Mul(q2_v_y, QUATERNION_FP)).Sub(v_y.Mul(q2_v_x, QUATERNION_FP));
	result.DestructiveNormalize();

}


public FQuaternionT_F32 MulAssign ( FQuaternionT_F32 q2In) {

	 F32 q2_s = new F32(q2In.s);

	 F32 q2_v_x = new F32(q2In.v_x);
  F32 q2_v_y = new F32(q2In.v_y);
  F32 q2_v_z = new F32(q2In.v_z);


	 F32 dotP = new F32(v_x.Mul(q2_v_x, QUATERNION_FP).Add(v_y.Mul(q2_v_y, QUATERNION_FP)).Add(v_z.Mul(q2_v_z, QUATERNION_FP)));

	 F32 ss = new F32(s.Mul(q2_s, QUATERNION_FP).Sub(dotP));

	 F32 vv_x = new F32(s.Mul(q2_v_x, QUATERNION_FP).Add(v_x.Mul(q2_s, QUATERNION_FP)).Add(v_y.Mul(q2_v_z, QUATERNION_FP)).Sub(v_z.Mul(q2_v_y, QUATERNION_FP)));
  F32 vv_y = new F32(s.Mul(q2_v_y, QUATERNION_FP).Add(v_y.Mul(q2_s, QUATERNION_FP)).Sub(v_x.Mul(q2_v_z, QUATERNION_FP)).Add(v_z.Mul(q2_v_x, QUATERNION_FP)));
  F32 vv_z = new F32(s.Mul(q2_v_z, QUATERNION_FP).Add(v_z.Mul(q2_s, QUATERNION_FP)).Add(v_x.Mul(q2_v_y, QUATERNION_FP)).Sub(v_y.Mul(q2_v_x, QUATERNION_FP)));

s = ss;
	v_x = vv_x;
	v_y = vv_y;
	v_z = vv_z;
	DestructiveNormalize();

	return this;

}


public FQuaternionT_F32 Assign ( FQuaternionT_F32 other) {

	ForceInline.v();

	s = other.s;
	v_x = other.v_x; v_y = other.v_y; v_z = other.v_z;;
	return this;

}


public void Assign (F32 inS, F32 vX, F32 vY, F32 vZ) {

	ForceInline.v();
	s = inS;
	v_x = vX;
	v_y = vY;
	v_z = vZ;

}


public boolean Equals ( FQuaternionT_F32 q2) {

	ForceInline.v();
	return  s.Equals(q2.s) && v_x.Equals(q2.v_x) && v_y.Equals(q2.v_y) && v_z.Equals(q2.v_z);

}


public F32 GetS() {
 return  s;   
}


public F32 GetVx() {
 return  v_x; 
}


public F32 GetVy() {
 return  v_y; 
}


public F32 GetVz() {
 return  v_z; 
}


public FQuaternionT_F32 ConvertRotationFromMaxToFlight () {

	FQuaternionT_F32 result = new FQuaternionT_F32();

	 FQuaternionT_F32 R = new FQuaternionT_F32(this.GetS(), new FVec3T_F32(this.GetVx(), this.GetVy(), this.GetVz()), FQuaternionT_F32.QUATERNION_FP);

	 FQuaternionT_F32 S = new FQuaternionT_F32(FVec3T_F32.UnitI(16), F32.PiOver2(16).Neg(), 16);

	
	
	result.Assign(S.Mul(R).Mul(S.GetInverseForNormalized())); 
	return  result;

}


public FVec3T_F32 Conjugate ( FVec3T_F32 v2In, int point) {

	ForceInline.v();
	return  Conjugate(v2In.x, v2In.y, v2In.z, point);

}


public void Conjugate (FVec3T_F32 out, FVec3T_F32 v2In, int point) {

	ForceInline.v();
	Conjugate(out, v2In.x, v2In.y, v2In.z, point);

}


public FVec3T_F32 Conjugate ( F32 v2InX, F32 v2InY, F32 v2InZ, int point) {

	 FVec3T_F32 retval = FVec3T_F32.Get();;
	Conjugate(retval, v2InX, v2InY, v2InZ, point);
	return  retval;

}


public void Conjugate (FVec3T_F32 out, F32 v2InX, F32 v2InY, F32 v2InZ, int point) {



	 int dp = QUATERNION_FP - point;

	 F32 ss = new F32(s.DecreasePrecision(dp));

	 F32 v2_x = new F32(v2InX);
  F32 v2_y = new F32(v2InY);
  F32 v2_z = new F32(v2InZ);

	 F32 vv_x = new F32(v_x.DecreasePrecision(dp));
  F32 vv_y = new F32(v_y.DecreasePrecision(dp));
  F32 vv_z = new F32(v_z.DecreasePrecision(dp));


	 F32 q_s = new F32(vv_x.Mul(v2_x, point).Add(vv_y.Mul(v2_y, point)).Add(vv_z.Mul(v2_z, point)));

	q_s = q_s.Neg();
	 F32 q_v_x = new F32(ss.Mul(v2_x, point).Add(vv_y.Mul(v2_z, point)).Sub(vv_z.Mul(v2_y, point)));
  F32 q_v_y = new F32(ss.Mul(v2_y, point).Sub(vv_x.Mul(v2_z, point)).Add(vv_z.Mul(v2_x, point)));
  F32 q_v_z = new F32(ss.Mul(v2_z, point).Add(vv_x.Mul(v2_y, point)).Sub(vv_y.Mul(v2_x, point)));

out.x = q_v_x.Mul(ss, point).Sub(q_s.Mul(vv_x, point)).Sub(q_v_y.Mul(vv_z, point)).Add(q_v_z.Mul(vv_y, point));
	out.y = q_v_y.Mul(ss, point).Sub(q_s.Mul(vv_y, point)).Add(q_v_x.Mul(vv_z, point)).Sub(q_v_z.Mul(vv_x, point));
	out.z = q_v_z.Mul(ss, point).Sub(q_s.Mul(vv_z, point)).Sub(q_v_x.Mul(vv_y, point)).Add(q_v_y.Mul(vv_x, point));

}


public FVec3T_F32 ConjugateUnitI (int point) {

	ForceInline.v();
	return  ConjugateUnit(v_x.Neg(), s, v_z, v_y.Neg(), point);

}


public FVec3T_F32 ConjugateUnitJ (int point) {

	ForceInline.v();
	return  ConjugateUnit(v_y.Neg(), v_z.Neg(), s, v_x, point);

}


public FVec3T_F32 ConjugateUnitK (int point) {

	ForceInline.v();
	return  ConjugateUnit(v_z.Neg(), v_y, v_x.Neg(), s, point);

}


public void ConjugateUnitI (FVec3T_F32 out, int point) {

	ForceInline.v();
	ConjugateUnit(v_x.Neg(), s, v_z, v_y.Neg(), out, point);

}


public void ConjugateUnitJ (FVec3T_F32 out, int point) {

	ForceInline.v();
	ConjugateUnit(v_y.Neg(), v_z.Neg(), s, v_x, out, point);

}


public void ConjugateUnitK (FVec3T_F32 out, int point) {

	ForceInline.v();
	ConjugateUnit(v_z.Neg(), v_y, v_x.Neg(), s, out, point);

}


public FQuaternionT_F32 DestructiveInverseForNormalized () {

	v_x = v_x.Neg(); v_y = v_y.Neg(); v_z = v_z.Neg();;
	return this;	

}


public FQuaternionT_F32 GetInverseForNormalized () {

	 FQuaternionT_F32 result = FQuaternionT_F32.Get();;

	GetInverseForNormalized(result);

	return  result;

}


public void GetInverseForNormalized (FQuaternionT_F32 returnValue) {

	returnValue.s = s;
	returnValue.v_x = v_x.Neg();
	returnValue.v_y = v_y.Neg();
	returnValue.v_z = v_z.Neg();

}


public FQuaternionT_F32 DestructiveInverse () {

	 F32 lenSq = new F32(v_x.Square(QUATERNION_FP).Add(v_y.Square(QUATERNION_FP)).Add(v_z.Square(QUATERNION_FP)));

	 F32 squaredMagnitude = new F32(s.Square(QUATERNION_FP).Add(lenSq));

	 F32 inverseSquaredMagnitude = new F32(squaredMagnitude.Inverse(QUATERNION_FP));

	s = s.Mul(inverseSquaredMagnitude, QUATERNION_FP);
	v_x = v_x.Mul(inverseSquaredMagnitude.Neg(), QUATERNION_FP); v_y = v_y.Mul(inverseSquaredMagnitude.Neg(), QUATERNION_FP); v_z = v_z.Mul(inverseSquaredMagnitude.Neg(), QUATERNION_FP);;

	return this;

}


public FQuaternionT_F32 GetInverse () {

	 FQuaternionT_F32 result = FQuaternionT_F32.Get();;

	 F32 lenSq = new F32(v_x.Square(QUATERNION_FP).Add(v_y.Square(QUATERNION_FP)).Add(v_z.Square(QUATERNION_FP)));

	 F32 squaredMagnitude = new F32(s.Square(QUATERNION_FP).Add(lenSq));

	 F32 inverseSquaredMagnitude = new F32(squaredMagnitude.Inverse(QUATERNION_FP));


	result.s = s.Mul(inverseSquaredMagnitude, QUATERNION_FP);
	result.v_x = v_x.Mul(inverseSquaredMagnitude.Neg(), QUATERNION_FP); result.v_y = v_y.Mul(inverseSquaredMagnitude.Neg(), QUATERNION_FP); result.v_z = v_z.Mul(inverseSquaredMagnitude.Neg(), QUATERNION_FP);;

	return  result;

}


public FQuaternionT_F32 DestructiveNormalize () {

	ForceInline.v();

	 F32 lenSq = new F32(v_x.Square(QUATERNION_FP).Add(v_y.Square(QUATERNION_FP)).Add(v_z.Square(QUATERNION_FP)));


	 F32 magnitude = new F32(s.Square(QUATERNION_FP).Add(lenSq).Sqrt(QUATERNION_FP));

	 F32 inverseMagnitude = new F32(magnitude.Inverse(QUATERNION_FP));

	s = s.Mul(inverseMagnitude, QUATERNION_FP);

	v_x = v_x.Mul(inverseMagnitude, QUATERNION_FP); v_y = v_y.Mul(inverseMagnitude, QUATERNION_FP); v_z = v_z.Mul(inverseMagnitude, QUATERNION_FP);;

	return this;	

}


public FQuaternionT_F32 GetNormalized () {

	 FQuaternionT_F32 result = FQuaternionT_F32.Get(this);;
	result.DestructiveNormalize();
	return  result;

}


public void SetIdentity () {

	ForceInline.v();

	s = F32.One(QUATERNION_FP);
	v_x = F32.Zero(QUATERNION_FP); v_y = F32.Zero(QUATERNION_FP); v_z = F32.Zero(QUATERNION_FP);;

}


public F32 GetNormalizedAxisAndRotationAngle (FVec3T_F32 normalizedAxis, int point) {



	 int dp = QUATERNION_FP - point;

	 F32 vv_x = new F32(v_x.DecreasePrecision(dp));
  F32 vv_y = new F32(v_y.DecreasePrecision(dp));
  F32 vv_z = new F32(v_z.DecreasePrecision(dp));


	 F32 halfAngle = new F32(s.ArcCos(QUATERNION_FP));

	 F32 rotationAngle = new F32(halfAngle.MulPower2(1));
 
	 F32 sin = new F32(halfAngle.Sin(QUATERNION_FP).DecreasePrecision(dp));

	if(sin.LessOrEqual(F32.Epsilon(point)))
	{
		normalizedAxis.x = F32.Zero(point); normalizedAxis.y = F32.Zero(point); normalizedAxis.z = F32.Zero(point);;
		return  F32.Zero(point);
	}
	else
	{
		normalizedAxis.x = vv_x.Div(sin, point); normalizedAxis.y = vv_y.Div(sin, point); normalizedAxis.z = vv_z.Div(sin, point);;
	}

	return  rotationAngle.DecreasePrecision(dp);

}


public F32 GetNormalizedAxisAndSmallestRotationAngle (FVec3T_F32 normalizedAxis, int point) {



	 int dp = QUATERNION_FP - point;

	 F32 vv_x = new F32(v_x.DecreasePrecision(dp));
  F32 vv_y = new F32(v_y.DecreasePrecision(dp));
  F32 vv_z = new F32(v_z.DecreasePrecision(dp));


	F32 rotationAngle = new F32();

	F32 halfAngle = new F32();


	if(s.GreaterOrEqual(F32.Zero(QUATERNION_FP)))
	{
		halfAngle = s.ArcCos(QUATERNION_FP);
		rotationAngle = halfAngle.MulPower2(1); 

		 F32 sin = new F32(halfAngle.Sin(QUATERNION_FP).DecreasePrecision(dp));

		if(sin.LessOrEqual(F32.Epsilon(point)))
		{
			normalizedAxis.x = F32.Zero(point); normalizedAxis.y = F32.Zero(point); normalizedAxis.z = F32.Zero(point);;
			return  F32.Zero(point);
		}
		else
		{
			normalizedAxis.x = vv_x.Div(sin, point); normalizedAxis.y = vv_y.Div(sin, point); normalizedAxis.z = vv_z.Div(sin, point);;
		}
	}
	else 
	{
		halfAngle = (s.Neg()).ArcCos(QUATERNION_FP);
		rotationAngle = halfAngle.MulPower2(1); 

		 F32 sin = new F32(halfAngle.Sin(QUATERNION_FP).DecreasePrecision(dp));

		if(sin.LessOrEqual(F32.Epsilon(QUATERNION_FP)))
		{
			normalizedAxis.x = F32.Zero(point); normalizedAxis.y = F32.Zero(point); normalizedAxis.z = F32.Zero(point);;
			return  F32.Zero(point);
		}
		else 
		{
			normalizedAxis.x = vv_x.Div(sin.Neg(), point); normalizedAxis.y = vv_y.Div(sin.Neg(), point); normalizedAxis.z = vv_z.Div(sin.Neg(), point);;
		}
	}

	return  rotationAngle.DecreasePrecision(dp);

}


public FMat44T_F32 ToMatrix (int point) {

	 FMat44T_F32 result = FMat44T_F32.Get();;
	ToMatrix(result, point);
	return  result;

}


public void ToMatrix (FMat44T_F32 returnValue, int point) {



	 int dp = QUATERNION_FP - point;

	 F32 ss = new F32(s.DecreasePrecision(dp));

	 F32 vv_x = new F32(v_x.DecreasePrecision(dp));
  F32 vv_y = new F32(v_y.DecreasePrecision(dp));
  F32 vv_z = new F32(v_z.DecreasePrecision(dp));


	 F32 twoX = new F32(vv_x.MulPower2(1));
 
	 F32 twoXX = new F32(twoX.Mul(vv_x, point));

	 F32 twoXY = new F32(twoX.Mul(vv_y, point));

	 F32 twoXZ = new F32(twoX.Mul(vv_z, point));

	 F32 twoXS = new F32(twoX.Mul(ss, point));

	 F32 twoY = new F32(vv_y.MulPower2(1));
 
	 F32 twoYY = new F32(twoY.Mul(vv_y, point));

	 F32 twoYZ = new F32(twoY.Mul(vv_z, point));

	 F32 twoYS = new F32(twoY.Mul(ss, point));

	 F32 twoZ = new F32(vv_z.MulPower2(1));
 
	 F32 twoZZ = new F32(twoZ.Mul(vv_z, point));

	 F32 twoZS = new F32(twoZ.Mul(ss, point));

	 F32 oneMinusTwoXX = new F32(F32.One(point).Sub(twoXX));


	returnValue.m11 = F32.One(point).Sub(twoYY).Sub(twoZZ);
	returnValue.m12 = twoXY.Sub(twoZS);
	returnValue.m13 = twoXZ.Add(twoYS);
	returnValue.m14 = F32.Zero(point);

	returnValue.m21 = twoXY.Add(twoZS);
	returnValue.m22 = oneMinusTwoXX.Sub(twoZZ);
	returnValue.m23 = twoYZ.Sub(twoXS);
	returnValue.m24 = F32.Zero(point);
	
	returnValue.m31 = twoXZ.Sub(twoYS);
	returnValue.m32 = twoYZ.Add(twoXS);
	returnValue.m33 = oneMinusTwoXX.Sub(twoYY);
	returnValue.m34 = F32.Zero(point);

	returnValue.m41 = F32.Zero(point);
	returnValue.m42 = F32.Zero(point);
	returnValue.m43 = F32.Zero(point);
	returnValue.m44 = F32.One(point);

}


public static FQuaternionT_F32 I () {

	 FQuaternionT_F32 retval = FQuaternionT_F32.Get();;

	retval.s = F32.One(QUATERNION_FP);
	retval.v_x = F32.Zero(QUATERNION_FP); retval.v_y = F32.Zero(QUATERNION_FP); retval.v_z = F32.Zero(QUATERNION_FP);;
	return  retval;

}


public static FQuaternionT_F32 Interpolate ( FQuaternionT_F32 orient1, FQuaternionT_F32 orient2, F32 factor, int point) {

	FVec3T_F32 normalizedAxis = new FVec3T_F32();

	 FQuaternionT_F32 deltaOrient = new FQuaternionT_F32(orient1.GetInverseForNormalized().Mul(orient2));

	 F32 angle = new F32(deltaOrient.GetNormalizedAxisAndSmallestRotationAngle(normalizedAxis, point));

	 F32 newAngle = new F32(angle.Mul(factor, point));

	return  orient1.Mul(new FQuaternionT_F32(normalizedAxis, newAngle, point));

}


public F32 GetScalarPart (int point) {

	ForceInline.v();
	return  s.DecreasePrecision(QUATERNION_FP - point);

}


public FVec3T_F32 GetVectorPart (int point) {

	 int dp = QUATERNION_FP - point;

	 FVec3T_F32 retval = FVec3T_F32.Get(v_x.DecreasePrecision(dp), v_y.DecreasePrecision(dp), v_z.DecreasePrecision(dp));;
return  retval;

}


public void SimulateEuler ( FVec3T_F32 rotationAsAngularVelocityTimeIn, int point) {

	ForceInline.v();





	
	
	
	F32 q_s = new F32();

	F32 q_v_x = new F32();
 F32 q_v_y = new F32();
 F32 q_v_z = new F32();


	
	
	
	 F32 rotationAngle = new F32(rotationAsAngularVelocityTimeIn.LengthHP(point));


	if(rotationAngle.LessThan(F32.Epsilon(point)))
	{
		q_s = F32.One(QUATERNION_FP);
		q_v_x = F32.Zero(QUATERNION_FP); q_v_y = F32.Zero(QUATERNION_FP); q_v_z = F32.Zero(QUATERNION_FP);;
	}
	else 
	{
		 int dp = QUATERNION_FP - point;

		 F32 halfAngle = new F32(rotationAngle.DivPower2(1));


		 F32 sin = new F32(halfAngle.Sin(point));

		 F32 cos = new F32(halfAngle.Cos(point));


		q_s = cos.IncreasePrecision(dp);

		q_v_x = rotationAsAngularVelocityTimeIn.x; q_v_y = rotationAsAngularVelocityTimeIn.y; q_v_z = rotationAsAngularVelocityTimeIn.z;;
		q_v_x = q_v_x.Div(rotationAngle, point); q_v_y = q_v_y.Div(rotationAngle, point); q_v_z = q_v_z.Div(rotationAngle, point);;
		q_v_x = q_v_x.Mul(sin, point); q_v_y = q_v_y.Mul(sin, point); q_v_z = q_v_z.Mul(sin, point);;
		q_v_x = q_v_x.IncreasePrecision(dp); q_v_y = q_v_y.IncreasePrecision(dp); q_v_z = q_v_z.IncreasePrecision(dp);;
	}

	
	
	
	
	 F32 dotP = new F32(q_v_x.Mul(v_x, QUATERNION_FP).Add(q_v_y.Mul(v_y, QUATERNION_FP)).Add(q_v_z.Mul(v_z, QUATERNION_FP)));

	 F32 ss = new F32(q_s.Mul(s, QUATERNION_FP).Sub(dotP));

	 F32 vv_x = new F32(q_s.Mul(v_x, QUATERNION_FP).Add(q_v_x.Mul(s, QUATERNION_FP)).Add(q_v_y.Mul(v_z, QUATERNION_FP)).Sub(q_v_z.Mul(v_y, QUATERNION_FP)));
  F32 vv_y = new F32(q_s.Mul(v_y, QUATERNION_FP).Add(q_v_y.Mul(s, QUATERNION_FP)).Sub(q_v_x.Mul(v_z, QUATERNION_FP)).Add(q_v_z.Mul(v_x, QUATERNION_FP)));
  F32 vv_z = new F32(q_s.Mul(v_z, QUATERNION_FP).Add(q_v_z.Mul(s, QUATERNION_FP)).Add(q_v_x.Mul(v_y, QUATERNION_FP)).Sub(q_v_y.Mul(v_x, QUATERNION_FP)));

s = ss;
	v_x = vv_x;
	v_y = vv_y;
	v_z = vv_z;
	DestructiveNormalize();

}


public void OnSerialize(Package _package) {
  FVec3T_F32 vv = FVec3T_F32.Get(v_x, v_y, v_z);;
		(s)= (_package).SerializeIntrinsic(s);
		(vv).OnSerialize(_package);
		v_x = vv.x;
		v_y = vv.y;
		v_z = vv.z;








FVec3T_F32.mPool[++FVec3T_F32.mPoolIndex] = vv;;
	
}


public static FQuaternionT_F32[] mPool = FQuaternionT_F32.InstArrayFQuaternionT_F32(50);

public static int mPoolIndex = -1;
public static FQuaternionT_F32 Get() {
 if(mPoolIndex >= 0)
		{
			 FQuaternionT_F32 obj = mPool[mPoolIndex--];
			return  obj;
		}
		return  new FQuaternionT_F32();
	
}


public static FQuaternionT_F32 Get(FQuaternionT_F32 copy) {
 if(mPoolIndex >= 0)
		{
			 FQuaternionT_F32 obj = mPool[mPoolIndex--];
			obj.Assign(copy);
			return  obj;
		}
		return  new FQuaternionT_F32(copy);
	
}


public static FQuaternionT_F32 Get(F32 scalarPart, FVec3T_F32 vectorPart) {
 if(mPoolIndex >= 0)
		{
			 FQuaternionT_F32 obj = mPool[mPoolIndex--];
			obj.s = scalarPart;
			obj.v_x = vectorPart.x;
			obj.v_y = vectorPart.y;
			obj.v_z = vectorPart.z;
			return  obj;
		}
		return  new FQuaternionT_F32(scalarPart, vectorPart);
	
}


public static FQuaternionT_F32 Get(FVec3T_F32 rotationAsAngularVelocityTimeIn, int point) {
 if(mPoolIndex >= 0)
		{


			 FQuaternionT_F32 obj = mPool[mPoolIndex--];

			 F32 rotationAngle = new F32(rotationAsAngularVelocityTimeIn.LengthHP(point));


			if(rotationAngle.LessThan(F32.Epsilon(point)))
			{
				obj.s = F32.One(QUATERNION_FP);
				obj.v_x = F32.Zero(QUATERNION_FP); obj.v_y = F32.Zero(QUATERNION_FP); obj.v_z = F32.Zero(QUATERNION_FP);;
			}
			else 
			{  int dp = QUATERNION_FP - point;

				 F32 halfAngle = new F32(rotationAngle.DivPower2(1));


				 F32 sin = new F32(halfAngle.Sin(point));

				 F32 cos = new F32(halfAngle.Cos(point));


				obj.s = cos.IncreasePrecision(dp);

				obj.v_x = rotationAsAngularVelocityTimeIn.x; obj.v_y = rotationAsAngularVelocityTimeIn.y; obj.v_z = rotationAsAngularVelocityTimeIn.z;;
				obj.v_x = obj.v_x.Div(rotationAngle, point); obj.v_y = obj.v_y.Div(rotationAngle, point); obj.v_z = obj.v_z.Div(rotationAngle, point);;
				obj.v_x = obj.v_x.Mul(sin, point); obj.v_y = obj.v_y.Mul(sin, point); obj.v_z = obj.v_z.Mul(sin, point);;
				obj.v_x = obj.v_x.IncreasePrecision(dp); obj.v_y = obj.v_y.IncreasePrecision(dp); obj.v_z = obj.v_z.IncreasePrecision(dp);
			}
		
			return  obj;
		}
		return  new FQuaternionT_F32(rotationAsAngularVelocityTimeIn, point);
	
}


public  FQuaternionT_F32 ( F32 scalarPart, FVec3T_F32 vectorPart) {
s = new F32(scalarPart);
v_x = new F32(vectorPart.x);
v_y = new F32(vectorPart.y);
v_z = new F32(vectorPart.z);



}


public F32 s;
public F32 v_x;
public F32 v_y;
public F32 v_z;
public FQuaternionT_F32 DestructiveNormalize (int point) {



	 int dp = QUATERNION_FP - point;


	 F32 lenSq = new F32(v_x.Square(point).Add(v_y.Square(point)).Add(v_z.Square(point)));

	 F32 magnitude = new F32((s.Square(point).Add(lenSq)).Sqrt(point));

	 F32 inverseMagnitude = new F32(magnitude.Inverse(point));

	s = s.Mul(inverseMagnitude, point).IncreasePrecision(dp);
	v_x = v_x.Mul(inverseMagnitude, point); v_y = v_y.Mul(inverseMagnitude, point); v_z = v_z.Mul(inverseMagnitude, point);;
	v_x = v_x.IncreasePrecision(dp); v_y = v_y.IncreasePrecision(dp); v_z = v_z.IncreasePrecision(dp);;

	return this;	

}


public void Mul ( FVec3T_F32 v2In, int point, FQuaternionT_F32 result) {



	 int dp = QUATERNION_FP - point;

	 F32 ss = new F32(s.DecreasePrecision(dp));

	 F32 v2_x = new F32(v2In.x);
  F32 v2_y = new F32(v2In.y);
  F32 v2_z = new F32(v2In.z);

	 F32 vv_x = new F32(v_x.DecreasePrecision(dp));
  F32 vv_y = new F32(v_y.DecreasePrecision(dp));
  F32 vv_z = new F32(v_z.DecreasePrecision(dp));


	result.s = vv_x.Mul(v2_x, point).Add(vv_y.Mul(v2_y, point)).Add(vv_z.Mul(v2_z, point));;
	result.s = result.s.Neg();
	result.v_x = ss.Mul(v2_x, point).Add(vv_y.Mul(v2_z, point)).Sub(vv_z.Mul(v2_y, point));
	result.v_y = ss.Mul(v2_y, point).Sub(vv_x.Mul(v2_z, point)).Add(vv_z.Mul(v2_x, point));
	result.v_z = ss.Mul(v2_z, point).Add(vv_x.Mul(v2_y, point)).Sub(vv_y.Mul(v2_x, point));

}


public FVec3T_F32 ConjugateUnit ( F32 ss, F32 vx, F32 vy, F32 vz, int point) {



	 FVec3T_F32 result = FVec3T_F32.Get(vx.Mul(s, QUATERNION_FP).Sub(ss.Mul(v_x, QUATERNION_FP)).Sub(vy.Mul(v_z, QUATERNION_FP)).Add(vz.Mul(v_y, QUATERNION_FP)), vy.Mul(s, QUATERNION_FP).Sub(ss.Mul(v_y, QUATERNION_FP)).Add(vx.Mul(v_z, QUATERNION_FP)).Sub(vz.Mul(v_x, QUATERNION_FP)), vz.Mul(s, QUATERNION_FP).Sub(ss.Mul(v_z, QUATERNION_FP)).Sub(vx.Mul(v_y, QUATERNION_FP)).Add(vy.Mul(v_x, QUATERNION_FP)));;
 int dp = QUATERNION_FP - point;

	result.x = result.x.DecreasePrecision(dp);
	result.y = result.y.DecreasePrecision(dp);
	result.z = result.z.DecreasePrecision(dp);

	return  result;

}


public void ConjugateUnit ( F32 ss, F32 vx, F32 vy, F32 vz, FVec3T_F32 out, int point) {



	out.x = vx.Mul(s, QUATERNION_FP).Sub(ss.Mul(v_x, QUATERNION_FP)).Sub(vy.Mul(v_z, QUATERNION_FP)).Add(vz.Mul(v_y, QUATERNION_FP));
	out.y = vy.Mul(s, QUATERNION_FP).Sub(ss.Mul(v_y, QUATERNION_FP)).Add(vx.Mul(v_z, QUATERNION_FP)).Sub(vz.Mul(v_x, QUATERNION_FP));
	out.z = vz.Mul(s, QUATERNION_FP).Sub(ss.Mul(v_z, QUATERNION_FP)).Sub(vx.Mul(v_y, QUATERNION_FP)).Add(vy.Mul(v_x, QUATERNION_FP));

	 int dp = QUATERNION_FP - point;

	out.x = out.x.DecreasePrecision(dp);
	out.y = out.y.DecreasePrecision(dp);
	out.z = out.z.DecreasePrecision(dp);

}



/* One dimension array */
public static FQuaternionT_F32[] InstArrayFQuaternionT_F32(int size) {
	FQuaternionT_F32[] newArray = new FQuaternionT_F32[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new FQuaternionT_F32();
	return newArray; }

/* Two dimension array */
public static FQuaternionT_F32[][] InstArrayFQuaternionT_F32(int size1, int size2) {
	FQuaternionT_F32[][] newArray = new FQuaternionT_F32[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FQuaternionT_F32[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new FQuaternionT_F32(); }
	return newArray; }

/* Three dimension array */
public static FQuaternionT_F32[][][] InstArrayFQuaternionT_F32(int size1, int size2, int size3) {
	FQuaternionT_F32[][][] newArray = new FQuaternionT_F32[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FQuaternionT_F32[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new FQuaternionT_F32[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new FQuaternionT_F32(); } }
	return newArray; }



}

