package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;

//#define INST_FROM_PRIMITIVE 0


public class FVec2T_F32 {

public FVec2T_F32 () {
x = new F32();
y = new F32();


}


public  FVec2T_F32 (F32 px, F32 py) {
x = new F32(px);
y = new F32(py);



}


public  FVec2T_F32 ( FVec2T_F32 other) {
x = new F32(other.x);
y = new F32(other.y);



}


public FVec2T_F32 Add ( FVec2T_F32 v) {

	return  new FVec2T_F32(x.Add(v.x), y.Add(v.y));

}


public FVec2T_F32 Sub ( FVec2T_F32 v) {

	return  new FVec2T_F32(x.Sub(v.x), y.Sub(v.y));

}


public FVec2T_F32 Mul ( FVec2T_F32 v, int point) {

	return  new FVec2T_F32(x.Mul(v.x, point), y.Mul(v.y, point));

}


public FVec2T_F32 Mul ( F32 c, int point) {

	return  new FVec2T_F32(c.Mul(x, point), c.Mul(y, point));

}


public FVec2T_F32 Div ( F32 c, int point) {

	return  new FVec2T_F32(x.Div(c, point), y.Div(c, point));

}


public FVec2T_F32 Neg () {

	return  new FVec2T_F32(x.Neg(), y.Neg());

}


public FVec2T_F32 AddAssign ( FVec2T_F32 v) {

	x = x.Add(v.x);
	y = y.Add(v.y);
	return this;

}


public FVec2T_F32 SubAssign ( FVec2T_F32 v) {

	x = x.Sub(v.x);
	y = y.Sub(v.y);
	return this;

}


public FVec2T_F32 MulAssign ( FVec2T_F32 v, int point) {

	x = x.Mul(v.x, point);
	y = y.Mul(v.y, point);
	return this;

}


public FVec2T_F32 MulAssign ( F32 c, int point) {

	x = x.Mul(c, point);
	y = y.Mul(c, point);
	return this;

}


public FVec2T_F32 DivEqual ( F32 c, int point) {

	 F32 ic = new F32(c.Inverse(point));

	x = x.Mul(ic, point);
	y = y.Mul(ic, point);
	return this;

}


public boolean Equals ( FVec2T_F32 v) {

	return  (x.Equals(v.x) && y.Equals(v.y));

}


public FVec2T_F32 Assign ( FVec2T_F32 v) {

	x = v.x;
	y = v.y;
	return this;

}


public F32 GetAt ( int index) {

	 int i = index & 1;

	return  ((i !=0) ? y : x);

}


public F32 Dot ( FVec2T_F32 v, int point) {

	return  x.Mul(v.x, point).Add(y.Mul(v.y, point));

}


public FVec2T_F32 Cross () {

	return  new FVec2T_F32(y.Neg(), x);

}


public F32 LengthSquared (int point) {

	return  x.Square(point).Add(y.Square(point));

}


public F32 Length (int point) {

	 F32 squared = new F32(x.Square(point).Add(y.Square(point)));

	return  squared.Sqrt(point);

}


public FVec2T_F32 Normalized (int point) {

	 FVec2T_F32 res = new FVec2T_F32(this);

	res.DestructiveNormalize(point);
	return  res;

}


public FVec2T_F32 DestructiveNormalize (int point) {

	 F32 f = new F32((F32)(x.Square(point).Add(y.Square(point))).Sqrt(point).Inverse(point));
 
	return  MulAssign(f, point);

}


public static FVec2T_F32 Zero (int point) {

	return  new FVec2T_F32(F32.Zero(point), F32.Zero(point));

}


public static FVec2T_F32 UnitI (int point) {

	return  new FVec2T_F32(F32.One(point), F32.Zero(point));

}


public static FVec2T_F32 UnitJ (int point) {

	return  new FVec2T_F32(F32.Zero(point), F32.One(point));

}


public void OnSerialize(Package _package) {
 (x)= (_package).SerializeIntrinsic(x);
		(y)= (_package).SerializeIntrinsic(y);
	
}


public static FVec2T_F32 Round ( FVec2T_F32 v, int inputPoint) {

	return  new FVec2T_F32(v.x.Round(inputPoint), v.y.Round(inputPoint));

}


public static FVec2T_F32 Float ( FVec2T_F32 v, int a5) {

	return  v;

}


public F32 x;
public F32 y;

/* One dimension array */
public static FVec2T_F32[] InstArrayFVec2T_F32(int size) {
	FVec2T_F32[] newArray = new FVec2T_F32[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new FVec2T_F32();
	return newArray; }

/* Two dimension array */
public static FVec2T_F32[][] InstArrayFVec2T_F32(int size1, int size2) {
	FVec2T_F32[][] newArray = new FVec2T_F32[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FVec2T_F32[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new FVec2T_F32(); }
	return newArray; }

/* Three dimension array */
public static FVec2T_F32[][][] InstArrayFVec2T_F32(int size1, int size2, int size3) {
	FVec2T_F32[][][] newArray = new FVec2T_F32[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FVec2T_F32[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new FVec2T_F32[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new FVec2T_F32(); } }
	return newArray; }



}

