package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;

//#define INST_FROM_PRIMITIVE 0


public class FVec3T_F32 {

public FVec3T_F32 () {
x = new F32();
y = new F32();
z = new F32();


}


public  FVec3T_F32 ( F32 value) {
x = new F32(value);
y = new F32(value);
z = new F32(value);



}


public  FVec3T_F32 ( F32 i, F32 j, F32 k) {
x = new F32(i);
y = new F32(j);
z = new F32(k);



}


public  FVec3T_F32 ( FVec3T_F32 other) {
x = new F32(other.x);
y = new F32(other.y);
z = new F32(other.z);



}


public FVec3T_F32 ConvertTranslationFromMaxToFlight () {

	return  new FVec3T_F32(x, z, y.Neg());

}


public FVec3T_F32 ConvertScaleFromMaxToFlight () {

	return  new FVec3T_F32(x, z, y);

}


public F32 Dot ( FVec3T_F32 other, int point) {

	return  x.Mul(other.x, point).Add(y.Mul(other.y, point)).Add(z.Mul(other.z, point));

}


public FVec3T_F32 Cross ( FVec3T_F32 other, int point) {

	 FVec3T_F32 result = FVec3T_F32.Get();;



Cross(other, point, result);
	return  result;

}


public void Cross ( FVec3T_F32 other, int point, FVec3T_F32 result) {

	result.x = y.Mul(other.z, point).Sub(z.Mul(other.y, point));
	result.y = z.Mul(other.x, point).Sub(x.Mul(other.z, point));
	result.z = x.Mul(other.y, point).Sub(y.Mul(other.x, point));

}


public F32 Length (int point) {

	 F32 l2 = new F32(x.Square(point).Add(y.Square(point)).Add(z.Square(point)));

	return  l2.Sqrt(point);

}


public F32 LengthHP (int point) {



	
	
	

{
		 long x64 = (long)x.value;

		 long y64 = (long)y.value;

		 long z64 = (long)z.value;

		 long len64 = (x64 * x64) + (y64 * y64) + (z64 * z64);


		 long mask = ((long)7) << 61;

		
		 int fractionPart = 0;

		while((len64 & mask) == 0&& fractionPart < 28)
		{
			fractionPart += 2;
			mask >>= 2;
		}

		 int integerPart = 32- fractionPart;

		
		 F32 len32 = new F32((int)(len64 >> integerPart), fractionPart);


		if(integerPart >= 16)
		{
			return  len32.Sqrt(fractionPart).IncreasePrecision(integerPart - 16);
		}
		else
		{
			return  len32.Sqrt(fractionPart).DecreasePrecision(16- integerPart);
		}

	}
	






}


public F32 LengthSquared (int point) {

	return  x.Square(point).Add(y.Square(point)).Add(z.Square(point));

}


public static F32 LengthSquared (F32 inX, F32 inY, F32 inZ, int point) {

	return  inX.Square(point).Add(inY.Square(point)).Add(inZ.Square(point));

}


public void DestructiveNormalizeHP (int point) {

	
	 F32 invlength = new F32(LengthHP(point).Inverse(point));

	x = x.Mul(invlength, point);
	y = y.Mul(invlength, point);
	z = z.Mul(invlength, point);

}


public FVec3T_F32 NormalizedHP (int point) {

	 FVec3T_F32 result = FVec3T_F32.Get(this);;
	result.DestructiveNormalizeHP(point);
	return  result;

}


public void NormalizedHP (FVec3T_F32 returnValue, int point) {

	returnValue.Assign(this);
	returnValue.DestructiveNormalizeHP(point);

}


public void DestructiveNormalize (int point) {

	
	 F32 invlength = new F32(Length(point).Inverse(point));

	x = x.Mul(invlength, point);
	y = y.Mul(invlength, point);
	z = z.Mul(invlength, point);

}


public FVec3T_F32 Normalized (int point) {

	 FVec3T_F32 result = FVec3T_F32.Get(this);;
	result.DestructiveNormalize(point);
	return  result;

}


public void Normalized (FVec3T_F32 returnValue, int point) {

	returnValue.Assign(this);
	returnValue.DestructiveNormalize(point);

}


public FVec3T_F32 Interpolate ( FVec3T_F32 other, F32 factor, int point) {

	 FVec3T_F32 retval = FVec3T_F32.Get();;
	Interpolate(retval, other.x, other.y, other.z, factor, point);
	return  retval;

}


public void Interpolate (FVec3T_F32 out, F32 ox, F32 oy, F32 oz, F32 factor, int point) {

	 F32 nfactor = new F32(F32.One(point).Sub(factor));

	out.x = x.Mul(nfactor, point).Add(ox.Mul(factor, point));
	out.y = y.Mul(nfactor, point).Add(oy.Mul(factor, point));
	out.z = z.Mul(nfactor, point).Add(oz.Mul(factor, point));

}


public FVec3T_F32 GetAPerpendicularUnitVector (int point) {

	 FVec3T_F32 retval = FVec3T_F32.Get();;
	GetAPerpendicularUnitVector(retval, point);
	return  retval;

}


public void GetAPerpendicularUnitVector (FVec3T_F32 out, int point) {

	
	 F32 temp = new F32(x.Square(point).Add(z.Square(point)));

	 F32 lengthInXZ = new F32(temp.Sqrt(point));


	if(lengthInXZ.LessThan(F32.Epsilon(point)))
	{
		out.x = F32.One(point); out.y = F32.Zero(point); out.z = F32.Zero(point);;
	}
	else
	{
		 F32 lengthInXZInverse = new F32(lengthInXZ.Inverse(point));

		out.x = z.Mul(lengthInXZInverse, point);
		out.y = F32.Zero(point);
		out.z = x.Mul(lengthInXZInverse, point).Neg();
		
	}

}


public static F32 GetAngleBetweenNormalizedVectors ( FVec3T_F32 vec1, FVec3T_F32 vec2, int point) {

	 F32 dot = new F32(vec1.Dot(vec2, point));


	
	if(dot.GreaterOrEqual(F32.One(point))) 
	{
		return  F32.Zero(point);
	}
	else if(dot.LessOrEqual(F32.One(point).Neg()))
	{
		return  F32.Pi(point);
	}

	return  dot.ArcCos(point);

}


public FVec3T_F32 Mul ( F32 scalar, int point) {

	 FVec3T_F32 retval = FVec3T_F32.Get(x.Mul(scalar, point), y.Mul(scalar, point), z.Mul(scalar, point));;
	return  retval;

}


public FVec3T_F32 Div ( F32 scalar, int point) {

	 FVec3T_F32 retval = FVec3T_F32.Get(x.Div(scalar, point), y.Div(scalar, point), z.Div(scalar, point));;
	return  retval;

}


public FVec3T_F32 Add ( FVec3T_F32 other) {

	 FVec3T_F32 retval = FVec3T_F32.Get(x.Add(other.x), y.Add(other.y), z.Add(other.z));;
	return  retval;

}


public FVec3T_F32 Sub ( FVec3T_F32 other) {

	 FVec3T_F32 retval = FVec3T_F32.Get(x.Sub(other.x), y.Sub(other.y), z.Sub(other.z));;
	return  retval;

}


public FVec3T_F32 AddAssign ( FVec3T_F32 other) {

	x = x.Add(other.x);
	y = y.Add(other.y);
	z = z.Add(other.z);
	return this;

}


public FVec3T_F32 SubAssign ( FVec3T_F32 other) {

	x = x.Sub(other.x);
	y = y.Sub(other.y);
	z = z.Sub(other.z);
	return this;

}


public FVec3T_F32 Neg () {

	 FVec3T_F32 retval = FVec3T_F32.Get(x.Neg(), y.Neg(), z.Neg());;
	return  retval;

}


public FVec3T_F32 Inverse (int point) {

	 FVec3T_F32 retval = FVec3T_F32.Get(x.Inverse(point), y.Inverse(point), z.Inverse(point));;
	return  retval;

}


public FVec3T_F32 Assign ( FVec3T_F32 other) {

	x = other.x;
	y = other.y;
	z = other.z;

	return this;

}


public boolean Equals ( FVec3T_F32 other) {

	return	x.Equals(other.x) &&
			y.Equals(other.y) &&
			z.Equals(other.z);

}


public FVec3T_F32 DecreasePrecision (int deltaPoint) {

	 FVec3T_F32 retval = FVec3T_F32.Get(x.DecreasePrecision(deltaPoint), y.DecreasePrecision(deltaPoint), z.DecreasePrecision(deltaPoint));;
	return  retval;

}


public FVec3T_F32 IncreasePrecision (int deltaPoint) {

	 FVec3T_F32 retval = FVec3T_F32.Get(x.IncreasePrecision(deltaPoint), y.IncreasePrecision(deltaPoint), z.IncreasePrecision(deltaPoint));;
	return  retval;

}


public static FVec3T_F32 UnitI (int point) {

	 FVec3T_F32 retval = FVec3T_F32.Get(F32.One(point), F32.Zero(point), F32.Zero(point));;
	return  retval;

}


public static FVec3T_F32 UnitJ (int point) {

	 FVec3T_F32 retval = FVec3T_F32.Get(F32.Zero(point), F32.One(point), F32.Zero(point));;
	return  retval;

}


public static FVec3T_F32 UnitK (int point) {

	 FVec3T_F32 retval = FVec3T_F32.Get(F32.Zero(point), F32.Zero(point), F32.One(point));;
	return  retval;

}


public static FVec3T_F32 Zero (int point) {

	 FVec3T_F32 retval = FVec3T_F32.Get(F32.Zero(point), F32.Zero(point), F32.Zero(point));;
	return  retval;

}


public static FVec3T_F32 One (int point) {

	 FVec3T_F32 retval = FVec3T_F32.Get(F32.One(point), F32.One(point), F32.One(point));;
	return  retval;

}


public static FVec3T_F32[] mPool = FVec3T_F32.InstArrayFVec3T_F32(100);

public static int mPoolIndex = -1;
public static FVec3T_F32 Get() {
 if(mPoolIndex >= 0)
		{
			 FVec3T_F32 obj = mPool[mPoolIndex--];
			return  obj;
		}
		return  new FVec3T_F32();
	
}


public static FVec3T_F32 Get(F32 i, F32 j, F32 k) {
 if(mPoolIndex >= 0)
		{
			 FVec3T_F32 obj = mPool[mPoolIndex--];
			obj.x = i;
			obj.y = j;
			obj.z = k;
			return  obj;
		}
		return  new FVec3T_F32(i, j, k);
	
}


public static FVec3T_F32 Get(FVec3T_F32 copy) {
 if(mPoolIndex >= 0)
		{
			 FVec3T_F32 obj = mPool[mPoolIndex--];
			obj.Assign(copy);
			return  obj;
		}
		return  new FVec3T_F32(copy);
	
}


public void OnSerialize(Package _package) {
 (x)= (_package).SerializeIntrinsic(x);
		(y)= (_package).SerializeIntrinsic(y);
		(z)= (_package).SerializeIntrinsic(z);
	
}


public F32 x;
public F32 y;
public F32 z;

/* One dimension array */
public static FVec3T_F32[] InstArrayFVec3T_F32(int size) {
	FVec3T_F32[] newArray = new FVec3T_F32[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new FVec3T_F32();
	return newArray; }

/* Two dimension array */
public static FVec3T_F32[][] InstArrayFVec3T_F32(int size1, int size2) {
	FVec3T_F32[][] newArray = new FVec3T_F32[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FVec3T_F32[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new FVec3T_F32(); }
	return newArray; }

/* Three dimension array */
public static FVec3T_F32[][][] InstArrayFVec3T_F32(int size1, int size2, int size3) {
	FVec3T_F32[][][] newArray = new FVec3T_F32[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FVec3T_F32[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new FVec3T_F32[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new FVec3T_F32(); } }
	return newArray; }



}

