package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


	import android.app.Activity;
	import android.content.Intent;
	import android.net.Uri;
	import android.os.Bundle;
	import android.view.Menu;
	import android.view.Window;
	import android.widget.TextView;
	
public class FlAndroidApp extends Activity implements Runnable {

public  FlAndroidApp () {
mScene = new FlAndroidScene(null);
mMainLoop = new Thread();
mResPkgName = new java.lang.String();


	currentWidth = SpecConstants.UsedWidth;
	currentHeight = SpecConstants.UsedHeight;

	mStarted = false;

	mResPkgName = null;

}


public void Exit () {

	application.SaveGame();

	super.finish();

}


public void run () {

	while(!this.mMustQuit)
	{
		
		FlEventQueue.GetInstance().ProcessEvents();

		if(!Application.GetInstance().GetIsSuspended())
		{

			synchronized(paintLock)
			{	
				mScene.OnTime(FlGameTimer.GetInstance().GetTime());
			}



			
			if(DisplayManager.GetInstance().GetMainDisplayContext().HasDirtyRects())
			

{
				mScene.RequestPaint();
			}


			synchronized(paintLock)
			{
				
				FrameworkGlobals.GetInstance().mPackageLoader.LoadQueuedPackages();	
			}

		}
	}

}


public int GetResId (java.lang.String folderName, java.lang.String fileName) {

	UpdatePkgName();
	fileName = fileName.substring(0, fileName.indexOf("."));	
	return  getResources().getIdentifier(fileName, folderName, mResPkgName);

}


public Uri GetResUri (java.lang.String folderName, java.lang.String fileName) {

	UpdatePkgName();
	 java.lang.String uriStr = new java.lang.String("android.resource://" + GetPkgName() + "/" + GetResId(folderName, fileName));

	return  Uri.parse(uriStr);

}


public java.lang.String GetPkgName() {
 return  mResPkgName; 
}


public void UpdatePkgName () {

	if(mResPkgName == null)
	{
		
		 java.lang.String mainGameClass = new java.lang.String(instance.getClass().getName());

		
		mResPkgName = mainGameClass.substring(0, mainGameClass.lastIndexOf('.'));
	}

}


public boolean mMustQuit;
public boolean mStarted;
public int currentWidth;
public int currentHeight;
public FlAndroidScene mScene;
public static Object paintLock;
public static FlAndroidApp instance;
public void InitializeFrameworkApplication () {

	try{
		frameworkGlobals = new FrameworkGlobals();
		 VideoMode resVideoMode = new VideoMode(SpecConstants.UsedWidth, SpecConstants.UsedHeight, Constants.kScreenColorDepth);

		DisplayManager.Initialize(resVideoMode, resVideoMode);
		application = ca.jamdat.tetris.ApplicationStarter.NewFlightApp();
	}	
	catch(Exception e)
	{
		android.util.Log.e("FlightApp", "InitializeFkApp except: " + e);
	}

}


public static FrameworkGlobals frameworkGlobals;
public static Application application;
public Thread mMainLoop;
public java.lang.String mResPkgName;
public void onCreate (Bundle icicle) {

	super.onCreate(icicle);

	
	requestWindowFeature(Window.FEATURE_NO_TITLE);

	paintLock = new Object();
	instance = this;
	
	
	mScene = new FlAndroidScene(this);
	setContentView(mScene);

	InitializeFrameworkApplication();

	
	

mMainLoop = new Thread(this);
	mMainLoop.setPriority(Thread.MIN_PRIORITY);

	this.mMainLoop.start();	

}


public void onResume () {

	super.onResume();





	FlEventQueue.GetInstance().AddEvent(FlEventQueue.EventResume);

}


public void onStart () {

	super.onStart();


}


public void onRestart () {

	super.onRestart();


}


public void onPause () {

	super.onPause();

	FlEventQueue.GetInstance().AddEvent(FlEventQueue.EventPause);

}


public void onStop () {

	super.onStop();


}


public void onDestroy () {

	super.onDestroy();



	 boolean retry = true;

	this.mMustQuit = true;

	while(retry)
	{
		try{
			mMainLoop.join();
			retry = false;
		}
		catch (InterruptedException e){}
	}

}


public void onConfigurationChanged (android.content.res.Configuration newConfig) {

	mStarted = true;

	if(newConfig.orientation == android.content.res.Configuration.ORIENTATION_LANDSCAPE)
	{
		

		currentWidth = SpecConstants.UsedHeight + 25;
		currentHeight = SpecConstants.UsedWidth - 25;
	}
	else if(newConfig.orientation == android.content.res.Configuration.ORIENTATION_PORTRAIT)
	{
		
		currentWidth = SpecConstants.UsedWidth;
		currentHeight = SpecConstants.UsedHeight;
	}
	super.onConfigurationChanged(newConfig);

}



/* One dimension array */
public static FlAndroidApp[] InstArrayFlAndroidApp(int size) {
	FlAndroidApp[] newArray = new FlAndroidApp[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new FlAndroidApp();
	return newArray; }

/* Two dimension array */
public static FlAndroidApp[][] InstArrayFlAndroidApp(int size1, int size2) {
	FlAndroidApp[][] newArray = new FlAndroidApp[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FlAndroidApp[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new FlAndroidApp(); }
	return newArray; }

/* Three dimension array */
public static FlAndroidApp[][][] InstArrayFlAndroidApp(int size1, int size2, int size3) {
	FlAndroidApp[][][] newArray = new FlAndroidApp[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FlAndroidApp[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new FlAndroidApp[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new FlAndroidApp(); } }
	return newArray; }



}

