package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


	import android.content.Context;
	import android.graphics.Bitmap;
	import android.graphics.Canvas;
	import android.graphics.Paint;	
	import android.util.AttributeSet;
	import android.view.KeyEvent;
	import android.view.View;
	import java.util.Map;
	
		import android.view.MotionEvent;
	
public class FlAndroidScene extends android.view.View {

public FlAndroidScene(Context context) {
 
		super(context);
		setFocusable(true);	
		UpdateDisplayContext(SpecConstants.UsedWidth, SpecConstants.UsedHeight);
	
}




	private Canvas mCanvas;
	private Bitmap mBitmap;	
	private int mLastGameTime = 0;
	private boolean mScreenRectInitialized = false;
	short mScreenRect_left; short mScreenRect_top; short mScreenRect_width; short mScreenRect_height;

	
	
	
	
	
	
	
	
	
	
	
	@Override
	protected void onDraw(Canvas canvas) 
	{
		super.onDraw(canvas);

		if (Application.GetInstance().GetIsSuspended())
		{
			return;
		}

		;
		synchronized(FlAndroidApp.paintLock)
		{
			if (!mScreenRectInitialized)
			{
				FlRect tmpRect = DisplayManager.GetVideoModeRect();
				mScreenRect_left = tmpRect.GetLeft(); mScreenRect_top = tmpRect.GetTop(); mScreenRect_width = tmpRect.GetWidth(); mScreenRect_height = tmpRect.GetHeight();;
				mScreenRectInitialized = true;
			}

			FlAndroidDisplayContextImp displayContext = (FlAndroidDisplayContextImp)DisplayManager.GetMainDisplayContext();
			
			
				displayContext.SetClippingRect((short)0, (short)0, (short)getWidth(), (short)getHeight());
			

displayContext.mCanvas = mCanvas;

			DisplayManager.RenderApplication();

			if (mBitmap != null) 
			{
				canvas.drawBitmap(mBitmap, 0, 0, null);
			}
		}
		;
	}


	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	@Override
	public boolean onKeyDown(int androidKey, KeyEvent msg) 
	{		
		
		if (IsIgnoredKey(androidKey))
		{
			;
			return false;
		}
		
		else if (msg.getRepeatCount() > 0)
		{
			return true;
		}
		
		;

		FlEventQueue.GetInstance().AddEvent(FlEventQueue.EventKeyDown, androidKey);
		return true;
	}


	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	@Override
	public boolean onKeyUp(int androidKey, KeyEvent msg)
	{
		
		if (IsIgnoredKey(androidKey))
		{
			;
			return false;
		}
		
		else if (msg.getRepeatCount() > 0)
		{
			return true;
		}
		
		;
		FlEventQueue.GetInstance().AddEvent(FlEventQueue.EventKeyUp, androidKey);
		return true;
	}
	
	
	
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		@Override
		public boolean onTouchEvent(MotionEvent event) 
		{
            short x = (short)event.getX();
            short y = (short)event.getY();
            
            switch (event.getAction()) 
            {
                case MotionEvent.ACTION_DOWN:
					FlEventQueue.GetInstance().AddEvent(FlEventQueue.EventPenDown, x, y);
                    break;
                    
                case MotionEvent.ACTION_MOVE:
					FlEventQueue.GetInstance().AddEvent(FlEventQueue.EventPenMoved, x, y);
                    break;
                    
                case MotionEvent.ACTION_UP:
					FlEventQueue.GetInstance().AddEvent(FlEventQueue.EventPenUp, x, y);
                    break;
            }
            return true;
        }
	@Override
	protected void onSizeChanged(int w, int h, int oldw, int oldh)
	{
		;

		
			FlEventQueue.GetInstance().AddEvent(FlEventQueue.EventSizeChanged, (short)w, (short)h);
		}


	
	
	
	
	
	
	
	
	public void UpdateDisplayContext(int width, int height)
	{
		mBitmap = Bitmap.createBitmap(width, height, Bitmap.Config.RGB_565);
		mCanvas = new Canvas();
		mCanvas.setBitmap(mBitmap);
	}
	

	
	
	
	
	
	
	
	
	public void RequestPaint()
	{
		super.postInvalidate();
	}


	
	
	
	
	
	
	
	
	
	
	public void OnTime(int time)
	{
		if(FlAndroidApp.instance.mStarted)
		{
			Application.GetInstance().OnScreenSizeChangedFromOS(FlAndroidApp.instance.currentWidth, FlAndroidApp.instance.currentHeight);
		}
		
		Application.GetInstance().Iteration((int)time, (int)(time - mLastGameTime));
		mLastGameTime = time;
	}


	
	
	
	
	
	
	
	
	
	
	
	
	boolean IsIgnoredKey(int androidKey)
	{
		switch (androidKey)
		{
			case KeyEvent.KEYCODE_BACK:
			case KeyEvent.KEYCODE_CALL:
			case KeyEvent.KEYCODE_ENDCALL:
			case KeyEvent.KEYCODE_HOME:
			case KeyEvent.KEYCODE_POWER:
			case KeyEvent.KEYCODE_VOLUME_DOWN:
			case KeyEvent.KEYCODE_VOLUME_UP:
				return true;

			default:
				return false;
		}
	}

	


}

