package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class FlGameTimer {

public void Resume () {

	if(!IsRunning())
	{
		mTotalTimePaused += (Application.GetRealTime() - mPauseTimestamp);
		mPauseTimestamp = -1;
	}

}


public void Pause () {

	Pause(Application.GetRealTime());

}


public void Pause (int timestamp) {

	if(IsRunning())
	{
		mPauseTimestamp = timestamp;
	}

}


public int GetTime () {

	if(IsRunning())
	{
		return  Application.GetRealTime() - mTotalTimePaused;
	}
	else
	{
		return  mPauseTimestamp - mTotalTimePaused;
	}

}


public static FlGameTimer GetInstance () {

	 FrameworkGlobals frameworkGlobals = FrameworkGlobals.GetInstance();

	if(frameworkGlobals.mFlGameTimer == null)
	{
		frameworkGlobals.mFlGameTimer = new FlGameTimer();
	}
	return  frameworkGlobals.mFlGameTimer;

}


public  FlGameTimer () {
mPauseTimestamp = (-1);
mTotalTimePaused = (Application.GetRealTime());


}


public boolean IsRunning () {

	return  (mPauseTimestamp == -1);

}


public int mPauseTimestamp;
public int mTotalTimePaused;

/* One dimension array */
public static FlGameTimer[] InstArrayFlGameTimer(int size) {
	FlGameTimer[] newArray = new FlGameTimer[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new FlGameTimer();
	return newArray; }

/* Two dimension array */
public static FlGameTimer[][] InstArrayFlGameTimer(int size1, int size2) {
	FlGameTimer[][] newArray = new FlGameTimer[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FlGameTimer[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new FlGameTimer(); }
	return newArray; }

/* Three dimension array */
public static FlGameTimer[][][] InstArrayFlGameTimer(int size1, int size2, int size3) {
	FlGameTimer[][][] newArray = new FlGameTimer[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FlGameTimer[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new FlGameTimer[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new FlGameTimer(); } }
	return newArray; }



}

