package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class FlRect {

public static FlRect Cast(Object o, FlRect _) {
 return  (FlRect)o; 
}


 final public static byte typeNumber = TypeIDOfType_FlRect.v;
 final public static byte typeID = TypeIDOfType_FlRect.w;
 public static final boolean supportsDynamicSerialization = false; public FlRect() {
 



}


public FlRect(FlRect other) {
 
		mData[0] = other.GetLeft();
		mData[1] = other.GetTop();
		mData[2] = other.GetWidth();
		mData[3] = other.GetHeight();
	
}


public FlRect(short left, short top, short width, short height) {
 
		mData[0] = left;
		mData[1] = top;
		mData[2] = width;
		mData[3] = height;
	
}


public FlRect(Vector2_short topLeft, Vector2_short size) {
 
		mData[0] = topLeft.GetX();
		mData[1] = topLeft.GetY();
		mData[2] = size.GetX();
		mData[3] = size.GetY();
	
}


public Vector2_short GetCenter() {
 return  new Vector2_short((short)(GetLeft() + GetWidth() / 2), (short)(GetTop() + GetHeight() / 2));
	
}


public short GetWidth() {
 return  mData[2]; 
}


public short GetHeight() {
 return  mData[3]; 
}


public short GetTop() {
 return  mData[1]; 
}


public short GetLeft() {
 return  mData[0]; 
}


public short GetRight() {
 return  (short)(GetLeft() + GetWidth() - 1);
	
}


public void SetCenter(Vector2_short center) {
 SetLeft((short)(center.GetX() - GetWidth() / 2));
		SetTop((short)(center.GetY() - GetHeight() / 2));
	
}


public void SetWidth(int inWidth) {
 mData[2] = (short)inWidth;
	
}


public void SetHeight(int inHeight) {
 mData[3] = (short)inHeight;
	
}


public void SetTop(int inTop) {
 mData[1] = (short)inTop;
	
}


public void SetLeft(int inLeft) {
 mData[0] = (short)inLeft;
	
}


public void SetRight(int right) {
 SetWidth((short)(right - GetLeft() + 1));
	
}


public short GetBottom() {
 return  (short)(GetTop() + GetHeight() - 1);
	
}


public void SetBottom(int bottom) {
 SetHeight((short)(bottom + 1- GetTop()));
	
}


public Vector2_short GetTopLeft() {
 return  new Vector2_short(GetLeft(), GetTop());
	
}


public void SetTopLeft(Vector2_short topLeft) {
 SetLeft(topLeft.GetX());
		SetTop(topLeft.GetY());
	
}


public Vector2_short GetTopRight() {

		return  new Vector2_short(GetRight(), GetTop());
	
}


public Vector2_short GetBottomRight() {

		return  new Vector2_short(GetRight(), GetBottom());
	
}


public void SetBottomRight(Vector2_short bottomRight) {
 SetWidth((short)(bottomRight.GetX() + 1- GetLeft()));
		SetHeight((short)(bottomRight.GetY() + 1- GetTop()));
	
}


public Vector2_short GetBottomLeft() {

		return  new Vector2_short(GetLeft(), GetBottom());
	
}


public Vector2_short GetSize() {
 return  new Vector2_short(mData[2], mData[3]); 
}


public void MoveBy(Vector2_short delta) {
 SetLeft((short)(GetLeft() + delta.GetX()));
		SetTop((short)(GetTop() + delta.GetY()));
	
}


public void MoveBy(int deltaX, int deltaY) {
 SetLeft((short)(GetLeft() + deltaX));
		SetTop((short)(GetTop() + deltaY));
	
}


public static boolean Contains(short rect_left, short rect_top, short rect_width, short rect_height, short ptX, short ptY) {
 return (rect_left <= ptX) &&
				(ptX <= (rect_left + rect_width - 1)) &&
				(rect_top <= ptY) &&
				(ptY <= (rect_top + rect_height - 1));
	
}


public boolean ClipLine (Vector2_short p0, Vector2_short p1) {

	if(IsEmpty())
	{
		return  false;
	}

	 F32 px0 = new F32((int)p0.GetX() << 16, 16);

	 F32 py0 = new F32((int)p0.GetY() << 16, 16);

	 F32 px1 = new F32((int)p1.GetX() << 16, 16);

	 F32 py1 = new F32((int)p1.GetY() << 16, 16);


	 F32 wxmin = new F32((int)GetLeft() << 16, 16);

	 F32 wymin = new F32((int)GetTop() << 16, 16);

	 F32 wxmax = new F32((int)(GetLeft() + GetWidth() - 1) << 16, 16);

	 F32 pymax = new F32((int)(GetTop() + GetHeight() - 1)  << 16, 16);


	boolean retVal;

	int code0;
 int code1;
 int codeout;
  int accept = 0;
  int done = 0;
 code0 = calcode(px0, py0, wxmin, wymin, wxmax, pymax); code1 = calcode(px1, py1, wxmin, wymin, wxmax, pymax); do {if((code0 | code1) == 0){accept = 1; done = 1;} else {if((code0 & code1) != 0){done = 1;} else {F32 x; F32 y; codeout = (code0 != 0) ? code0 : code1;if((codeout & RectSide.TOP) != 0){x = px0.Add(px1.Sub(px0).Mul(pymax.Sub(py0).Div(py1.Sub(py0), 16),16)); y = pymax;} else {if((codeout & RectSide.BOTTOM) != 0){x = px0.Add(px1.Sub(px0).Mul(wymin.Sub(py0).Div(py1.Sub(py0), 16), 16)); y = wymin;} else {if ((codeout & RectSide.RIGHT) != 0){y = py0.Add(py1.Sub(py0).Mul(wxmax.Sub(px0).Div(px1.Sub(px0), 16), 16)); x = wxmax;} else {y = py0.Add(py1.Sub(py0).Mul(wxmin.Sub(px0).Div(px1.Sub(px0), 16), 16)); x = wxmin;} } } if(codeout == code0){px0 = x; py0 = y; code0 = calcode(px0,py0,wxmin,wymin,wxmax,pymax);} else {px1 = x; py1 = y; code1 = calcode(px1,py1,wxmin,wymin,wxmax,pymax);} } } } while(done == 0); retVal = (accept != 0? true: false);;

	p0.SetX((short)px0.ToInt(16));
	p0.SetY((short)py0.ToInt(16));
	p1.SetX((short)px1.ToInt(16));
	p1.SetY((short)py1.ToInt(16));

	return  retVal;

}


public static boolean Intersects(short rect1_left, short rect1_top, short rect1_width, short rect1_height, short rect2_left, short rect2_top, short rect2_width, short rect2_height) {
 return  (rect2_left + rect2_width > rect1_left) &&
				(rect2_top + rect2_height > rect1_top) &&
				(rect1_left + rect1_width > rect2_left) &&
				(rect1_top + rect1_height > rect2_top);
	
}


public static boolean Contains(short rect_left, short rect_top, short rect_width, short rect_height, short insideRect_left, short insideRect_top, short insideRect_width, short insideRect_height) {
 return  (insideRect_left >= rect_left) &&
				(insideRect_top >= rect_top) &&
				((short) (insideRect_left + insideRect_width - 1)  <= (short) (rect_left + rect_width - 1)) &&
				((short)(insideRect_top + insideRect_height - 1) <= (short)(rect_top + rect_height - 1));
	
}


public void OffsetTop(short pixel) {
 ForceInline.v();
        SetTop((short)(GetTop() + pixel));
	
}


public void OffsetLeft(short pixel) {
 ForceInline.v();
        SetLeft((short)(GetLeft() + pixel));
	
}


public boolean Equals(FlRect rhs) {
 return  	(mData[0] == rhs.mData[0]) && 
				(mData[1] == rhs.mData[1]) && 
				(mData[2] == rhs.mData[2]) && 
				(mData[3] == rhs.mData[3]);
	
}


public FlRect Add(Vector2_short rhs) {
 return  new FlRect((short)(GetLeft() + rhs.GetX()), (short)(GetTop() + rhs.GetY()), GetWidth(), GetHeight());
	
}


public boolean IsEmpty() {
 return  (GetWidth() <= 0|| GetHeight() <= 0);
	
}


public FlRect GetVideoModeRect () {

		return  DisplayManager.GetVideoModeRect();
	
}


public void OnSerialize (Package p) {



short c;

	c = GetLeft();	(c)= (p).SerializeIntrinsic(c); SetLeft(c);
	c = GetTop();	(c)= (p).SerializeIntrinsic(c); SetTop(c);
	c = GetWidth();	(c)= (p).SerializeIntrinsic(c); SetWidth(c);
	c = GetHeight();(c)= (p).SerializeIntrinsic(c); SetHeight(c);

}


public FlRect Assign(FlRect other) {
 mData[0] = other.GetLeft();
		mData[1] = other.GetTop();
		mData[2] = other.GetWidth();
		mData[3] = other.GetHeight();
		return this;
	
}


public short[] mData = new short[4];

public static int calcode (F32 x, F32 y, F32 xwmin, F32 ywmin, F32 xwmax, F32 ywmax) {

	 int code = 0;

	if(y.GreaterThan(ywmax))
	{
		code |= RectSide.TOP;
	}
	if(y.LessThan(ywmin))
	{
		code |= RectSide.BOTTOM;
	}
	if(x.GreaterThan(xwmax))
	{
		code |= RectSide.RIGHT;
	}
	if(x.LessThan(xwmin))
	{
		code |= RectSide.LEFT;
	}
	return (code);

}



/* One dimension array */
public static FlRect[] InstArrayFlRect(int size) {
	FlRect[] newArray = new FlRect[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new FlRect();
	return newArray; }

/* Two dimension array */
public static FlRect[][] InstArrayFlRect(int size1, int size2) {
	FlRect[][] newArray = new FlRect[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FlRect[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new FlRect(); }
	return newArray; }

/* Three dimension array */
public static FlRect[][][] InstArrayFlRect(int size1, int size2, int size3) {
	FlRect[][][] newArray = new FlRect[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FlRect[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new FlRect[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new FlRect(); } }
	return newArray; }



}

