package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class JavaBasicFileStream {

public static void WriteFile (String filename, byte [] data, int size, byte fileMode) {

		
		if(fileMode == FileStream.fileModeWrite)
		{
			FileDelete(filename);
		}
	
		try
		{
	
			java.io.RandomAccessFile javaFileStream = new java.io.RandomAccessFile(StringUtils.CreateJavaString(filename), "rw");
	
			if (fileMode == FileStream.fileModeAppend)
			{
				javaFileStream.seek(javaFileStream.length());
			}
	
			javaFileStream.write(data, 0, size);
	
			javaFileStream.close();
		}
		catch(java.lang.Exception except)
		{
			

			
		}
		
	
}


public static byte [] ReadFile (String filename) {

		
		try
		{
			java.io.RandomAccessFile javaFileStream = new java.io.RandomAccessFile(StringUtils.CreateJavaString(filename), "r");
	
			int size = (int)javaFileStream.length();
			byte[] data = new byte[size];
	
	
			int offset = 0;
			int readBytes = 0;
			while((offset < size) && (readBytes != -1))
			{
				readBytes = javaFileStream.read(data, offset, size - offset);
				offset += readBytes;
			}
	
			javaFileStream.close();
	
			return data;
		}
		catch(java.lang.Exception except)
		{
			

			
			return null;
		}
		
	
}


public static int GetFileSize (String filename) {

		
		try
		{
			java.io.RandomAccessFile javaFileStream = new java.io.RandomAccessFile(StringUtils.CreateJavaString(filename), "r");
			int size = (int)javaFileStream.length();
			javaFileStream.close();
			return size;
		}
		catch(java.lang.Exception except)
		{
			

			
			return -1;
		}
		
	
}


public static boolean FileExists ( String filename) {

		
		return new java.io.File(StringUtils.CreateJavaString(filename)).exists();
		
	
}


public static boolean FileDelete ( String filename) {

		
		return new java.io.File(StringUtils.CreateJavaString(filename)).delete();
		
	
}



/* One dimension array */
public static JavaBasicFileStream[] InstArrayJavaBasicFileStream(int size) {
	JavaBasicFileStream[] newArray = new JavaBasicFileStream[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new JavaBasicFileStream();
	return newArray; }

/* Two dimension array */
public static JavaBasicFileStream[][] InstArrayJavaBasicFileStream(int size1, int size2) {
	JavaBasicFileStream[][] newArray = new JavaBasicFileStream[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new JavaBasicFileStream[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new JavaBasicFileStream(); }
	return newArray; }

/* Three dimension array */
public static JavaBasicFileStream[][][] InstArrayJavaBasicFileStream(int size1, int size2, int size3) {
	JavaBasicFileStream[][][] newArray = new JavaBasicFileStream[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new JavaBasicFileStream[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new JavaBasicFileStream[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new JavaBasicFileStream(); } }
	return newArray; }

public JavaBasicFileStream () { 
}




}

