package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class KeyFrameSequence {

public static KeyFrameSequence Cast(Object o, KeyFrameSequence _) {
 return  (KeyFrameSequence)o; 
}


 final public static byte typeNumber = TypeIDOfType_KeyFrameSequence.v;
 final public static byte typeID = TypeIDOfType_KeyFrameSequence.w;
 public static final boolean supportsDynamicSerialization = false; public  KeyFrameSequence () {



}


public  KeyFrameSequence (short numKeys, byte bytesPerValue, byte pointPosition, byte valuesPerKey) {







 int valueSizeInBytes = (numKeys * bytesPerValue * valuesPerKey);




 short[] values = new short[FieldTimeValues + numKeys + ((valueSizeInBytes + 1) >> 1)];


	values[FieldKeysPerChannel] = numKeys;



values[FieldBytesPerValue] = bytesPerValue;
	values[FieldPointPosition] = pointPosition;
	values[FieldValuesPerKey] = valuesPerKey;	
	values[FieldSingleInterpolator] = Interpolator.LINEAR;
	values[FieldLoopingPeriod] = 0;
	values[FieldLastIndex] = -1;

	mValues = values;

}


public void destruct() {

	mValues = null;

}


public void GetObjectValue (int currentTimeMs, int[] buffer) {





	 short valuePerKey = mValues[FieldValuesPerKey];

	 short loopingPeriod = mValues[FieldLoopingPeriod];



	 int[] valueBuffer = mValueBuffer;


if(loopingPeriod != 0)
	{
		currentTimeMs = FlMath.Modulo(currentTimeMs, loopingPeriod);
	}

	 int index = GetKeyFrameIndex(currentTimeMs);


	GetKeyFrameValue(index, valueBuffer, 0);

	if(mValues[FieldSingleInterpolator] == Interpolator.LINEAR)
	{
		GetKeyFrameValue(index + 1, valueBuffer, 4);




 int correctedIndexA = GetCorrectedIndex(index);

			 int correctedIndexB = GetCorrectedIndex(index + 1);

			 int timeA = mValues[FieldTimeValues + correctedIndexA];

			 int timeB = mValues[FieldTimeValues + correctedIndexB];


			if(correctedIndexA > correctedIndexB)
			{
				if(currentTimeMs < timeB)
				{
					currentTimeMs += loopingPeriod;
				}

				timeB += loopingPeriod;
			}		

			 int timeDiff = timeB - timeA;
	

			if(timeDiff != 0)
			{
				
				 int roundingCorrector = FlMath.Absolute(timeDiff >> 1);


				for(int i = 0;i < valuePerKey;i ++)
				{
					 int temp = ((timeB - currentTimeMs) * valueBuffer[i]) + ((currentTimeMs - timeA) * valueBuffer[4 + i]);


					temp += (temp < 0) ? -roundingCorrector : roundingCorrector;


valueBuffer[i] = temp / timeDiff;
				}
			}











}


















for(int i = 0;i < valuePerKey;i ++)
	{
		buffer[i] = valueBuffer[i];
	}

}


public void SetKeyFrame (int index, short timeMs, int[] value) {





	
	mValues[FieldTimeValues + index] = timeMs;	

	for(int i = 0;i < mValues[FieldValuesPerKey];i ++)
	{
		value[i] >>= -mValues[FieldPointPosition];
	}

	SetKeyFrameValue(index, value);

}


public void SetKeyFrame (int index, short timeMs, F32[] value, int point) {



mValues[FieldTimeValues + index] = timeMs;
	 int[] convertedValues = new int[mValues[FieldValuesPerKey]];
	 int bitShift = point - mValues[FieldPointPosition];


	for(int i = 0;i < mValues[FieldValuesPerKey];i ++)
	{
		if(bitShift < 0)
		{
			convertedValues[i] = value[i].ToFixedPoint(mValues[FieldPointPosition]) << -bitShift;
		}
		else
		{
			convertedValues[i] = value[i].ToFixedPoint(mValues[FieldPointPosition]) >> bitShift;
		}
	}

	SetKeyFrameValue(index, convertedValues);




}


public byte GetInterpolator () {

	return  (byte)mValues[FieldSingleInterpolator];

}


public void SetInterpolator (byte interpolator) {

	mValues[FieldSingleInterpolator] = interpolator;

}


public boolean IsLooping() {
 return  mValues[FieldLoopingPeriod] != 0; 
}


public short GetPeriod() {
 return  mValues[FieldLoopingPeriod]; 
}


public void SetPeriod(short val) {
 mValues[FieldLoopingPeriod] = val; 
}


public KeyFrameSequence OnSerialize (Package p) {
	
	 short arrayLength = 0;


	 short[] valuesSerialized = mValues;































(arrayLength)= (p).SerializeIntrinsic(arrayLength);
	(valuesSerialized)= (p).SerializeIntrinsics(valuesSerialized, arrayLength);







{
		mValues = valuesSerialized;
	}

	return  this;

}


public int GetKeyFrameIndex (int currentTimeMs) {

	 short[] values = mValues;

	if(values[FieldLastIndex] != -1) 
	{
		 short currentIndex = values[FieldLastIndex];

		 short nextIndex = currentIndex < (values[FieldKeysPerChannel] - 1) ? (short)(currentIndex + 1) : (short)0;


		if(values[FieldTimeValues + currentIndex] <= currentTimeMs && (nextIndex == 0|| values[FieldTimeValues + nextIndex] > currentTimeMs))
		{
			return  currentIndex;
		}

		 short nextIndex2 = nextIndex < (values[FieldKeysPerChannel] - 1) ? (short)(nextIndex + 1) : (short)0;

		if(values[FieldTimeValues + nextIndex] <= currentTimeMs && (nextIndex2 == 0|| values[FieldTimeValues + nextIndex2] > currentTimeMs))
		{
			values[FieldLastIndex] = nextIndex;
			return  nextIndex;
		}
	}	
	
	 int index = values[FieldKeysPerChannel] >> 1;

	 int rspan = values[FieldKeysPerChannel] - 1;

	 int lspan = 0;


	
	while(rspan != lspan)
	{
		int size;

		 int time = values[FieldTimeValues + index];

		if(time < currentTimeMs)
		{
			lspan = index;
			size = (rspan - lspan) >> 1;
			index += (size > 0) ? size : 1;
		}
		else if(time > currentTimeMs)
		{
			rspan = index - 1;
			size = (rspan - lspan) >> 1;
			index = rspan - size;	
		}
		else
		{
			values[FieldLastIndex] = (short)index;
			return  index;
		}
	}

	
	if(lspan == 0&& values[FieldTimeValues] > currentTimeMs)
	{
		values[FieldLastIndex] = -1;
		
		return  values[FieldLoopingPeriod] != 0&& values[FieldLoopingPeriod] != currentTimeMs ? GetKeyFrameIndex(values[FieldLoopingPeriod]) : -1;
	}

	values[FieldLastIndex] = (short)lspan;
	return  lspan;

}


public void GetKeyFrameValue (int index, int[] buffer, int bufferStartIndex) {



 short[] values = mValues;
	 short keysPerChannel = values[FieldKeysPerChannel];

	 short bytesPerValue = values[FieldBytesPerValue];

	 short valuesPerKey = values[FieldValuesPerKey];

	 int valuesStartIndex = FieldTimeValues + keysPerChannel;


	index = GetCorrectedIndex(index) * bytesPerValue * valuesPerKey;



if(bytesPerValue > 1)
	{
		index = (index >> 1) + valuesStartIndex;


}
	


for(int i = 0;i < valuesPerKey;i ++)
	{
		 int internalValue = 0;








if(bytesPerValue == 2)
		{
			internalValue = values[index];
		}
		else
		{		

			
			internalValue = (byte)(values[valuesStartIndex + (index >> 1)] >> ((~index & 1) << 3));
		}

		index++;
		buffer[i + bufferStartIndex] = internalValue;
	}

}


public void SetKeyFrameValue (int arrayIndex, int[] buffer) {



 short[] values = mValues;
	 int startValuesIndex = FieldTimeValues + values[FieldKeysPerChannel];

	 int bytesPerValue = values[FieldBytesPerValue];


	arrayIndex *= (bytesPerValue * values[FieldValuesPerKey]);



if(bytesPerValue > 1)
	{
		arrayIndex = (arrayIndex >> 1) + startValuesIndex;


}



for(int i = 0;i < values[FieldValuesPerKey];i ++)
	{
		 int internalValue = buffer[i];

		







if(bytesPerValue == 2)
		{
			values[arrayIndex] = (short)internalValue;
		}
		else
		{

			 int index = startValuesIndex + (arrayIndex >> 1);

			values[index] = (short)((values[index] & (0x00FF<< ((arrayIndex & 1) << 3))) | ((internalValue & 0x00FF) << ((~arrayIndex & 1) << 3)));
		}
		
		arrayIndex++;
	}

}


public F32 GetTimeRatio (int currentTimeMs, int indexA, int indexB) {



	 short[] values = mValues;

	 short timeIndexA = values[FieldTimeValues + indexA];

	 int timeDiff = 0;


	if(indexB >= values[FieldKeysPerChannel])
	{
		if(values[FieldLoopingPeriod] != 0)
		{			
			timeDiff = (values[FieldLoopingPeriod] - timeIndexA) + values[FieldTimeValues];

			if(currentTimeMs < timeIndexA)
			{
				currentTimeMs += values[FieldLoopingPeriod];
			}
		}
	}	
	else
	{
		timeDiff = values[FieldTimeValues + indexB] - timeIndexA;
	}

	if(timeDiff == 0)
	{
		return  F32.One(16);
	}
	else
	{
		return  F32.FromInt(currentTimeMs - timeIndexA, 16).Div(timeDiff);
	}

}


public int GetCorrectedIndex (int index) {

	 int keysPerChannel = mValues[FieldKeysPerChannel];


	if(index < 0)
	{
		index = (mValues[FieldLoopingPeriod] != 0) ? keysPerChannel - 1 : 0;
	}
	else if(index >= keysPerChannel)
	{
		index = (mValues[FieldLoopingPeriod] != 0) ? 0 : keysPerChannel - 1;
	}

	return  index;

}


public final static byte FieldKeysPerChannel = 0;
public final static byte FieldValuesPerKey = 1;
public final static byte FieldBytesPerValue = 2;
public final static byte FieldPointPosition = 3;
public final static byte FieldSingleInterpolator = 4;
public final static byte FieldLoopingPeriod = 5;
public final static byte FieldLastIndex = 6;
public final static byte FieldTimeValues = 7;

public short[] mValues = null;
public static int[] mValueBuffer = new int[8];


/* One dimension array */
public static KeyFrameSequence[] InstArrayKeyFrameSequence(int size) {
	KeyFrameSequence[] newArray = new KeyFrameSequence[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new KeyFrameSequence();
	return newArray; }

/* Two dimension array */
public static KeyFrameSequence[][] InstArrayKeyFrameSequence(int size1, int size2) {
	KeyFrameSequence[][] newArray = new KeyFrameSequence[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new KeyFrameSequence[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new KeyFrameSequence(); }
	return newArray; }

/* Three dimension array */
public static KeyFrameSequence[][][] InstArrayKeyFrameSequence(int size1, int size2, int size3) {
	KeyFrameSequence[][][] newArray = new KeyFrameSequence[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new KeyFrameSequence[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new KeyFrameSequence[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new KeyFrameSequence(); } }
	return newArray; }



}

