package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


import java.io.*;



public class LibraryStream extends Stream {

public final static byte kSizeOfReadByte = 1;
public final static byte kSizeOfReadInt = 4;
public final static byte kSizeOfReadChar = 2;
public final static byte kSizeOfReadShort = 2;
public final static byte kEofValue = -1;

public  LibraryStream ( String fileName) {
mFileName = new String();


	Create(fileName);

}


public void destruct() {

	Close();

}


public static boolean FileExists ( String fileName) {

	 boolean fileIsFound = false;


	
	java.io.InputStream is = System.out.getClass().getResourceAsStream(StringUtils.CreateJavaString(fileName));
	
	if (is == null)
	{
		fileIsFound = false;
	}
	else
	{
		fileIsFound = true;

		try
		{
			is.close();
		}
		catch (Exception err)
		{
			err.printStackTrace();			
		}
	}

	

	return  fileIsFound;

}


public void Skip (int size) {

	SetPosition(GetPosition() + size);

}


public int Read (byte [] buffer, int offset, int size) {

	



	 int sizeToRead = size;

	 int endOffsetInBuffer = offset + size;


	do
	{
		 int remainingInSegment = mSizeOfCurrentSegment - mPositionInSegment;

		
		if(remainingInSegment <= 0)
		{
			CloseSegment();
			mCurrentSegment++;
			OpenSegment(mCurrentSegment);

			remainingInSegment = mSizeOfCurrentSegment;
		}

		 int sizeToReadInSegment = FlMath.Minimum(sizeToRead, remainingInSegment);

		

		try
		{	
			int bytesRead = 0;

			while (true)
			{
bytesRead += mInputStream.read(buffer, endOffsetInBuffer - sizeToRead + bytesRead, sizeToReadInSegment - bytesRead);

				if (bytesRead == sizeToReadInSegment) break;
				if (bytesRead < 0)
				{
					

throw new java.io.IOException();
					}
			}




}
		catch (Exception err)
		{
			

			
		}

		mPositionInSegment += sizeToReadInSegment;
		

		sizeToRead -= sizeToReadInSegment;
	}
	while(sizeToRead > 0);

	return  size;

}


public int Read (byte [] buffer, int size) {
 
	return  Read(buffer, GetPosition(), size); 

}


public int Write ( byte [] buffer, int size) {
 

	return  0;

}


public int ReadLong () {
	

	
	byte[] buffer = mBuffer;
	
	Read(buffer, 0, kSizeOfReadInt);
	return (int) (((buffer[0] & 0xff) << 24) | ((buffer[1] & 0xff) << 16) |
				   ((buffer[2] & 0xff) << 8)  |  (buffer[3] & 0xff));

}


public static int ReadLong (byte [] data, int index) {
	
	return (int) (((data[index] & 0xff) << 24) | ((data[index + 1] & 0xff) << 16) |
		((data[index + 2] & 0xff) << 8)  |  (data[index + 3] & 0xff));

}


public short ReadShort () {
	
	
	byte[] buffer = mBuffer;
	
	Read(buffer, 0, kSizeOfReadShort);
	return  (short)((buffer[0] << 8) | (buffer[1] & 0xff));

}


public byte ReadChar () {

	

return  (byte)ReadByte();
	
}


public byte ReadByte () {

	

	



	


	if(mPositionInSegment >= mSizeOfCurrentSegment)
	{
		CloseSegment();
		mCurrentSegment++;
		OpenSegment(mCurrentSegment);
	}

	

	byte[] buffer = mBuffer;

	try
	{

		while (true)
		{
int bytesRead = mInputStream.read(buffer, 0, kSizeOfReadByte);

			if (bytesRead >= kSizeOfReadByte) break;
			if (bytesRead < 0)
			{
				

throw new java.io.IOException();
				}
		}




}
	catch (Exception err)
	{
		

		
	}

	mPositionInSegment++;
	

	return  buffer[0];



}


public int GetSize () {
	
	return  mLibrarySize;

}


public void SetPosition (int offset) {

	 int size = GetSize();


	 int newSegment = 0;

	 int segmentSize = mSegmentSize;


	if(offset >= size) 
	{
		
		newSegment = (size - 1) / segmentSize; 
		offset = size - (newSegment * segmentSize);
	}
	else
	{
		newSegment = offset / segmentSize;
		offset %= segmentSize;
	}

	if((newSegment == mCurrentSegment) && (offset >= mPositionInSegment))
	{		
		offset -= mPositionInSegment;
	}
	else
	{
		mCurrentSegment = newSegment;
		CloseSegment();
		OpenSegment(mCurrentSegment); 
	}	

	 int skippedBytes = 0;

	 int bytesRead = -1;


	
	try
	{
		while ((skippedBytes < offset) &&
			  (bytesRead != 0))
		{
			bytesRead = (int)mInputStream.skip(offset - skippedBytes);
			skippedBytes += bytesRead;
		}
	}
	catch (Exception err)
	{
		mError = 1;
		err.printStackTrace();
	}
	

	mPositionInSegment += skippedBytes;

}


public int GetPosition () {

	return  mPositionInSegment + (mCurrentSegment * mSegmentSize);

}


public boolean IsEndOfFile () {

	return  GetPosition() == GetSize();

}


public boolean IsOpen () {

	
	return mInputStream != null;
	

}


public boolean IsValid () {

	
	return mInputStream != null;
	

}


public int GetLastError () {

	return  mError;

}


public void Close () {

	CloseSegment();
	





}


public void Create ( String fileName) {

	

mFileName.Assign(String.FromChar((byte)'/').Add(fileName).Add(String.FromChar((byte)'.')));

	

OpenSegment(0);
	if(IsOpen())
	{
		

		int segmentSize = 0;
		int librarySize = 0;

		
		
		mLibrarySize = 4096;
		mSizeOfCurrentSegment = mLibrarySize ;
		
		segmentSize = ReadLong();
		librarySize = ReadLong();
		mPositionInSegment += kSizeOfReadInt * 2;

		

		if((segmentSize == 0) || (librarySize < segmentSize))
		{
			segmentSize = librarySize;
		}

		mSizeOfCurrentSegment = segmentSize;

		





mLibrarySize = librarySize;
		mSegmentSize = segmentSize;

		SetPosition(0);
	}

}


public void CloseSegment () {



	
	
	try
	{	
		mInputStream.close();
	}
	catch(Exception err)
	{
		mError = 1;
		err.printStackTrace();
	}

	mInputStream = null;

	

}


public void OpenSegment (int segmentIndex) {

	
	
	int segmentSize = mSegmentSize;

	if (segmentSize > 0)
	{
		int nbOfCompleteSegments = mLibrarySize / segmentSize;
		mSizeOfCurrentSegment = (segmentIndex < nbOfCompleteSegments)? 
			(segmentSize):
			(mLibrarySize - nbOfCompleteSegments * segmentSize);
	}

	mPositionInSegment = 0;

	InputStream sysInputStream;
	




























sysInputStream = GetInputStreamOnSegment(segmentIndex);
		
	if (sysInputStream == null)
	{
		mInputStream = null;
		mError = 1;
		

		
	}
	else
	{
		mInputStream = sysInputStream;
		mError = 0;
	}
	
	

}


public InputStream GetInputStreamOnSegment (int segmentIndex) {


	 java.lang.String javaSegmentName = StringUtils.CreateJavaString(mFileName.Add(new String(segmentIndex)));
	
	

		
		
		
		if (javaSegmentName.charAt(0) == '/')
		{
			javaSegmentName = javaSegmentName.substring(1);
		}
		
		java.io.InputStream sysInputStream = null;
		
		try
		{
        	sysInputStream = FlAndroidApp.instance.getAssets().open(javaSegmentName);
        }
        catch (Exception e) 
        {
        	android.util.Log.e("Flight library error", "LibraryStream.GetInputStreamOnSegment: " + e);
        }
		
		
		return  sysInputStream;
	
	
















































































}



	public java.io.InputStream mInputStream;




public String mFileName;
public int mError;
public int mSegmentSize;
public int mLibrarySize;
public int mCurrentSegment;
public int mPositionInSegment;
public int mSizeOfCurrentSegment;
public int mCurrentDecompressionSegIndex;
public byte[] mBuffer = new byte[kSizeOfReadInt];




}

