package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class Palette {

public static Palette Cast(Object o, Palette _) {
 return  (Palette)o; 
}


 final public static byte typeNumber = TypeIDOfType_Palette.v;
 final public static byte typeID = TypeIDOfType_Palette.w;
 public static final boolean supportsDynamicSerialization = false; public  Palette () {
mPixelFormat = (PixelFormat.Undefined);



}


public  Palette (short numColors, int pixelFormat) {
mNumColors = (numColors);
mPixelFormat = (pixelFormat);


	UpdateAllocation();




}


public void destruct() {

	mColors = null;
	mColors = null;

}


public void InitializeToZero () {

	Memory.Set(mColors, 0, NumBytesInPalette());

}


public int NumBytesPerColor () {

		if (
		

mIsUseAlphaBlending ||
		false )
		{
			return  PixelFormat.GetBytesPerPixel(GetPixelFormat());
		}
		else 
		{
			return  BitmapImplementor.PNG_PALETTE_SIZE_PER_COLOR;
		}
	
}


public int NumBytesInPalette () {

		
		if (
		

mIsUseAlphaBlending ||
		false) 
		{
			return mNumColors * NumBytesPerColor();
		}
		else 
		{
			return mColors.length;
		}
		
	
}


public int NumBytesInFilledPalette () {

	return  PixelFormat.GetBytesPerPixel(mPixelFormat) * 256;

}


public short GetNumColors () {

		
		if (
		

mIsUseAlphaBlending ||
		false) 
		{
			return mNumColors;
		}
		else
		{
			return (short)((mColors.length - BitmapImplementor.PNG_CRC_OVERHEAD) / NumBytesPerColor());
		}
		
	
}


public int GetPixelFormat () {

		if (
		

mIsUseAlphaBlending ||
		false) 
		{
			return  mPixelFormat;
		}
		else
		{
			return  PixelFormat.RGB888;
		}
	
}


public boolean IsUseAlphaBlending() {
 return  mIsUseAlphaBlending; 
}


public void SetIsUseAlphaBlending(boolean isUseAlphaBlending) {
 mIsUseAlphaBlending = isUseAlphaBlending; 
}


public int GetJavaSizeOfPalette (short numColors) {

		return  (numColors * NumBytesPerColor()) + BitmapImplementor.PNG_CRC_OVERHEAD;
	
}


public void SetProperties (short numColors, int pixelFormat) {

	if((numColors != mNumColors) || (pixelFormat != mPixelFormat))
	{
		mNumColors = numColors;
		mPixelFormat = pixelFormat;
		UpdateAllocation();
	}

}


public Palette OnSerialize (Package p) {













(mIsUseAlphaBlending)= (p).SerializeIntrinsic(mIsUseAlphaBlending);
	(mNumColors)= (p).SerializeIntrinsic(mNumColors);

	if(p.IsReading())
	{
		
			if (
			

mIsUseAlphaBlending ||
			false )
			{
				 short newPixelFormat = 0;

				(newPixelFormat)= (p).SerializeIntrinsic(newPixelFormat);
				mPixelFormat = (int)((int)newPixelFormat & 0xFFFF);

				(mColors)= (p).SerializeIntrinsics(mColors, NumBytesInPalette());

				
				 int signature = 0;

				(signature)= (p).SerializeIntrinsic(signature);
			}
			else
			{
				
				(mColors)= (p).SerializeIntrinsics(mColors, GetJavaSizeOfPalette(mNumColors));
			}
		

















}
























































































return  this;

}


public byte[] GetData() {
 return  mColors; 
}


public void UpdateAllocation () {

	mColors = new byte[NumBytesInPalette()];;

}


public short mNumColors;
public int mPixelFormat;
public byte[] mColors = null;
public int[] mInflatedColors = null;
public int[] GetInflatedColors() {
 return  mInflatedColors; 
}


public void SetInflatedColors (short numColors, int pixelFormat, int [] newColors) {

	mNumColors = numColors;
	mPixelFormat = pixelFormat;
	mColors = null;
	mInflatedColors = newColors;

}


public boolean mIsUseAlphaBlending;
public Palette(short numColors)
{
	this(numColors, PixelFormat.RGB888);
}

/* One dimension array */
public static Palette[] InstArrayPalette(int size) {
	Palette[] newArray = new Palette[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new Palette();
	return newArray; }

/* Two dimension array */
public static Palette[][] InstArrayPalette(int size1, int size2) {
	Palette[][] newArray = new Palette[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Palette[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new Palette(); }
	return newArray; }

/* Three dimension array */
public static Palette[][][] InstArrayPalette(int size1, int size2, int size3) {
	Palette[][][] newArray = new Palette[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Palette[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new Palette[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new Palette(); } }
	return newArray; }



}

