package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class PixelFormat {

public final static int HAS_ALPHA_MASK = 0x8000;
public final static int ALPHA_FIRST_MASK = 0x4000;
public final static int IS_INDEXED_MASK = 0x2000;
public final static int BYTES_PER_PIXEL_MASK = 0x1E00;
public final static int ALPHA_BITS_MASK = 0x01E0;
public final static int DIFFERENTIATING_MASK_0 = 0x0000;
public final static int DIFFERENTIATING_MASK_1 = 0x0001;
public final static int DIFFERENTIATING_MASK_2 = 0x0002;
public final static int DIFFERENTIATING_MASK_3 = 0x0003;
public final static int DIFFERENTIATING_MASK_4 = 0x0004;
public final static int DIFFERENTIATING_MASK_5 = 0x0005;
public final static int DIFFERENTIATING_MASK_6 = 0x0006;
public final static int DIFFERENTIATING_MASK_7 = 0x0007;
public final static int DIFFERENTIATING_MASK_8 = 0x0008;

public final static int HAS_ALPHA_SHIFT = 15;
public final static int ALPHA_FIRST_SHIFT = 14;
public final static int IS_INDEXED_SHIFT = 13;
public final static int BYTES_PER_PIXEL_SHIFT = 9;
public final static int ALPHA_BITS_SHIFT = 5;
public final static int UNUSED_SHIFT = 0;

public final static int Undefined = 0x0000;
public final static int A8 = HAS_ALPHA_MASK | ALPHA_FIRST_MASK |                   ((1 << BYTES_PER_PIXEL_SHIFT) & BYTES_PER_PIXEL_MASK)  | ((8 << ALPHA_BITS_SHIFT) & ALPHA_BITS_MASK);
public final static int I8XRGB4444 = IS_INDEXED_MASK | ((1 << BYTES_PER_PIXEL_SHIFT) & BYTES_PER_PIXEL_MASK)  | ((0 << ALPHA_BITS_SHIFT) & ALPHA_BITS_MASK) | DIFFERENTIATING_MASK_0;
public final static int I8XRGB4444BigEndian = IS_INDEXED_MASK | ((1 << BYTES_PER_PIXEL_SHIFT) & BYTES_PER_PIXEL_MASK)  | ((0 << ALPHA_BITS_SHIFT) & ALPHA_BITS_MASK) | DIFFERENTIATING_MASK_1;
public final static int I8XRGB1555 = IS_INDEXED_MASK | ((1 << BYTES_PER_PIXEL_SHIFT) & BYTES_PER_PIXEL_MASK)  | ((0 << ALPHA_BITS_SHIFT) & ALPHA_BITS_MASK) | DIFFERENTIATING_MASK_2;
public final static int I8RGB565 = IS_INDEXED_MASK | ((1 << BYTES_PER_PIXEL_SHIFT) & BYTES_PER_PIXEL_MASK)  | ((0 << ALPHA_BITS_SHIFT) & ALPHA_BITS_MASK) | DIFFERENTIATING_MASK_3;
public final static int I8RGB888 = IS_INDEXED_MASK | ((1 << BYTES_PER_PIXEL_SHIFT) & BYTES_PER_PIXEL_MASK)  | ((0 << ALPHA_BITS_SHIFT) & ALPHA_BITS_MASK) | DIFFERENTIATING_MASK_4;
public final static int I8RGBA8888 = IS_INDEXED_MASK | ((1 << BYTES_PER_PIXEL_SHIFT) & BYTES_PER_PIXEL_MASK)  | ((0 << ALPHA_BITS_SHIFT) & ALPHA_BITS_MASK) | DIFFERENTIATING_MASK_5;
public final static int I8ARGB8888 = IS_INDEXED_MASK | ((1 << BYTES_PER_PIXEL_SHIFT) & BYTES_PER_PIXEL_MASK)  | ((0 << ALPHA_BITS_SHIFT) & ALPHA_BITS_MASK) | DIFFERENTIATING_MASK_6;
public final static int I8RGBA5658 = IS_INDEXED_MASK | ((1 << BYTES_PER_PIXEL_SHIFT) & BYTES_PER_PIXEL_MASK)  | ((0 << ALPHA_BITS_SHIFT) & ALPHA_BITS_MASK) | DIFFERENTIATING_MASK_7;
public final static int I8RGBA5551 = IS_INDEXED_MASK | ((1 << BYTES_PER_PIXEL_SHIFT) & BYTES_PER_PIXEL_MASK)  | ((0 << ALPHA_BITS_SHIFT) & ALPHA_BITS_MASK) | DIFFERENTIATING_MASK_8;
public final static int ARGB4444 = HAS_ALPHA_MASK | ALPHA_FIRST_MASK |                   ((2 << BYTES_PER_PIXEL_SHIFT) & BYTES_PER_PIXEL_MASK) | ((4 << ALPHA_BITS_SHIFT) & ALPHA_BITS_MASK) | DIFFERENTIATING_MASK_0;
public final static int ARGB4444BigEndian = HAS_ALPHA_MASK | ALPHA_FIRST_MASK |                   ((2 << BYTES_PER_PIXEL_SHIFT) & BYTES_PER_PIXEL_MASK) | ((4 << ALPHA_BITS_SHIFT) & ALPHA_BITS_MASK) | DIFFERENTIATING_MASK_1;
public final static int XRGB4444 = ((2 << BYTES_PER_PIXEL_SHIFT) & BYTES_PER_PIXEL_MASK) | ((4 << ALPHA_BITS_SHIFT) & ALPHA_BITS_MASK) | DIFFERENTIATING_MASK_0;
public final static int XRGB4444BigEndian = ((2 << BYTES_PER_PIXEL_SHIFT) & BYTES_PER_PIXEL_MASK) | ((4 << ALPHA_BITS_SHIFT) & ALPHA_BITS_MASK) | DIFFERENTIATING_MASK_1;
public final static int XRGB1555 = ((2 << BYTES_PER_PIXEL_SHIFT) & BYTES_PER_PIXEL_MASK) | ((0 << ALPHA_BITS_SHIFT) & ALPHA_BITS_MASK) | DIFFERENTIATING_MASK_0;
public final static int XRGBA15558 = HAS_ALPHA_MASK |										((3 << BYTES_PER_PIXEL_SHIFT) & BYTES_PER_PIXEL_MASK) | ((8 << ALPHA_BITS_SHIFT) & ALPHA_BITS_MASK) | DIFFERENTIATING_MASK_0;
public final static int RGBA4444 = HAS_ALPHA_MASK |										((2 << BYTES_PER_PIXEL_SHIFT) & BYTES_PER_PIXEL_MASK) | ((4 << ALPHA_BITS_SHIFT) & ALPHA_BITS_MASK);
public final static int RGB565 = ((2 << BYTES_PER_PIXEL_SHIFT) & BYTES_PER_PIXEL_MASK) | ((0 << ALPHA_BITS_SHIFT) & ALPHA_BITS_MASK) | DIFFERENTIATING_MASK_1;
public final static int RGBA5658 = HAS_ALPHA_MASK |										((3 << BYTES_PER_PIXEL_SHIFT) & BYTES_PER_PIXEL_MASK) | ((8 << ALPHA_BITS_SHIFT) & ALPHA_BITS_MASK) | DIFFERENTIATING_MASK_1;
public final static int RGB888 = ((3 << BYTES_PER_PIXEL_SHIFT) & BYTES_PER_PIXEL_MASK) | ((0 << ALPHA_BITS_SHIFT) & ALPHA_BITS_MASK);
public final static int RGBA5551 = HAS_ALPHA_MASK |                                      ((2 << BYTES_PER_PIXEL_SHIFT) & BYTES_PER_PIXEL_MASK) | ((1 << ALPHA_BITS_SHIFT) & ALPHA_BITS_MASK);
public final static int RGBA8888 = HAS_ALPHA_MASK |                                      ((4 << BYTES_PER_PIXEL_SHIFT) & BYTES_PER_PIXEL_MASK) | ((8 << ALPHA_BITS_SHIFT) & ALPHA_BITS_MASK);
public final static int ARGB8888 = HAS_ALPHA_MASK | ALPHA_FIRST_MASK |                   ((4 << BYTES_PER_PIXEL_SHIFT) & BYTES_PER_PIXEL_MASK) | ((8 << ALPHA_BITS_SHIFT) & ALPHA_BITS_MASK)	;

public static int GetBytesPerPixel (int value) {

	return  ((value & BYTES_PER_PIXEL_MASK) >> BYTES_PER_PIXEL_SHIFT);

}


public static int GetBitsPerPixel (int value) {

	return  ((value & BYTES_PER_PIXEL_MASK) >> BYTES_PER_PIXEL_SHIFT) << 3;

}


public static int GetColorBytesPerPixel (int value) {

	 int numColorBits = (((value & BYTES_PER_PIXEL_MASK) >> BYTES_PER_PIXEL_SHIFT) << 3) - ((value & ALPHA_BITS_MASK) >> ALPHA_BITS_SHIFT);

	return  ((numColorBits - 1) >> 3) + 1;

}


public static int GetColorBitsPerPixel (int value) {

	return  (((value & BYTES_PER_PIXEL_MASK) >> BYTES_PER_PIXEL_SHIFT) << 3) - ((value & ALPHA_BITS_MASK) >> ALPHA_BITS_SHIFT);	

}


public static boolean HasAlpha (int value) {

	return  (value & HAS_ALPHA_MASK) != 0;

}


public static boolean HasAlphaInPalette (int value) {

	boolean hasAlpha;


	switch(value)
	{
	case I8RGBA8888 :
	case I8ARGB8888 :
	case I8RGBA5658 :
	case I8RGBA5551 :
		hasAlpha = true;
		break;
	default : 
		hasAlpha = false;
	}

	return  hasAlpha;

}


public static boolean IsIndexed (int value) {

	return  (value & IS_INDEXED_MASK) != 0;

}



/* One dimension array */
public static PixelFormat[] InstArrayPixelFormat(int size) {
	PixelFormat[] newArray = new PixelFormat[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new PixelFormat();
	return newArray; }

/* Two dimension array */
public static PixelFormat[][] InstArrayPixelFormat(int size1, int size2) {
	PixelFormat[][] newArray = new PixelFormat[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new PixelFormat[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new PixelFormat(); }
	return newArray; }

/* Three dimension array */
public static PixelFormat[][][] InstArrayPixelFormat(int size1, int size2, int size3) {
	PixelFormat[][][] newArray = new PixelFormat[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new PixelFormat[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new PixelFormat[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new PixelFormat(); } }
	return newArray; }

public PixelFormat () { 
}




}

