package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class Selection extends Viewport {

public static Selection Cast(Object o, Selection _) {
 return  (Selection)o; 
}


 final public static byte typeNumber = TypeIDOfType_Selection.v;
 final public static byte typeID = TypeIDOfType_Selection.w;
 public static final boolean supportsDynamicSerialization = true; public byte GetTypeID() {
 return  typeID; 
}


public static Class AsClass() {
 return  null; 
}


public final static byte releasedState = 0;
public final static byte pushedState = 1;
public final static byte pushedRepeatState = 2;
public final static byte canceledState = 3;

public final static byte unselectedState = 0;
public final static byte selectedState = 1;

public final static byte disabledState = 0;
public final static byte enabledState = 1;

public  Selection () {
mHotKey = (Key.NO_KEY);



	SetPassThrough(false);

}


public void SetSelectedState (boolean selected, boolean propagateSelectionInParent) {

	SetSelectedState(selected, propagateSelectionInParent, true);

}


public boolean GetSelectedState() {
 return  mSelected; 
}


public void SetEnabledState (boolean enabled) {

	if(enabled != mEnabled)
	{

		if(!enabled)
		{
			CancelPush();
			SetSelectedState(false);
		}
mEnabled = enabled;
		SendMsg(this, enabledMsg, enabled ? enabledState : disabledState);
		if(!mEnabled && DescendentOrSelfHasFocus()) TakeFocus(); 
	}

}


public boolean GetEnabledState() {
 return  mEnabled; 
}


public void CancelPush () {

	if(mPushed)
	{
		SetPushed(false);
		SendMsg(this, pushedMsg, canceledState);
	}

}


public void SetPushedState (boolean onDown) {


	if(GetEnabledState())
{
		if(onDown != mPushed)
		{
			SetPushed(onDown);
			SendMsg(this, pushedMsg, onDown ? pushedState : releasedState);
		}
	}

}


public boolean GetPushedState() {
 return  mPushed; 
}


public void SetHotKey(int hotkey) {
 mHotKey = (byte)hotkey; 
}


public int GetHotKey() {
 return  (int)mHotKey; 
}


public void SetCommand(byte command) {
 mCommand = command; 
}


public byte GetCommand() {
 return  mCommand; 
}


public void SetForwardFocus(Component forwardFocus) {
 mForwardFocus = forwardFocus; 
}


public Component ForwardFocus () {

	if(mEnabled && mForwardFocus != null) return  mForwardFocus;
	return  this;

}


public void OnSerialize (Package p) {

	super.OnSerialize(p);

	(mForwardFocus)= mForwardFocus.Cast((p).SerializePointer((mForwardFocus).typeNumber, (mForwardFocus).supportsDynamicSerialization, false), null);
	(mEnabled)= (p).SerializeIntrinsic(mEnabled);
	(mHotKey)= (p).SerializeIntrinsic(mHotKey);
	(mCommand)= (p).SerializeIntrinsic(mCommand);


	

{
			(mSendRepeatOnPush)= (p).SerializeIntrinsic(mSendRepeatOnPush);
		}

}


public boolean OnDefaultMsg (Component source, int msg, int intParam) {
	
	if ((msg >= keyUpMsg) &&
	   (msg <= keyDownOrRepeatMsg) &&
	   (((int)intParam) == Key.SELECT))
	{
		SetPushedState(msg != keyUpMsg);
		return  true;
	}


	switch(msg)
	{
	case penDownMsg :
	case penDragMsg :
		OnPenDown();
		return  true;
	case penUpMsg :
		OnPenUp();
		return  true;
	case penDragOutMsg :
	case penMgrDeactivatedMsg :
		OnPenDragOut();
	    return  true;
	default :
	    break;
	}
return  super.OnDefaultMsg(source, msg, intParam);

}


public void OnTime (int totalTime, int deltaTime) {

	mTimeSinceLastRepeat += deltaTime;
	if(mTimeSinceLastRepeat > 150)
	{
		SendMsg(this, pushedMsg, pushedRepeatState);
		mTimeSinceLastRepeat = 0;
	}

}


public void SetSendRepeatOnPush (boolean repeatOnPush) {

	mSendRepeatOnPush = repeatOnPush;
	SetPushed(mPushed);

}


public boolean GetSendRepeatOnPush () {

	return  mSendRepeatOnPush;

}


public void SetSelectedState (boolean selected, boolean propagateSelectionInParent, boolean isFinalState) {


	if(GetEnabledState())
{
		if(selected != mSelected)
		{
			mSelected = selected;
			SendMsg(this, selectedMsg, selected ? selectedState : unselectedState);
		}

		
		if(selected && propagateSelectionInParent)
		{
			SendMsg(this, synchronizeSelectorMsg, isFinalState ? Selector.finalState : Selector.intermediateState);
		}
	}

}


public void SetPushed (boolean isPushed) {

	mPushed = isPushed;


	if(mSendRepeatOnPush)
	{	
		if(isPushed)
		{
			mTimeSinceLastRepeat = -(500- 150);
			RegisterInGlobalTime();
		}
		else
		{
			UnRegisterInGlobalTime();
		}
	}

}


public void OnPenUp () {

	if(GetEnabledState() && GetSelectedState())
	{
		SetPushedState(false);
	}

}


public void OnPenDown () {

	if(GetEnabledState())
	{
		SetSelectedState(true, true);
		SetPushedState(true);
	}

}


public void OnPenDragOut () {

	CancelPush();

}


public boolean mEnabled;
public boolean mSelected;
public boolean mPushed;
public byte mHotKey;
public byte mCommand;
public Component mForwardFocus;
public boolean mSendRepeatOnPush;
public int mTimeSinceLastRepeat;
public void SetSelectedState(boolean selected)
{
	SetSelectedState(selected, false);
}

/* One dimension array */
public static Selection[] InstArraySelection(int size) {
	Selection[] newArray = new Selection[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new Selection();
	return newArray; }

/* Two dimension array */
public static Selection[][] InstArraySelection(int size1, int size2) {
	Selection[][] newArray = new Selection[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Selection[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new Selection(); }
	return newArray; }

/* Three dimension array */
public static Selection[][][] InstArraySelection(int size1, int size2, int size3) {
	Selection[][][] newArray = new Selection[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Selection[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new Selection[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new Selection(); } }
	return newArray; }



}

