package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class Selector extends Scroller {

public static Selector Cast(Object o, Selector _) {
 return  (Selector)o; 
}


 final public static byte typeNumber = TypeIDOfType_Selector.v;
 final public static byte typeID = TypeIDOfType_Selector.w;
 public static final boolean supportsDynamicSerialization = true; public byte GetTypeID() {
 return  typeID; 
}


public static Class AsClass() {
 return  null; 
}


public  Selector () {
super();
mCurrentSelectionIndex = (-1);
mLastUpdatedSelectionIndex = (-1);
mSkipDisabledSelections = (true);


	
	mIsVertical = false;

}


public  Selector (int maxNumElements) {
super(maxNumElements);
mCurrentSelectionIndex = (-1);
mSkipDisabledSelections = (true);


	
	mIsVertical = false;

}


public boolean OnDefaultMsg (Component source, int msg, int intParam) {

	if(synchronizeSelectorMsg == msg)
	{
		for(int i = 0;i < GetNumElements();++i)
		{
			 Selection child = GetSelectionAt(i);
			if(child.IsSelfOrAncestorOf(source))
			{
				SetSingleSelection(i, mTakeFocusOnSync);
				SendMsg(this, scrollerUpdatedMsg, intParam);
				i = GetNumElements(); 
			}
		}
	}

	return  super.OnDefaultMsg(source, msg, intParam);

}


public void SetSelectionAt (int index, Selection selection) {

	super.SetElementAt(index, selection);

	
	if(mCurrentSelectionIndex == index)
	{
		((Selection)mElements[mCurrentSelectionIndex]).SetSelectedState(true);
	}

}


public Selection GetSelectionAt(int index) {
 return  (Selection)super.GetElementAt(index); 
}


public int GetSingleSelection() {
 return  mCurrentSelectionIndex; 
}


public void SetSingleSelection (int selectionIndex, boolean takeFocus, boolean propagateSelectionInParent) {

	SetSingleSelection(selectionIndex, takeFocus, propagateSelectionInParent, true);

}


public void SetLooping(boolean looping) {
 mLooping = looping;
							
}


public boolean GetLooping() {
 return  mLooping; 
}


public void SetNumSelections(int numSelections) {
 mNumElements = numSelections; 
}


public int GetNumSelections() {
 return  mNumElements; 
}


public void SetSkipDisabledSelection(boolean isDisabled) {
 mSkipDisabledSelections = isDisabled; 
}


public void SetTakeFocusOnSync(boolean takeFocusOnSync) {
 mTakeFocusOnSync = takeFocusOnSync; 
}


public void OnSerialize (Package p) {

	super.OnSerialize(p);

	 int selectionCurr = 0;

	if(p.IsReading())
	{
		(selectionCurr)= (p).SerializeIntrinsic(selectionCurr);		
	}
	else
	{
		(mCurrentSelectionIndex)= (p).SerializeIntrinsic(mCurrentSelectionIndex);
	}

	(mSkipDisabledSelections)= (p).SerializeIntrinsic(mSkipDisabledSelections);
	(mLooping)= (p).SerializeIntrinsic(mLooping);
	(mTakeFocusOnSync)= (p).SerializeIntrinsic(mTakeFocusOnSync);
	

if(p.IsReading())
	{
		if(selectionCurr >= 0)
		{
			SetSingleSelection(selectionCurr);
		}
	}

}


public Component ForwardFocus () {

	if(GetSingleSelection() == -1)
	{
		return  this;
	}
	return  GetElementAt(GetSingleSelection()).ForwardFocus();

}


public void UpdateArrowsEnabledState () {

	if(mNextArrow != null)
	{
		if(!mLooping)
		{

			 int currentSelectionIndex = mCurrentSelectionIndex;

			 int lastElementsIndex = mNumElements - 1;


			 int lastEnabledSelectionIndex = -1;

			 int firstEnabledSelectionIndex = -1;


			for(int i = 0;i < mNumElements;i ++)
			{
				if((firstEnabledSelectionIndex == -1) && ((Selection)mElements[i]).GetEnabledState())
				{
					firstEnabledSelectionIndex = i;
				}

				if((lastEnabledSelectionIndex == -1) && ((Selection)mElements[lastElementsIndex - i]).GetEnabledState())
				{
					lastEnabledSelectionIndex = lastElementsIndex - i;
				}

				if((firstEnabledSelectionIndex | lastEnabledSelectionIndex) != -1) 
				{
					break;
				}
			}
	
			mNextArrow.SetEnabledState(currentSelectionIndex < lastEnabledSelectionIndex);
			mPreviousArrow.SetEnabledState(currentSelectionIndex > firstEnabledSelectionIndex);
		}
		else
		{
			mNextArrow.SetEnabledState(true);
			mPreviousArrow.SetEnabledState(true);
		}
	}

}


public void OnScrollEvent (int advance, boolean updateSelection) {

	
	 int currentSelectionIndex = mCurrentSelectionIndex;

	 int newSelectionIndex = currentSelectionIndex;

	 int numSelections = mNumElements;

	 boolean looping = mLooping;

	 boolean skipDisabledSelections = mSkipDisabledSelections;


	while(true)
	{
		newSelectionIndex += advance;
		 int unloopedNewSelectionIndex = newSelectionIndex;

		if(newSelectionIndex < 0) newSelectionIndex = numSelections - 1;
		if(newSelectionIndex >= numSelections) newSelectionIndex = 0;

		if(looping) 
		{
			
			if(newSelectionIndex == currentSelectionIndex)
			{
				break;
			}
		}
		else
		{
			
			if(newSelectionIndex != unloopedNewSelectionIndex) 
			{
				newSelectionIndex = unloopedNewSelectionIndex - advance;

				if(skipDisabledSelections && !((Selection)mElements[newSelectionIndex]).GetEnabledState())
				{
					newSelectionIndex = mCurrentSelectionIndex;
				}

				break;
			}
		}
		if(skipDisabledSelections && !((Selection)mElements[newSelectionIndex]).GetEnabledState())
		{
			continue;
		}
		break;
	}

	if(updateSelection)
	{
		if(mLastUpdatedSelectionIndex != mCurrentSelectionIndex)
		{
			mCurrentSelectionIndex = mLastUpdatedSelectionIndex;
		}

		SetSingleSelection(newSelectionIndex, true, true, false);
	}
	else
	{
		mCurrentSelectionIndex = newSelectionIndex;
	}

}


public boolean IsAppropriateHotkey (int msg, int key) {

	
	for(int selectionIndex = 0;selectionIndex < mNumElements;selectionIndex ++)
	{
		 Selection selection = (Selection)mElements[selectionIndex];
		if((selection.GetEnabledState() || !mSkipDisabledSelections) && key == selection.GetHotKey())
		{
			SetSingleSelection(selectionIndex, true, true, true);
			selection.SetPushedState(msg != Component.keyUpMsg);
			return  true;
		}
	}

	return  false;

}


public void SetSingleSelection (int selectionIndex, boolean takeFocus, boolean propagateSelectionInParent, boolean isFinalState) {



	 int oldSelectionIndex = mCurrentSelectionIndex;







mCurrentSelectionIndex = selectionIndex;

	
	if((oldSelectionIndex >= 0) && (oldSelectionIndex != selectionIndex))
	{
		((Selection)mElements[oldSelectionIndex]).SetSelectedState(false);
	}

	
	 Selection newSelection = (Selection)mElements[selectionIndex];







































mScrollerViewport.ChangeOffsetToShow(newSelection, false);
newSelection.SetSelectedState(true, propagateSelectionInParent, isFinalState);

	
	UpdateArrowsEnabledState();

	if(takeFocus)
	{
		newSelection.TakeFocus();
	}

	mLastUpdatedSelectionIndex = mCurrentSelectionIndex;

}


public int mCurrentSelectionIndex;
public int mLastUpdatedSelectionIndex;
public boolean mSkipDisabledSelections;
public boolean mLooping;
public boolean mTakeFocusOnSync;
public void SetSingleSelection(int selectionIndex)
{
	SetSingleSelection(selectionIndex, false);
}
public void SetSingleSelection(int selectionIndex, boolean takeFocus)
{
	SetSingleSelection(selectionIndex, takeFocus, false);
}
public void OnScrollEvent(int advance)
{
	OnScrollEvent(advance, true);
}

/* One dimension array */
public static Selector[] InstArraySelector(int size) {
	Selector[] newArray = new Selector[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new Selector();
	return newArray; }

/* Two dimension array */
public static Selector[][] InstArraySelector(int size1, int size2) {
	Selector[][] newArray = new Selector[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Selector[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new Selector(); }
	return newArray; }

/* Three dimension array */
public static Selector[][][] InstArraySelector(int size1, int size2, int size3) {
	Selector[][][] newArray = new Selector[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Selector[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new Selector[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new Selector(); } }
	return newArray; }



}

