package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class Slider extends Viewport {

public static Slider Cast(Object o, Slider _) {
 return  (Slider)o; 
}


 final public static byte typeNumber = TypeIDOfType_Slider.v;
 final public static byte typeID = TypeIDOfType_Slider.w;
 public static final boolean supportsDynamicSerialization = true; public byte GetTypeID() {
 return  typeID; 
}


public static Class AsClass() {
 return  null; 
}


public final static byte inactiveState = 0;
public final static byte activeState = 1;

public  Slider () {
mMaxValue = (255);
mStepSize = (1);




SetPassThrough(false);

}


public  Slider (int cMinValue, int cMaxValue, int cCurrValue, int cStepSize, boolean cIsVertical) {
mMinValue = (cMinValue);
mMaxValue = (cMaxValue);
mCurrValue = (cCurrValue);
mStepSize = (cStepSize);
mIsVertical = (cIsVertical);






SetPassThrough(false);

}


public void destruct() {
 
}


public void OnSerialize (Package p) {

	super.OnSerialize(p);

	(mMinValue)= (p).SerializeIntrinsic(mMinValue);
	(mMaxValue)= (p).SerializeIntrinsic(mMaxValue);
	(mCurrValue)= (p).SerializeIntrinsic(mCurrValue);
	(mStepSize)= (p).SerializeIntrinsic(mStepSize);
	(mIsVertical)= (p).SerializeIntrinsic(mIsVertical);

}


public int GetMinValue() {
 return  mMinValue; 
}


public int GetMaxValue() {
 return  mMaxValue; 
}


public int GetCurrValue() {
 return  mCurrValue; 
}


public int GetStepSize() {
 return  mStepSize; 
}


public void SetMinValue (int pMinValue) {
 


mMinValue = pMinValue; 
	if(mCurrValue < mMinValue)
	{
		mCurrValue = mMinValue;
	}




}


public void SetMaxValue (int pMaxValue) {
 


mMaxValue = pMaxValue;
	if(mCurrValue > mMaxValue)
	{
		mCurrValue = mMaxValue;
	}




}


public void SetStepSize (int pStepSize) {


	mStepSize = pStepSize;

}


public void SetCurrValue (int pCurrValue) {


	if(pCurrValue != mCurrValue)
	{
		mCurrValue = pCurrValue; 
		SendMsg(this, slideMsg, mCurrValue);
	}

}


public void SetVertical(boolean isVertical) {
 mIsVertical = isVertical; 
}


public boolean IsVertical() {
 return  mIsVertical; 
}


public void ChangeCurrentValue (boolean increment) {


	if(increment && mCurrValue < mMaxValue)
	{
		mCurrValue += mStepSize;
		if(mCurrValue > mMaxValue)
		{
			mCurrValue = mMaxValue;
	  	}
	  	SendMsg(this, slideMsg, mCurrValue);
	}
	else if(!increment && mCurrValue > mMinValue)
	{
		mCurrValue -= mStepSize;
		if(mCurrValue < mMinValue)
		{
			mCurrValue = mMinValue;
		}
		SendMsg(this, slideMsg, mCurrValue);
	}

}


public void ChangeCurrentState () {

	mIsActive = !mIsActive;
	SendMsg(this, slideStateMsg, (mIsActive ? activeState : inactiveState));

}


public boolean OnDefaultMsg (Component source, int msg, int intParam) {



	switch(msg)
	{
	case penDownMsg :
	case penDragMsg :
		OnPenDown(FlPenManager.GetPenPosition(intParam));
		return  true;
	case penUpMsg :
	case penDragOutMsg :
		OnPenUp();
		return  true;	
	default :
		break;
	}
if(msg == Component.keyDownOrRepeatMsg && OnKeyDownOrRepeat(intParam))
	{
		return  true;
	}

	return  super.OnDefaultMsg(source, msg, intParam);


}


public boolean OnKeyDownOrRepeat (int intParam) {

	 int advance = 0;

	 int key = (int)intParam;


	if(key == Key.LEFT) advance = -1;
	else if(key == Key.RIGHT) advance = 1;




if(advance != 0)
	{
		ChangeCurrentValue(advance > 0);
		return  true;
	}
	return  false;

}


public void OnPenUp () {

	if(mIsActive)
	{
		ChangeCurrentState();
	}
	
	



}


public void OnPenDown ( Vector2_short ptIn) {

	if(!mIsActive)
	{
		ChangeCurrentState();
	}

	




SetValueRelativeToRect(ptIn);

}


public void SetValueRelativeToRect ( Vector2_short absoluteCoord) {

	 int minValue = mMinValue;

	 int maxValue = mMaxValue;

	 int stepSize = mStepSize;



 Vector2_short relativeCoord = new Vector2_short(GetRelativeCoord(absoluteCoord));


	 int relevantCoord = IsVertical() ? relativeCoord.GetY() : relativeCoord.GetX();

	 int relevantSize = IsVertical() ? GetRectHeight() : GetRectWidth();

	relevantSize--;  

	 int valueRange = maxValue - minValue;

	 int wantedValue = (relevantCoord * valueRange / relevantSize) + minValue;


	 int offFromStepByValue = FlMath.Modulo(wantedValue - minValue, stepSize);


	if(0!= offFromStepByValue)
	{
		 int lowerBound = wantedValue - offFromStepByValue;

		 int upperBound = lowerBound + stepSize;

		 boolean isLowerBoundNearer = offFromStepByValue <= (stepSize / 2);


		if(lowerBound < minValue)
		{
			lowerBound = minValue;
			isLowerBoundNearer = true;
		}

		if(upperBound > maxValue)
		{
			upperBound = maxValue;
			isLowerBoundNearer = false;
		}




		if(isLowerBoundNearer)
		{
			wantedValue = lowerBound;
		}
		else
		{
			wantedValue = upperBound;
		}
	}
	
	SetCurrValue(wantedValue);

}


public int GetInvalidValue () {
 

	return  mMinValue - 1;

}


public int mMinValue;
public int mMaxValue;
public int mCurrValue;
public int mStepSize;
public boolean mIsVertical;
public boolean mIsActive;

/* One dimension array */
public static Slider[] InstArraySlider(int size) {
	Slider[] newArray = new Slider[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new Slider();
	return newArray; }

/* Two dimension array */
public static Slider[][] InstArraySlider(int size1, int size2) {
	Slider[][] newArray = new Slider[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Slider[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new Slider(); }
	return newArray; }

/* Three dimension array */
public static Slider[][][] InstArraySlider(int size1, int size2, int size3) {
	Slider[][][] newArray = new Slider[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Slider[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new Slider[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new Slider(); } }
	return newArray; }



}

