package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class Sphere {

public static Sphere Cast(Object o, Sphere _) {
 return  (Sphere)o; 
}


 final public static byte typeNumber = TypeIDOfType_Sphere.v;
 final public static byte typeID = TypeIDOfType_Sphere.w;
 public static final boolean supportsDynamicSerialization = false; public Sphere () {
center = new FVec3T_F32();
radius = new F32();
radiusSquared = new F32();


}


public  Sphere ( FVec3T_F32 parCenter, F32 parRadius) {
center = new FVec3T_F32(parCenter);
radius = new F32(parRadius);
radiusSquared = new F32(parRadius.DecreasePrecision(8).Square(8));



}


public  Sphere ( Sphere other) {
center = new FVec3T_F32(other.GetCenter());
radius = new F32(other.GetRadius());
radiusSquared = new F32(other.GetRadius().DecreasePrecision(8).Square(8));



}


public void SetCenter ( FVec3T_F32 parCenter) {

  center.Assign(parCenter);

}


public  FVec3T_F32 GetCenter () {

  return  center;

}


public void SetRadius (F32 parRadius) {

  radius = parRadius;
  radiusSquared = radius.DecreasePrecision(8).Square(8);

}


public F32 GetRadius () {

  return  radius;

}


public F32 GetRadiusSquared () {

  return  radiusSquared;

}


public boolean Contains ( FVec3T_F32 point) {

 return  (point.Sub(center)).DecreasePrecision(8).LengthSquared(8).LessOrEqual(radiusSquared);

}


public boolean Intersects ( Box3 box) {

	 F32 distanceSquared = new F32(F32.Zero(8));


	if(center.x.GreaterThan(box.maxCorner.x))
	{
		 F32 deltaX = new F32(center.x.Sub(box.maxCorner.x));

		distanceSquared = distanceSquared.Add(deltaX.DecreasePrecision(8).Square(8));
	}
	else if(center.x.LessThan(box.minCorner.x))
	{
		 F32 deltaX = new F32(center.x.Sub(box.minCorner.x));

		distanceSquared = distanceSquared.Add(deltaX.DecreasePrecision(8).Square(8));
	}

	if(center.y.GreaterThan(box.maxCorner.y))
	{
		 F32 deltaY = new F32(center.y.Sub(box.maxCorner.y));

		distanceSquared = distanceSquared.Add(deltaY.DecreasePrecision(8).Square(8));
	}
	else if(center.y.LessThan(box.minCorner.y))
	{
		 F32 deltaY = new F32(center.y.Sub(box.minCorner.y));

		distanceSquared = distanceSquared.Add(deltaY.DecreasePrecision(8).Square(8));
	}
	if(center.z.GreaterThan(box.maxCorner.z))
	{
		 F32 deltaZ = new F32(center.z.Sub(box.maxCorner.z));

		distanceSquared = distanceSquared.Add(deltaZ.DecreasePrecision(8).Square(8));
	}
	else if(center.z.LessThan(box.minCorner.z))
	{
		 F32 deltaZ = new F32(center.z.Sub(box.minCorner.z));

		distanceSquared = distanceSquared.Add(deltaZ.DecreasePrecision(8).Square(8));
	}

	return  distanceSquared.LessOrEqual(radiusSquared);

}


public boolean IntersectsExtension ( Box3 box, FVec3T_F32 outSpherePt, FVec3T_F32 outBoxPt, F32 sphereCenterToBoxdistanceSquared, FVec3T_F32 outAxis, F32 inEpsilon) {

	 FVec3T_F32 v = new FVec3T_F32(FVec3T_F32.Zero(16));
 
	sphereCenterToBoxdistanceSquared = F32.Zero(16);

	if(center.x.GreaterThan(box.maxCorner.x))
	{
		v.x = center.x.Sub(box.maxCorner.x);
		sphereCenterToBoxdistanceSquared = sphereCenterToBoxdistanceSquared.Add(v.x.Square(16));
	}
	else if(center.x.LessThan(box.minCorner.x))
	{
		v.x = center.x.Sub(box.minCorner.x);
		sphereCenterToBoxdistanceSquared = sphereCenterToBoxdistanceSquared.Add(v.x.Square(16));
	}

	if(center.y.GreaterThan(box.maxCorner.y))
	{
		v.y = center.y.Sub(box.maxCorner.y);
		sphereCenterToBoxdistanceSquared = sphereCenterToBoxdistanceSquared.Add(v.y.Square(16));
	}
	else if(center.y.LessThan(box.minCorner.y))
	{
		v.y = center.y.Sub(box.minCorner.y);
		sphereCenterToBoxdistanceSquared = sphereCenterToBoxdistanceSquared.Add(v.y.Square(16));
	}

	if(center.z.GreaterThan(box.maxCorner.z))
	{
		v.z = center.z.Sub(box.maxCorner.z);
		sphereCenterToBoxdistanceSquared = sphereCenterToBoxdistanceSquared.Add(v.z.Square(16));
	}
	else if(center.z.LessThan(box.minCorner.z))
	{
		v.z = center.z.Sub(box.minCorner.z);
		sphereCenterToBoxdistanceSquared = sphereCenterToBoxdistanceSquared.Add(v.z.Square(16));
	}

	
	if(sphereCenterToBoxdistanceSquared.LessOrEqual((radius.Add(inEpsilon)).Square(16)))
	{
		
		if(sphereCenterToBoxdistanceSquared.GreaterThan(radiusSquared))
		{		
			outAxis.Assign(v.Normalized(16).Neg());
			outSpherePt.Assign(center.Add(outAxis.Mul(radius, 16)));
			outBoxPt.Assign(center.Sub(v));
		}

		return  true;
	}	

	return  false;

}


public boolean Intersects ( Box3 box, F32 radiusAddedToBox) {

	 F32 distanceSquared = new F32(F32.Zero(8));


	if(center.x.GreaterThan(box.maxCorner.x))
	{
		 F32 deltaX = new F32(center.x.Sub(box.maxCorner.x));

		distanceSquared = distanceSquared.Add(deltaX.DecreasePrecision(8).Square(8));
	}
	else if(center.x.LessThan(box.minCorner.x))
	{
		 F32 deltaX = new F32(center.x.Sub(box.minCorner.x));

		distanceSquared = distanceSquared.Add(deltaX.DecreasePrecision(8).Square(8));
	}

	if(center.y.GreaterThan(box.maxCorner.y))
	{
		 F32 deltaY = new F32(center.y.Sub(box.maxCorner.y));

		distanceSquared = distanceSquared.Add(deltaY.DecreasePrecision(8).Square(8));
	}
	else if(center.y.LessThan(box.minCorner.y))
	{
		 F32 deltaY = new F32(center.y.Sub(box.minCorner.y));

		distanceSquared = distanceSquared.Add(deltaY.DecreasePrecision(8).Square(8));
	}

	if(center.z.GreaterThan(box.maxCorner.z))
	{
		 F32 deltaZ = new F32(center.z.Sub(box.maxCorner.z));

		distanceSquared = distanceSquared.Add(deltaZ.DecreasePrecision(8).Square(8));
	}
	else if(center.z.LessThan(box.minCorner.z))
	{
		 F32 deltaZ = new F32(center.z.Sub(box.minCorner.z));

		distanceSquared = distanceSquared.Add(deltaZ.DecreasePrecision(8).Square(8));
	}

	 F32 wierdRadius = new F32(radius.Add(radiusAddedToBox));
  
	 F32 wierdSquareRadius = new F32(wierdRadius.DecreasePrecision(8).Square(8));

	return  distanceSquared.LessOrEqual(wierdSquareRadius);

}


public boolean Contains ( Box3 box) {


	 boolean a = ((box.minCorner.x.Add(box.maxCorner.x)).Mul(F32.Half(16), 16).GreaterThan(center.x));

	 boolean b = ((box.minCorner.y.Add(box.maxCorner.y)).Mul(F32.Half(16), 16).GreaterThan(center.y));

	 boolean c = ((box.minCorner.z.Add(box.maxCorner.z)).Mul(F32.Half(16), 16).GreaterThan(center.z));


	 FVec3T_F32 furthestCorner = new FVec3T_F32(a ? box.maxCorner.x : box.minCorner.x, b ? box.maxCorner.y : box.minCorner.y, c ? box.maxCorner.z : box.minCorner.z);


  return  (furthestCorner.Sub(center)).DecreasePrecision(8).LengthSquared(8).LessOrEqual(radiusSquared);

}


public boolean Intersects ( Sphere sphere2) {


	return  (center.Sub(sphere2.center)).DecreasePrecision(8).LengthSquared(8).LessOrEqual(radiusSquared.Add(sphere2.radiusSquared).Add(F32.FromInt(2, 8).Mul(radius.DecreasePrecision(8), 8).Mul(sphere2.radius.DecreasePrecision(8), 8))); 

}


public boolean Contains ( Sphere sphere2) {


  return  (center.Sub(sphere2.center)).DecreasePrecision(8).LengthSquared(8).LessOrEqual(radiusSquared.Add(sphere2.radiusSquared).Sub(F32.FromInt(2, 8).Mul(radius.DecreasePrecision(8), 8).Mul(sphere2.radius.DecreasePrecision(8), 8))) && radius.GreaterOrEqual(sphere2.radius);

}


public Sphere BoundingSphereOfUnion ( Sphere sphere2) {

	 F32 squaredCenterDistance = new F32((center.Sub(sphere2.center)).DecreasePrecision(8).LengthSquared(8));

	 boolean oneContainsTheOther = squaredCenterDistance.LessOrEqual(radiusSquared.Add(sphere2.radiusSquared).Sub(F32.FromInt(2, 8).Mul(radius.DecreasePrecision(8), 8).Mul(sphere2.radius.DecreasePrecision(8), 8)));

	if(oneContainsTheOther || squaredCenterDistance.LessThan(F32.Epsilon(8))) {
		
		if(radius.GreaterOrEqual(sphere2.radius)) return this;
		else return  sphere2;
	}
	else {
		 F32 centerDistance = new F32(squaredCenterDistance.Sqrt(8));

		 F32 newRadius = new F32((radius.Add(sphere2.radius).Add(centerDistance)).Mul(F32.Half(16), 16));

		 F32 secondCenterWeight = new F32((centerDistance.LessThan(F32.Epsilon(16))) ? F32.Half(16) : (newRadius.Sub(radius)).Div(centerDistance, 16));

		 FVec3T_F32 newCenter = new FVec3T_F32(center.Add((sphere2.center.Sub(center)).Mul(secondCenterWeight, 16)));

		return  new Sphere(newCenter, newRadius);
	}

}


public void OnSerialize (Package _package) {

	(center).OnSerialize(_package);
	(radius)= (_package).SerializeIntrinsic(radius);

	if(_package.IsReading())
	{
		radiusSquared = radius.DecreasePrecision(8).Square(8);
	}

}


public  Sphere Assign ( Sphere other) {

	center.Assign(other.center);
	radius = other.radius;
	radiusSquared = other.radiusSquared;
	return this;

}


public FVec3T_F32 center;
public F32 radius;
public F32 radiusSquared;

/* One dimension array */
public static Sphere[] InstArraySphere(int size) {
	Sphere[] newArray = new Sphere[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new Sphere();
	return newArray; }

/* Two dimension array */
public static Sphere[][] InstArraySphere(int size1, int size2) {
	Sphere[][] newArray = new Sphere[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Sphere[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new Sphere(); }
	return newArray; }

/* Three dimension array */
public static Sphere[][][] InstArraySphere(int size1, int size2, int size3) {
	Sphere[][][] newArray = new Sphere[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Sphere[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new Sphere[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new Sphere(); } }
	return newArray; }



}

