package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class String {

public static String Cast(Object o, String _) {
 return  (String)o; 
}


 final public static byte typeNumber = TypeIDOfType_String.v;
 final public static byte typeID = TypeIDOfType_String.w;
 public static final boolean supportsDynamicSerialization = false; public final static short kBufferSizeForLongValue = 16;

public  String () {


	byte[] emptyString = new byte[1];
	emptyString[0] = 0;
	Assign(emptyString, 0, 0);

}


public  String ( String string) {


	Assign(string.mData, 0, string.GetLength());

}


public  String ( String string, int startIndex, int nbChar) {


	Assign(string.mData, startIndex, nbChar);

}


public  String ( byte [] string) {


	Assign(string, 0, StringUtils.StringLen(string));

}


public  String (java.lang.String string) {


	Assign(string);

}


public  String (byte value) {


		Assign((int)value);
	
}


public  String (short value) {


		Assign((int)value);
	
}


public  String (int value) {


	Assign(value);

}


public  String (long value) {


	Assign(value);

}


public  String (F32 f32Number, int f32Point, int txtNumDigitsAfterPoint) {


	Assign(StringUtils.CreateString(""));
	
	 boolean isNegative = f32Number.IsNegative();

	F32 positiveF32Number = new F32();

	if(isNegative)
	{
		positiveF32Number = f32Number.Neg();
	}
	else
	{
		positiveF32Number = f32Number;
	}
	 int fixedPointValue = positiveF32Number.ToFixedPoint(f32Point);


	 int integerPart = fixedPointValue >> f32Point;


	 int [] digits = null;
	if(txtNumDigitsAfterPoint > 0)
	{
		digits = new int[txtNumDigitsAfterPoint];

		 int fractionalPart = fixedPointValue - (integerPart << f32Point);

		fractionalPart *= 10;
		digits[0] = fractionalPart >> f32Point;

		for(int digitIndex = 1;digitIndex < txtNumDigitsAfterPoint;digitIndex ++)
		{
			fractionalPart = fractionalPart - (digits[digitIndex - 1] << f32Point);
			fractionalPart *= 10;
			digits[digitIndex] = fractionalPart >> f32Point;
		}
	}

	
	String strSign = new String();

	AddAssign(isNegative ? StringUtils.CreateString("-") : StringUtils.CreateString(""));

	String strIntegerPart = new String();

	strIntegerPart.Assign(integerPart);
	AddAssign(strIntegerPart);

	if(txtNumDigitsAfterPoint > 0)
	{
		AddAssign(StringUtils.CreateString("."));

		for(int digitIndex2 = 0;digitIndex2 < txtNumDigitsAfterPoint;digitIndex2 ++)
		{
			String strDigit = new String();

			strDigit.Assign(digits[digitIndex2]);
			AddAssign(strDigit);
		}
	}
	digits = null;


}


public static String FromChar (byte c) {

	byte[] cs = new byte[2];
	cs[0] = c;
	cs[1] = 0;
	return  StringUtils.CreateString(cs);

}


public  String (Stream stream) {


		 short size = stream.ReadShort();




mData = new byte[size + 1];

		if(size != 0)
		{





stream.Read((byte [])mData, size * 1);
}

		mData[size] = 0;
	
}


public void destruct() {

	mData = null;

}


public String Assign ( String string) {

	Assign(string.mData, 0, string.GetLength());
	return this;

}


public String AddAssign ( String string) {

	return  AddAssign(string.mData);

}


public  String Add ( String other) {

	return  Add(other.mData);

}


public boolean Equals ( String string2) {

	 int length = GetLength();

	if(string2.GetLength() != length)
	{
		return  false;
	}
	 byte [] strData = string2.mData;

	for(int ulIndex = 0;ulIndex < length;ulIndex ++)
	{
		if(mData[ulIndex] != strData[ulIndex])
		{
			return  false;
		}
	}

	return  true;

}


public byte GetCharAt (int offset) {


	return  mData[offset];

}


public int GetLength () {

	return  StringUtils.StringLen(mData);

}


public boolean IsEmpty () {

	return  (mData[0] == 0);

}


public void Write (Stream stream, boolean writeStrLen) {

		 int strLength = GetLength();



		if(writeStrLen)
		{
			stream.WriteShort((short)strLength);
		}

		if(strLength != 0)
		{









stream.Write((byte [])mData, strLength * 1);
}
	
}


public int ToLong () {

	 int length = GetLength();

	 int multiplier = 1;

	 int dataIndex = 0;

	 int lValue = 0;

	 boolean isNegative = false;


	if(length == 0)
	{
		return  0;
	}

	for(int i = 0;i < length;i ++)
	{
		multiplier *= 10;
	}

	do
	{
		
		 byte letter = mData[dataIndex++];


		multiplier /= 10;

		if(letter == (byte)'-')
		{
			isNegative = true;
		}
		else
		{
			lValue += multiplier * (letter - (byte)'0');
		}

	} while(multiplier != 1);


	if(isNegative)
	{
		lValue = -lValue;
	}

	return  lValue;

}


public boolean IsNumber () {

	 int dataIndex = 0;

	if(mData[dataIndex] == '-')
	{
		dataIndex++;
	}

	while(dataIndex < GetLength())
	{
		if(mData[dataIndex] < '0' || mData[dataIndex] > '9')
		{
			return  false;
		}
		dataIndex++;
	}
	return  true;

}


public int FindChar (byte inChar, int startIndex) {

	 int length = GetLength();

	for(int i = startIndex;i < length;i ++)
	{
		if(mData[i] == inChar)
		{
			return  i;
		}
	}

	return  -1;

}


public int FindSubstring ( String token) {

	return  StringUtils.StringFindSubstring(mData, token.mData);

}


public int FindSubstring ( String token, int from) {

	 int stringIndex = -1;

	if(from >= 0)
	{
		stringIndex = StringUtils.StringFindSubstring(mData, token.mData, from);
	}
	return  stringIndex;

}


public String Substring (int startIndex, int length) {

	 int stringLength = GetLength();

	if(startIndex >= stringLength)
	{

		return  new String();
	}

	 int remainingLength = stringLength - startIndex;


	if(length < 0|| length > remainingLength)
	{
		length = remainingLength;
	}

	return  new String(this, startIndex, length);

}


public void Assign (int value) {

	byte[] buffer = new byte[kBufferSizeForLongValue];
	 int startIndex = StringUtils.StringLong(buffer, value);

	Assign(buffer, startIndex, kBufferSizeForLongValue - startIndex);

}


public void Assign (long value) {

	byte[] buffer = new byte[kBufferSizeForLongValue * 2];
	 int startIndex = StringUtils.StringLongLong(buffer, value);

	Assign(buffer, startIndex, kBufferSizeForLongValue * 2- startIndex);

}


public String Assign (java.lang.String string) {

		Assign(StringUtils.CreateString(string));
		return this;

}


public void ToUpper () {

	 int lgt = GetLength();

	for(int i = 0;i < lgt;i ++)
	{
		 byte letter = GetCharAt(i);


		if(letter >= 'a' && letter <= 'z')
		{
			ReplaceCharAt(i, (byte)(letter - 'a' + 'A'));
		}
	}

}


public void ToLower () {

	 int lgt = GetLength();

	for(int i = 0;i < lgt;i ++)
	{
		 byte letter = GetCharAt(i);


		if(letter >= 'A' && letter <= 'Z')
		{
			ReplaceCharAt(i, (byte)(letter - 'A' + 'a'));
		}
	}

}


public void Trim () {

	 int strLength = GetLength();

	 int startIdx = 0;

	 int endIdx = strLength -1;

	
	
	while(startIdx < strLength)
	{
		 byte c = GetCharAt(startIdx);

		if((c != (byte)' ') && (c != (byte)'\t') && (c != (byte)'\n') && (c != (byte)'\r'))
		{
			break;
		}
		startIdx++;
	}
	
	
	while(endIdx > startIdx)
	{
		 byte c = GetCharAt(endIdx);

		if((c != (byte)' ') && (c != (byte)'\t') && (c != (byte)'\n') && (c != (byte)'\r'))
		{
			break;
		}
		endIdx--;
	}

	if(startIdx > 0|| endIdx < strLength -1)
	{
		Assign(Substring(startIdx, endIdx -startIdx +1));
	}

}


public void RemoveCharAt (int inPosition, int nbChar) {




	do 
	{		
		mData[inPosition] = mData[inPosition + nbChar];
	}
	while(mData[inPosition++] != 0);

}


public void InsertCharAt (int inPosition, byte inLetter) {

	 int aLength = GetLength();


	if(inPosition <= aLength)
	{
		GuaranteeCapacity(aLength + 1);
		for(int i = aLength + 1;i > inPosition;i --)
		{
			mData[i] = mData[i - 1];
		}

		mData[inPosition] = inLetter;
	}

}


public void ReplaceCharAt (int inPosition, byte inLetter) {



	mData[inPosition] = inLetter;

}


public void ReplaceStringAt (int inPosition, String inString, int nbCharToReplace) {




	 int inSize = inString.GetLength();


	if(inSize < nbCharToReplace)
	{
		
		for(int i = 0;i < inSize;i ++)
		{
			ReplaceCharAt(inPosition + i, inString.GetCharAt(i));
		}

		RemoveCharAt(inPosition + inSize, nbCharToReplace - inSize);
	}
	else
	{
		
		for(int i = 0;i < nbCharToReplace;i ++)
		{
			ReplaceCharAt(inPosition + i, inString.GetCharAt(i));
		}

		for(int j = nbCharToReplace;j < inSize;j ++)
		{
			InsertCharAt(inPosition + j, inString.GetCharAt(j));
		}
	}

}


public  byte [] ToRawString () {

	return  mData;

}


public static void SkipStream (Stream stream) {

	 int size = stream.ReadShort();

	stream.Skip(size * 1);

}


public void OnSerialize (Package p) {




































































































































	 short length = 0;

	(length)= (p).SerializeIntrinsic(length);
	mData = null;
	

 byte [] data = null;
	(data)= (p).SerializeIntrinsics(data, length);
	mData = (byte [])data;



}



		public boolean equals (Object obj)
		{
			if (obj instanceof ca.jamdat.flight.String)
			{
				return Equals((ca.jamdat.flight.String)obj);
			}
			return false;
		}
		public String Assign ( byte [] string) {

	Assign(string, 0, StringUtils.StringLen(string));
	return this;

}


public String AddAssign ( byte [] string) {



	 int currLength = GetLength();

	 int newLength = StringUtils.StringLen(string);


	GuaranteeCapacity(currLength + newLength);
	StringUtils.StringNCopy(mData, string, currLength, 0, newLength + 1);



return this;

}


public String Add ( byte [] other) {

	 String result = new String(mData);

	result.AddAssign(other);
	return  result;

}


public void Assign ( byte [] str, int startIndex, int nbChar) {


	mData = null;



mData = new byte[nbChar + 1];
	StringUtils.StringNCopy(mData, str, 0, startIndex, nbChar);
	mData[GetCapacity() - 1] = 0;




}


public void GuaranteeCapacity (int size) {



if(size + 1> GetCapacity())
	{
		 int mul = (size + 1) >> 4;

		 int newCapacity = (mul + 1) << 4;


		 byte [] oldData = mData;



mData = new byte[newCapacity];
		StringUtils.StringCopy(mData, oldData);
		oldData = null;
	}

}


public int GetCapacity () {




	return mData.length;
	

}


public byte [] mData;
public void Write(Stream stream)
{
	Write(stream, true);
}
public int FindChar(byte inChar)
{
	return FindChar(inChar, (int)0);
}
public void RemoveCharAt(int inPosition)
{
	RemoveCharAt(inPosition, (int)1);
}

/* One dimension array */
public static String[] InstArrayString(int size) {
	String[] newArray = new String[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new String();
	return newArray; }

/* Two dimension array */
public static String[][] InstArrayString(int size1, int size2) {
	String[][] newArray = new String[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new String[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new String(); }
	return newArray; }

/* Three dimension array */
public static String[][][] InstArrayString(int size1, int size2, int size3) {
	String[][][] newArray = new String[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new String[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new String[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new String(); } }
	return newArray; }



}

