package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class TextField extends Viewport {

public static TextField Cast(Object o, TextField _) {
 return  (TextField)o; 
}


 final public static byte typeNumber = TypeIDOfType_TextField.v;
 final public static byte typeID = TypeIDOfType_TextField.w;
 public static final boolean supportsDynamicSerialization = true; public byte GetTypeID() {
 return  typeID; 
}


public static Class AsClass() {
 return  null; 
}


public final static byte charRemoval = 0;
public final static byte charAppend = 1;
public final static byte charCycle = 2;

public  TextField () {
super();
mString = new String();
mKeysString = new String();


	Initialize();

}


public  TextField (Viewport viewport) {
super(viewport);
mString = new String();
mKeysString = new String();


	Initialize();

}


public  TextField (Viewport viewport, Font inFont, String caption, short inRect_left, short inRect_top, short inRect_width, short inRect_height, byte align, boolean multiline) {
super(viewport);
mString = new String();
mKeysString = new String();


	Initialize();
	SetRect(inRect_left, inRect_top, inRect_width, inRect_height);
	mString.Assign(caption);
	mText = new Text(this, inFont, new String(mString), (short)0, (short)0, inRect_width, inRect_height, align);
	mText.SetMultiline(multiline);
	mText.KeepTrailingWhiteSpaces(true);

}


public void destruct() {

	mText.SetViewport(null);
	if(mCursor != null)
	{
		mCursor.SetViewport(null);
	}

	mCursor = null;
	mText = null;

}


public void OnTime (int a10, int deltaTimeMs) {

	if(mIsFocused)
	{
		mCursorBlinkTimeLeft -= deltaTimeMs;
		if(mCursor != null && mCursorBlinkTimeLeft <= 0)
		{
			ResetCursor(!mCursor.IsVisible());
		}

		if(mCycleTimeLeft > 0)
		{
			mCycleTimeLeft -= deltaTimeMs;
			if(mCycleTimeLeft <= 0)
			{
				UpdateCursorPosition(1);
			}
		}
	}

}


public boolean OnDefaultMsg (Component source, int msg, int intParam) {

 	if(msg == focusMsg)
	{
		SetFocus(intParam == isEntering);	
		return  true;
	}

	if((msg < keyUpMsg) || (msg > keyDownOrRepeatMsg))
	{
		return  super.OnDefaultMsg(source, msg, intParam);
	}

	 int key = (int)intParam;


	if(!IsKeySupported(key))
	{
		
		return  super.OnDefaultMsg(source, msg, intParam);
	}

	if((key == Key.CLEAR || key == Key.BACKSPACE) && (mString.GetLength() == 0))
	{
		StopCycling();
		
		return  false;
	}

	if(msg == keyUpMsg)
	{
		switch(key)
		{



















case Key.CLEAR :
		case Key.BACKSPACE :
			{
				StopCycling();
				if(mCursorPosition > 0)
				{
					mString.RemoveCharAt(mCursorPosition - 1);
					UpdateDisplay();
					UpdateCursorPosition(-1);
					SendMsg(this, textFieldInputMsg, charRemoval);
				}
			}
			break;








default :
			{
				if(mIsDigitsOnly && (key < Key.DIGIT0 || key > Key.DIGIT9))
				{
					return  true;
				}


























{
					InsertChar(key);
				}
			}
			break;
		}

	}
	return  true;

}


public void OnSerialize (Package p) {

	








super.OnSerialize(p);

	(mCursor)= mCursor.Cast((p).SerializePointer((mCursor).typeNumber, (mCursor).supportsDynamicSerialization, false), null);

	(mText)= mText.Cast((p).SerializePointer((mText).typeNumber, (mText).supportsDynamicSerialization, false), null);
	mString.Assign(mText.GetCaption());
	mText.SetViewport(this);
	mText.KeepTrailingWhiteSpaces(true);

	(mMaxLength)= (p).SerializeIntrinsic(mMaxLength);
	(mIsCapitalised)= (p).SerializeIntrinsic(mIsCapitalised);
	(mIsCapitalisedLock)= (p).SerializeIntrinsic(mIsCapitalisedLock);
	(mIsDigitsOnly)= (p).SerializeIntrinsic(mIsDigitsOnly);

	SetCursor(mCursor);

	
		SetClipChildren(true);
	
}


public void SetFocus (boolean isFocused) {

	if(isFocused == mIsFocused) return ;

	mIsFocused = isFocused;

	mCycleTimeLeft = 0;
	mCursorPosition = mString.GetLength();
	UpdateCursorPosition(0);

	ResetCursor(isFocused);

	if(mIsFocused)
	{
		TakeFocus();
		RegisterInGlobalTime();
	}
	else
	{
		UnRegisterInGlobalTime();
	}





}


public void SetMaxCharacters (short length) {

	mMaxLength = length;

}


public void SetCapitalised (boolean capital) {

	mIsCapitalised = mIsCapitalisedLock || capital;

}


public void SetLockCapitalised (boolean locked) {

	mIsCapitalisedLock = locked;

}


public void SetCursor (Component cursor) {

	if(mCursor != null)
	{
		mCursor.SetViewport(null);
		mCursor = null;
	}

	mCursor = cursor;

	if(mCursor != null)
	{
		mCursor.SetViewport(this);
		mCursor.SetVisible(mIsFocused);
		UpdateCursorPosition(0);
	}

}


public void SetIsDigitOnly (boolean digitsOnly) {

	mIsDigitsOnly = digitsOnly;

}


public Component GetCursor() {
 return  mCursor; 
}


public Text GetText() {
 return  mText; 
}


public short GetMaxCharacters() {
 return  mMaxLength; 
}


public Text BeginTextChange () {

	


return  mText;

}


public void EndTextChange () {

	


mString.Assign(mText.GetCaption());
	mCursorPosition = mString.GetLength();
	UpdateDisplay();
	UpdateCursorPosition(0);

}


public void InsertCharacterInSet (byte character, int key) {

	if(mKeysString.FindChar(character) == -1)
	{
		mKeysString.InsertCharAt(mFirstIndexs[key + 1], character);

		for(int curKeyIndex = key + 1;curKeyIndex < Key.LASTLOOPKEY + 1;curKeyIndex ++)
		{
			mFirstIndexs[curKeyIndex]++;
		}
	}

}


public void RemoveCharacterFromSet (byte character) {

	 int charPos = mKeysString.FindChar(character);

	if(charPos >= 0)
	{
		mKeysString.RemoveCharAt(charPos);

		for(int curKeyIndex = 0;curKeyIndex < Key.LASTLOOPKEY + 1;curKeyIndex ++)
		{
			if(mFirstIndexs[curKeyIndex] > charPos)
			{
				mFirstIndexs[curKeyIndex]--;
			}
		}
	}

}


public void Initialize () {

	mMaxLength = 255;
	











mKeysString.Assign(StringUtils.CreateString(" !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~"));

	


































mFirstIndexs[Key.DIGIT0] = 0;
		mFirstIndexs[Key.DIGIT1] = 0+ 1;
		mFirstIndexs[Key.DIGIT2] = 0+ 1+ 2;
		mFirstIndexs[Key.DIGIT3] = 0+ 1+ 2+ 4;
		mFirstIndexs[Key.DIGIT4] = 0+ 1+ 2+ 4+ 4;
		mFirstIndexs[Key.DIGIT5] = 0+ 1+ 2+ 4+ 4+ 4;
		mFirstIndexs[Key.DIGIT6] = 0+ 1+ 2+ 4+ 4+ 4+ 4;
		mFirstIndexs[Key.DIGIT7] = 0+ 1+ 2+ 4+ 4+ 4+ 4+ 4;
		mFirstIndexs[Key.DIGIT8] = 0+ 1+ 2+ 4+ 4+ 4+ 4+ 4+ 5;
		mFirstIndexs[Key.DIGIT9] = 0+ 1+ 2+ 4+ 4+ 4+ 4+ 4+ 5+ 4;
		mFirstIndexs[Key.STAR] = 0+ 1+ 2+ 4+ 4+ 4+ 4+ 4+ 5+ 4+ 5;
		mFirstIndexs[Key.POUND] = 0+ 1+ 2+ 4+ 4+ 4+ 4+ 4+ 5+ 4+ 5+ 0;
		mFirstIndexs[Key.LASTLOOPKEY] = 0+ 1+ 2+ 4+ 4+ 4+ 4+ 4+ 5+ 4+ 5+ 0+ 1;
	
	
}


public void ResetCursor (boolean visible) {

	if(mCursor != null)
	{
		mCursorBlinkTimeLeft = 800;
		mCursor.SetVisible(visible);
	}

}


public void UpdateCursorPosition (int offset) {

	mCursorPosition += offset;
	ResetCursor(mIsFocused);

	 Vector2_short cursor2dPos = new Vector2_short(mText.GetCharIndex2DPosition(mCursorPosition));

	 String lineString = new String(mText.GetLineString(cursor2dPos.GetY()));


	 int fullStringLength = mText.GetFont().GetLineWidth(lineString, 0, lineString.GetLength(), false);

	 int stringLength = mText.GetFont().GetLineWidth(lineString, 0, cursor2dPos.GetX(), false);

	 int xOffset = Alignment.GetOffsetX(mText.GetAlignment(), mText.GetRectWidth(), (short)fullStringLength);

	if(mCursor != null)
	{
		if(lineString.GetLength() == mMaxLength && stringLength >= fullStringLength)
		{
			stringLength -= mCursor.GetRectWidth();
		}

		mCursor.SetTopLeft((short)FlMath.Minimum((stringLength + xOffset), (int)mText.GetRectWidth()), (short)(cursor2dPos.GetY() * mText.GetFont().GetLineHeight()));
		
			ChangeOffsetToShow(mCursor, true);
		}

}


public void UpdateDisplay () {

	

	 String captionString = new String(mString);
	mText.SetCaption(captionString, false);

	 short cursorWidth = 0;

	if(mCursor != null)
	{
		cursorWidth = mCursor.GetRectWidth();
	}

	if(!mText.IsMultiline())
	{
		mText.ComputeLineWidth(false);

		
			 short allowedSize = (short)(mRect_width - cursorWidth);

			if(mText.GetLineWidth(0) >= allowedSize || mText.GetRectWidth() > allowedSize)
			{
				mText.SetSize(FlMath.Maximum(mText.GetLineWidth(0), allowedSize), mText.GetRectHeight());
				

{
					ChangeOffsetToShow(mText, true);
				}
			}
		}
	else
	{
		SetSize((short)(mText.GetRectWidth() + cursorWidth), mText.GetRectHeight());
	}

}


public byte GetCurrentChar () {

	if(mIsDigitsOnly)
	{
		return  (byte)((byte)'0' + (mLastKey - Key.DIGIT0));
	}

	
	
		if(mIsCapitalised)
		{
			switch(mLastKey)
			{
				case Key.A :                return  (byte)'A';  
				case Key.B :                return  (byte)'B';  
				case Key.C :                return  (byte)'C';  
				case Key.D :                return  (byte)'D';  
				case Key.E :                return  (byte)'E';  
				case Key.F :                return  (byte)'F';  
				case Key.G :                return  (byte)'G';  
				case Key.H :                return  (byte)'H';  
				case Key.I :                return  (byte)'I';  
				case Key.J :                return  (byte)'J';  
				case Key.K :                return  (byte)'K';  
				case Key.L :                return  (byte)'L';  
				case Key.M :                return  (byte)'M';  
				case Key.N :                return  (byte)'N';  
				case Key.O :                return  (byte)'O';  
				case Key.P :                return  (byte)'P';  
				case Key.Q :                return  (byte)'Q';  
				case Key.R :                return  (byte)'R';  
				case Key.S :                return  (byte)'S';  
				case Key.T :                return  (byte)'T';  
				case Key.U :                return  (byte)'U';  
				case Key.V :                return  (byte)'V';  
				case Key.W :                return  (byte)'W';  
				case Key.X :                return  (byte)'X';  
				case Key.Y :                return  (byte)'Y';  
				case Key.Z :                return  (byte)'Z';  
			}
		}
		else
		{
			switch(mLastKey)
			{
				case Key.A :                return  (byte)'a';  
				case Key.B :                return  (byte)'b';  
				case Key.C :                return  (byte)'c';  
				case Key.D :                return  (byte)'d';  
				case Key.E :                return  (byte)'e';  
				case Key.F :                return  (byte)'f';  
				case Key.G :                return  (byte)'g';  
				case Key.H :                return  (byte)'h';  
				case Key.I :                return  (byte)'i';  
				case Key.J :                return  (byte)'j';  
				case Key.K :                return  (byte)'k';  
				case Key.L :                return  (byte)'l';  
				case Key.M :                return  (byte)'m';  
				case Key.N :                return  (byte)'n';  
				case Key.O :                return  (byte)'o';  
				case Key.P :                return  (byte)'p';  
				case Key.Q :                return  (byte)'q';  
				case Key.R :                return  (byte)'r';  
				case Key.S :                return  (byte)'s';  
				case Key.T :                return  (byte)'t';  
				case Key.U :                return  (byte)'u';  
				case Key.V :                return  (byte)'v';  
				case Key.W :                return  (byte)'w';  
				case Key.X :                return  (byte)'x';  
				case Key.Y :                return  (byte)'y';  
				case Key.Z :                return  (byte)'z';  
			}
		}
	
		switch(mLastKey)
		{
			case Key.SPACE :            return  (byte)' ';  
			case Key.EXCLAMATION_MARK : return  (byte)'!';  
			case Key.DOUBLE_QUOTE :     return  (byte)'"';  
			case Key.POUND :            return  (byte)'#';  
			case Key.DOLLAR_SIGN :      return  (byte)'$';  
			case Key.PERCENT_SIGN :     return  (byte)'%';  
			case Key.AMPERSAND :        return  (byte)'&';  
			case Key.QUOTE :            return  (byte)'\''; 
			case Key.PARENTHESE_OPEN :  return  (byte)'(';  
			case Key.PARENTHESE_CLOSE : return  (byte)')';  
			case Key.STAR :             return  (byte)'*';  
			case Key.PLUS :             return  (byte)'+';  
			case Key.COMMA :            return  (byte)',';  
			case Key.MINUS :            return  (byte)'-';  
			case Key.PERIOD :           return  (byte)'.';  
			case Key.SLASH :            return  (byte)'/';  
			case Key.DIGIT0 :           return  (byte)'0';  
			case Key.DIGIT1 :           return  (byte)'1';  
			case Key.DIGIT2 :           return  (byte)'2';  
			case Key.DIGIT3 :           return  (byte)'3';  
			case Key.DIGIT4 :           return  (byte)'4';  
			case Key.DIGIT5 :           return  (byte)'5';  
			case Key.DIGIT6 :           return  (byte)'6';  
			case Key.DIGIT7 :           return  (byte)'7';  
			case Key.DIGIT8 :           return  (byte)'8';  
			case Key.DIGIT9 :           return  (byte)'9';  
			case Key.COLON :            return  (byte)':';  
			case Key.SEMICOLON :        return  (byte)';';  
			case Key.LESSER :           return  (byte)'<';  
			case Key.EQUAL :            return  (byte)'=';  
			case Key.GREATER :          return  (byte)'>';  
			case Key.QUESTION_MARK :    return  (byte)'?';  
			case Key.AT_SIGN :          return  (byte)'@';  
			case Key.UP_A :             return  (byte)'A';  
			case Key.UP_B :             return  (byte)'B';  
			case Key.UP_C :             return  (byte)'C';  
			case Key.UP_D :             return  (byte)'D';  
			case Key.UP_E :             return  (byte)'E';  
			case Key.UP_F :             return  (byte)'F';  
			case Key.UP_G :             return  (byte)'G';  
			case Key.UP_H :             return  (byte)'H';  
			case Key.UP_I :             return  (byte)'I';  
			case Key.UP_J :             return  (byte)'J';  
			case Key.UP_K :             return  (byte)'K';  
			case Key.UP_L :             return  (byte)'L';  
			case Key.UP_M :             return  (byte)'M';  
			case Key.UP_N :             return  (byte)'N';  
			case Key.UP_O :             return  (byte)'O';  
			case Key.UP_P :             return  (byte)'P';  
			case Key.UP_Q :             return  (byte)'Q';  
			case Key.UP_R :             return  (byte)'R';  
			case Key.UP_S :             return  (byte)'S';  
			case Key.UP_T :             return  (byte)'T';  
			case Key.UP_U :             return  (byte)'U';  
			case Key.UP_V :             return  (byte)'V';  
			case Key.UP_W :             return  (byte)'W';  
			case Key.UP_X :             return  (byte)'X';  
			case Key.UP_Y :             return  (byte)'Y';  
			case Key.UP_Z :             return  (byte)'Z';  
			case Key.BRACKET_OPEN :     return  (byte)'[';  
			case Key.BACKSLASH :        return  (byte)'\\'; 
			case Key.BRACKET_CLOSE :    return  (byte)']';  
			case Key.CARET :            return  (byte)'^';  
			case Key.UNDERSCORE :       return  (byte)'_';  
			
			case Key.BRACE_OPEN :       return  (byte)'{';  
			case Key.VERTICAL_BAR :     return  (byte)'|';  
			case Key.BRACE_CLOSE :      return  (byte)'}';  
			case Key.TILDE :            return  (byte)'~';  
			default :

				return  (byte)'0';
		}

	














}


public void InsertChar (int key) {

	if(mString.GetLength() < mMaxLength)
	{
		StopCycling();

		
		mLastKey = key;
		





 byte character = GetCurrentChar();


		
			 byte characterCopy = character;

	
			
			
			 int letter = characterCopy - (byte)'A';

			if(letter >= 0&& letter <= 25)
			{
				characterCopy = (byte)((byte)'a' + letter);
			}
	
			
			if(mKeysString.FindChar(characterCopy) == -1)
			{
				return ;
			}
		mString.InsertCharAt(mCursorPosition, character);

		UpdateDisplay();








{
			UpdateCursorPosition(1);
		}

		SendMsg(this, textFieldInputMsg, charAppend);
	}

}


public void StopCycling () {

	if(mCycleTimeLeft > 0)
	{
		mCycleTimeLeft = -1;
		UpdateCursorPosition(1);
	}

}


public int GetKeysStringIndexFor (int key) {

	return  mFirstIndexs[key];

}


public boolean CanCycle () {

	if(mIsDigitsOnly)
	{
		return  false;
	}

	return  (mFirstIndexs[mLastKey] != (mFirstIndexs[mLastKey + 1] - 1));

}


public boolean IsKeySupported (int key) {

	if((key == Key.SOFT_CLEAR) || (key == Key.BACKSPACE) || (key == Key.CLEAR))
	{
		return  true;
	}

	




return  ((key >= Key.DIGIT0 && key <= Key.POUND) || (key > Key.KEYBOARD_ONLY_VALID_CHAR_START && key < Key.KEYBOARD_ONLY_VALID_CHAR_END));
	


}


public Component mCursor;
public Text mText;
public String mString;
public boolean mIsFocused;
public short mMaxLength;
public boolean mIsCapitalised;
public boolean mIsCapitalisedLock;
public boolean mIsDigitsOnly;
public int mCursorBlinkTimeLeft;
public int mCycleTimeLeft;
public String mKeysString;
public int[] mFirstIndexs = new int[Key.LASTLOOPKEY + 1];

public int mCurrentKeysStringIndex;
public int mCursorPosition;
public int mLastKey;

/* One dimension array */
public static TextField[] InstArrayTextField(int size) {
	TextField[] newArray = new TextField[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new TextField();
	return newArray; }

/* Two dimension array */
public static TextField[][] InstArrayTextField(int size1, int size2) {
	TextField[][] newArray = new TextField[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new TextField[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new TextField(); }
	return newArray; }

/* Three dimension array */
public static TextField[][][] InstArrayTextField(int size1, int size2, int size3) {
	TextField[][][] newArray = new TextField[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new TextField[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new TextField[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new TextField(); } }
	return newArray; }



}

