package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


	import java.util.Calendar;
	
public class TimeData {

public final static byte TD_YEAR = 0;
public final static byte TD_MONTH = 1;
public final static byte TD_DAY = 2;
public final static byte TD_HOUR = 3;
public final static byte TD_MINUTE = 4;
public final static byte TD_SECOND = 5;
public final static byte TD_SIZE = 6;

public TimeData () {

	



	
	Calendar time = Calendar.getInstance();

	mData[TD_MONTH] = (int)(time.get(Calendar.MONTH)) + 1;
	mData[TD_DAY] = time.get(Calendar.DAY_OF_MONTH);
	mData[TD_YEAR] = time.get(Calendar.YEAR);

	mData[TD_HOUR] = time.get(Calendar.HOUR_OF_DAY);
	mData[TD_MINUTE] = time.get(Calendar.MINUTE);
	mData[TD_SECOND] = time.get(Calendar.SECOND);
	
























































































}


public TimeData (String date) {


	 int numDate = date.ToLong();


	 int month = (int)(numDate / 1000000);

	 int day = (int)((numDate / 10000) % 100);

	 int year = (int)(numDate % 10000);


	mData[TD_MONTH] = month;
	mData[TD_DAY] = day;
	mData[TD_YEAR] = year;

	mData[TD_HOUR] = 0;
	mData[TD_MINUTE] = 0;
	mData[TD_SECOND] = 0;

}


public TimeData (int month, int day, int year) {

	mData[TD_MONTH] = month;
	mData[TD_DAY] = day;
	mData[TD_YEAR] = year;

	mData[TD_HOUR] = 0;
	mData[TD_MINUTE] = 0;
	mData[TD_SECOND] = 0;

}


public TimeData (int month, int day, int year, int hour, int min, int sec) {

	mData[TD_MONTH] = month;
	mData[TD_DAY] = day;
	mData[TD_YEAR] = year;

	mData[TD_HOUR] = hour;
	mData[TD_MINUTE] = min;
	mData[TD_SECOND] = sec;

}


public int GetHour() {
 return  mData[TD_HOUR]; 
}


public int GetMin() {
 return  mData[TD_MINUTE]; 
}


public int GetSec() {
 return  mData[TD_SECOND]; 
}


public int GetYear() {
 return  mData[TD_YEAR]; 
}


public int GetMonth() {
 return  mData[TD_MONTH]; 
}


public int GetDay() {
 return  mData[TD_DAY]; 
}


public boolean IsDateValid () {

	 int year = mData[TD_YEAR];

	 int month = mData[TD_MONTH];

	 int day = mData[TD_DAY];


	if(month < 1|| month > 12)
	{
		return  false;
	}

	if(day < 1)
	{
		return  false;
	}

	
	if(month == 2)
	{
		if((year % 4 == 0 && year % 100 != 0) || year % 400 == 0)
		{
			return  day < 30;
		}
		else
		{		
			return  day < 29;
		}
	}
 	else if(month == 1|| 
			month == 3|| 
			month == 5|| 
			month == 7|| 
			month == 8|| 
			month == 10|| 
			month == 12)
	{
		return  day < 32;
 	}
 	else
 	{
 		return  day < 31;
	}

}


public boolean Equals ( TimeData other) {

	 boolean equal = true;

	for(int i = 0;i < TD_SIZE;i ++)
	{
		if(mData[i] != other.mData[i])
		{
			equal = false;
			break;
		}
	}

	return  equal;

}


public int[] mData = new int[TD_SIZE];


/* One dimension array */
public static TimeData[] InstArrayTimeData(int size) {
	TimeData[] newArray = new TimeData[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new TimeData();
	return newArray; }

/* Two dimension array */
public static TimeData[][] InstArrayTimeData(int size1, int size2) {
	TimeData[][] newArray = new TimeData[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new TimeData[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new TimeData(); }
	return newArray; }

/* Three dimension array */
public static TimeData[][][] InstArrayTimeData(int size1, int size2, int size3) {
	TimeData[][][] newArray = new TimeData[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new TimeData[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new TimeData[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new TimeData(); } }
	return newArray; }



}

