package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class TimeUtils {

public static TimeData GetTime() {
 TimeData td = new TimeData();
 return  td; 
}


public static int GetHour(TimeData time) {
 return  time.GetHour(); 
}


public static int GetMin(TimeData time) {
 return  time.GetMin(); 
}


public static int GetSec(TimeData time) {
 return  time.GetSec(); 
}


public static int GetYear(TimeData time) {
 return  time.GetYear(); 
}


public static int GetMonth(TimeData time) {
 return  time.GetMonth(); 
}


public static int GetDay(TimeData time) {
 return  time.GetDay(); 
}


public static String Get12HourFormat (TimeData time, boolean useSecond, byte sep) {

	 int hour = time.GetHour();


	 boolean am = true;

	if(hour > 12)
	{
		am = false;
		hour -= 12;
	}

	 String t12hour = new String(hour);

	t12hour.AddAssign(String.FromChar(sep));

	 int minute = time.GetMin();

	if(minute < 10)
	{
		t12hour.AddAssign(new String(0));
	}
	t12hour.AddAssign(new String(minute));

	if(useSecond)
	{
		t12hour.AddAssign(String.FromChar(sep));
		 int second = time.GetSec();

		if(second < 10)
		{
			t12hour.AddAssign(new String(0));
		}
		t12hour.AddAssign(new String(second));
	}

	if(am)
	{
		t12hour.AddAssign(StringUtils.CreateString("am"));
	}
	else
	{
		t12hour.AddAssign(StringUtils.CreateString("pm"));
	}
	return  t12hour;

}


public static String Get24HourFormat (TimeData time, boolean useSecond, byte sep) {

	 String t24hour = new String(time.GetHour());

	t24hour.AddAssign(String.FromChar(sep));

	 int minute = time.GetMin();

	if(minute < 10)
	{
		t24hour.AddAssign(new String(0));
	}
	t24hour.AddAssign(new String(minute));

	if(useSecond)
	{
		t24hour.AddAssign(String.FromChar(sep));
		 int second = time.GetSec();

		if(second < 10)
		{
			t24hour.AddAssign(new String(0));
		}
		t24hour.AddAssign(new String(second));
	}

	return  t24hour;

}


public static boolean IsDateValid (int year, int month, int day) {

	 TimeData time = new TimeData(month, day, year);

	return  time.IsDateValid();

}


public static int GetElapsedDays (TimeData since) {

	TimeData now = new TimeData();


	 int nowJDN = GetJulianDayNumber(now);

	 int sinceJDN = GetJulianDayNumber(since);


	return  nowJDN - sinceJDN;

}


public static int GetElapsedYears (TimeData since) {

	 int elapsedYears = 0;


	TimeData now = new TimeData();


	
	elapsedYears = now.GetYear() - since.GetYear() - 1;
	
	
	if(since.GetMonth() < now.GetMonth())
	{
		elapsedYears++;
	}
	else if(since.GetMonth() == now.GetMonth() && since.GetDay() <= now.GetDay())
	{
		elapsedYears++;
	}

	return  elapsedYears;

}


public static int GetJulianDayNumber (TimeData time) {

	
	
	 int month = time.GetMonth();

	 int year = time.GetYear();

	if(month < 3)
	{
		month = month + 12;
		year = year - 1;
	}
	
	return  (time.GetDay() + (((153* month) - 457) / 5) + (365* year) + (year / 4) + 1721116); 

}


public static String Get12HourFormat(TimeData time)
{
	return Get12HourFormat(time, false);
}
public static String Get12HourFormat(TimeData time, boolean useSecond)
{
	return Get12HourFormat(time, useSecond, (byte)':');
}
public static String Get24HourFormat(TimeData time)
{
	return Get24HourFormat(time, false);
}
public static String Get24HourFormat(TimeData time, boolean useSecond)
{
	return Get24HourFormat(time, useSecond, (byte)':');
}

/* One dimension array */
public static TimeUtils[] InstArrayTimeUtils(int size) {
	TimeUtils[] newArray = new TimeUtils[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new TimeUtils();
	return newArray; }

/* Two dimension array */
public static TimeUtils[][] InstArrayTimeUtils(int size1, int size2) {
	TimeUtils[][] newArray = new TimeUtils[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new TimeUtils[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new TimeUtils(); }
	return newArray; }

/* Three dimension array */
public static TimeUtils[][][] InstArrayTimeUtils(int size1, int size2, int size3) {
	TimeUtils[][][] newArray = new TimeUtils[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new TimeUtils[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new TimeUtils[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new TimeUtils(); } }
	return newArray; }

public TimeUtils () { 
}




}

