package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class TimerSequence extends TimeSystem {

public static TimerSequence Cast(Object o, TimerSequence _) {
 return  (TimerSequence)o; 
}


 final public static byte typeNumber = TypeIDOfType_TimerSequence.v;
 final public static byte typeID = TypeIDOfType_TimerSequence.w;
 public static final boolean supportsDynamicSerialization = true; public byte GetTypeID() {
 return  typeID; 
}


public static Class AsClass() {
 return  null; 
}


public final static short Infinite = 0x7FFF;

public  TimerSequence () {
super();



}


public  TimerSequence (int maxNumInterval) {
super();




	mStartDurationTimes = new short[maxNumInterval * 2];



mTimeControlleds.SetSize(maxNumInterval);






}


public void destruct() {

	mStartDurationTimes = null;

}


public void Register ( TimeControlled timeable) {




}


public void UnRegister ( TimeControlled timeable) {

	 PtrArray_TimeControlled timeControlleds = mTimeControlleds;

	for(int i = 0;i < timeControlleds.End();i ++)
	{
		if(timeControlleds.GetAt(i) == timeable)
		{
			timeControlleds.SetAt(null, i);
		}
	}

}


public void RegisterInterval ( TimeControlled timeable, int startTime, int duration) {

	 PtrArray_TimeControlled timeControlleds = mTimeControlleds;

	 int index = 0;

	while(index < timeControlleds.End() && timeControlleds.GetAt(index) != null)
	{
		index++;
	}



	timeControlleds.SetAt(timeable, index);












	mStartDurationTimes[index * 2] = (short)startTime;
	mStartDurationTimes[index * 2 + 1] = (short)duration;

}


public void SetTotalTimeRecursively (int val) {

	SetTotalTime(val);

	for(int i = mTimeControlleds.Start();i < mTimeControlleds.End();i ++)
	{
		 TimeControlled tc = mTimeControlleds.GetAt(i);
		if (tc != null&& (tc instanceof TimeSystem))
		{
			 short start = mStartDurationTimes[i * 2];

			((TimeSystem)tc).SetTotalTimeRecursively(val - start);
		}
	}

}


public void OnSerialize (Package p) {

	super.OnSerialize(p);


	 short mStartDurationTimesLength = 0;
 
(mStartDurationTimesLength)= (p).SerializeIntrinsic(mStartDurationTimesLength);
	(mStartDurationTimes)= (p).SerializeIntrinsics(mStartDurationTimes, mStartDurationTimesLength);
	
	mTimeControlleds.SetSize(mStartDurationTimesLength / 2);

}


public void CleanUpTimeTable () {

	

}


public void SendOnTime (int timeMs, int deltaTimeMs) {



	if(Empty())
	{
		super.SendOnTime(timeMs, deltaTimeMs);
		return ;
	}

	for(int i = 0;i < mTimeControlleds.End();i ++)
	{
		 TimeControlled curTimeControlled = mTimeControlleds.GetAt(i);

		if(curTimeControlled != null)
		{
			 short start = mStartDurationTimes[i * 2];

			 short duration = mStartDurationTimes[i * 2 + 1];

			 short end = (short)((duration != Infinite) ? (start + duration) : Infinite);


			 int lastTime = timeMs - deltaTimeMs;

			 int currentTime = timeMs;

			
			
			if(currentTime >= start && (lastTime <= end || end == Infinite) || lastTime >= start && (currentTime <= end || end == Infinite))
			{
				

				if(start > lastTime)
				{
					lastTime = start;
				}

				if(end != Infinite && end < currentTime)
				{
					currentTime = end;
				}

				
				curTimeControlled.OnTime(currentTime - start, currentTime - lastTime);
			}
		}
	}

}


public boolean Empty() {
 return  mStartDurationTimes.length  == 0; 
}


public short[] mStartDurationTimes = null;

/* One dimension array */
public static TimerSequence[] InstArrayTimerSequence(int size) {
	TimerSequence[] newArray = new TimerSequence[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new TimerSequence();
	return newArray; }

/* Two dimension array */
public static TimerSequence[][] InstArrayTimerSequence(int size1, int size2) {
	TimerSequence[][] newArray = new TimerSequence[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new TimerSequence[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new TimerSequence(); }
	return newArray; }

/* Three dimension array */
public static TimerSequence[][][] InstArrayTimerSequence(int size1, int size2, int size3) {
	TimerSequence[][][] newArray = new TimerSequence[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new TimerSequence[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new TimerSequence[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new TimerSequence(); } }
	return newArray; }



}

