package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class ViewingFrustrum {

public static ViewingFrustrum Cast(Object o, ViewingFrustrum _) {
 return  (ViewingFrustrum)o; 
}


public void OnSerialize(Package p) {

}


public final static byte front = 0;
public final static byte back = 1;
public final static byte left = 2;
public final static byte right = 3;
public final static byte top = 4;
public final static byte bottom = 5;

public final static byte frontMask = 1;
public final static byte backMask = 2;
public final static byte leftMask = 4;
public final static byte rightMask = 8;
public final static byte topMask = 16;
public final static byte bottomMask = 32;

public HalfSpace[] halfSpaces = HalfSpace.InstArrayHalfSpace(6);

public ViewingFrustrum () {


}


public ViewingFrustrum ( ViewingFrustrum other) {

	Init(other.halfSpaces[front], other.halfSpaces[back], other.halfSpaces[left], other.halfSpaces[right], other.halfSpaces[top], other.halfSpaces[bottom]);

}


public ViewingFrustrum ( HalfSpace parFront, HalfSpace parBack, HalfSpace parLeft, HalfSpace parRight, HalfSpace parTop, HalfSpace parBottom) {

	Init(parFront, parBack, parLeft, parRight, parTop, parBottom);

}


public void Init ( HalfSpace parFront, HalfSpace parBack, HalfSpace parLeft, HalfSpace parRight, HalfSpace parTop, HalfSpace parBottom) {

	halfSpaces[front].Assign(parFront);
	halfSpaces[back].Assign(parBack);
	halfSpaces[left].Assign(parLeft);
	halfSpaces[right].Assign(parRight);
	halfSpaces[top].Assign(parTop);
	halfSpaces[bottom].Assign(parBottom);

}


public HalfSpace Front () {
return  halfSpaces[front]; 
}


public HalfSpace Back () {
return  halfSpaces[back];  
}


public HalfSpace Left () {
return  halfSpaces[left];  
}


public HalfSpace Right () {
return  halfSpaces[right]; 
}


public HalfSpace Top () {
return  halfSpaces[top];   
}


public HalfSpace Bottom () {
return  halfSpaces[bottom];
}


public byte AttemptToExcludeIntersectingPlanes (byte possiblyIntersectingPlanes, Box3 box) {

   byte intersectingPlanes = 0;

	
   int planeMask = 1;

  for(int planeIndex =0;planeIndex <6;planeIndex ++) {
    if((possiblyIntersectingPlanes & planeMask) != 0) {
       byte side = halfSpaces[planeIndex].WhichSideOfPlane(box);

      if(side == BoundsSide.BothSides) intersectingPlanes |= planeMask;
      else if(side == BoundsSide.Outside) return  0x40;
    }
    planeMask = planeMask << 1;
  }
	







  return  intersectingPlanes;

}


public byte AttemptToExcludeIntersectingPlanes (byte possiblyIntersectingPlanes, Box3 box, F32 radiusAddedToBox) {

   byte intersectingPlanes = 0;

	
   int planeMask = 1;

  for(int planeIndex =0;planeIndex <6;planeIndex ++) {
    if((possiblyIntersectingPlanes & planeMask) != 0) {
       byte side = halfSpaces[planeIndex].WhichSideOfPlane(box, radiusAddedToBox);

      if(side == BoundsSide.BothSides) intersectingPlanes |= planeMask;
      else if(side == BoundsSide.Outside) return  0x40;
    }
    planeMask = planeMask << 1;
  }
	







  return  intersectingPlanes;

}


public byte AttemptToExcludeIntersectingPlanes (byte possiblyIntersectingPlanes, Sphere sphere) {

	 byte intersectingPlanes = 0;

	
	 int planeMask = 1;

	for(int planeIndex = 0;planeIndex < 6;planeIndex ++)
	{
		if((possiblyIntersectingPlanes & planeMask) != 0)
		{
			 byte side = halfSpaces[planeIndex].WhichSideOfPlane(sphere);

			if(side == BoundsSide.BothSides)
			{
				intersectingPlanes |= planeMask;
			}
			else if(side == BoundsSide.Outside)
			{
				return  0x40;
			}
		}
		planeMask = planeMask << 1;
	}
	








	return  intersectingPlanes;

}


public  ViewingFrustrum Assign ( ViewingFrustrum other) {

	for(int i = 0;i < 6;i ++)
	{
		halfSpaces[i].Assign(other.halfSpaces[i]);
	}
	return this;

}



/* One dimension array */
public static ViewingFrustrum[] InstArrayViewingFrustrum(int size) {
	ViewingFrustrum[] newArray = new ViewingFrustrum[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new ViewingFrustrum();
	return newArray; }

/* Two dimension array */
public static ViewingFrustrum[][] InstArrayViewingFrustrum(int size1, int size2) {
	ViewingFrustrum[][] newArray = new ViewingFrustrum[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new ViewingFrustrum[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new ViewingFrustrum(); }
	return newArray; }

/* Three dimension array */
public static ViewingFrustrum[][][] InstArrayViewingFrustrum(int size1, int size2, int size3) {
	ViewingFrustrum[][][] newArray = new ViewingFrustrum[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new ViewingFrustrum[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new ViewingFrustrum[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new ViewingFrustrum(); } }
	return newArray; }



}

