package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class GameSetupScene extends BaseScene {

public final static int kMarathon = 0;
public final static int kUltra = 1;
public final static int k40Lines = 2;
public final static int kGameModesCount = 3;

public final static int kSinglePlayer = 0;
public final static int kPlayerModeCount = 1;

public final static int kUpdateSavedValues = 0;
public final static int kUpdateMenu = 1;

public  GameSetupScene (byte packageID) {
super(packageID);


	 TetrisState tetrisState = GetTetrisState();
	mGameModesMenu = EGameModeStateToMenuVersion(tetrisState.GetGameMode());
	mPlayerMode = DeductPlayerMode(tetrisState.GetGameMode(), tetrisState.IsNetworkGame());







}


public void destruct() {


}


public void UnloadResources () {

	if(mpViewport == null)
	{
		
		return ;
	}

	if(mbChangedSetup)
	{
		SaveValues();	
		SaveOnExit();
	}


	
	
	if(mpScramblingTextTimeSystem != null)
	{
		mpScramblingTextTimeSystem.OnTime(0, (((int)ConstantsEnglishPortrait.animScramblingTextMaxMenuPeriod == (int)ConstantsEnglishLandscape.animScramblingTextMaxMenuPeriod) ? Constants.animScramblingTextMaxMenuPeriod : ConstantsGetter.GetConstants().animScramblingTextMaxMenuPeriodFct()));
	}
 Selector subSelector = null;
	
	GetApp().TakeFocus();

	for(int i = 0;i < (((int)ConstantsEnglishPortrait.gameModesTotalElements == (int)ConstantsEnglishLandscape.gameModesTotalElements) ? Constants.gameModesTotalElements : ConstantsGetter.GetConstants().gameModesTotalElementsFct());i ++)
	{
		subSelector = (Selector)(mpSelectionItem[i].GetChild((((int)ConstantsEnglishPortrait.gameSetupSubSelectorChildIndex == (int)ConstantsEnglishLandscape.gameSetupSubSelectorChildIndex) ? Constants.gameSetupSubSelectorChildIndex : ConstantsGetter.GetConstants().gameSetupSubSelectorChildIndexFct())));

		if(subSelector.GetSubtype() != 0)
		{
			ReleaseElementList(subSelector, (int)subSelector.GetSubtype());
		}
	}

	super.UnloadResources();

}


public void Init () {

	((Selector)mpComponentWithFocus).SetSingleSelection(0);
	 Selector subSelector = null;

	for(int i = 0;i < (((int)ConstantsEnglishPortrait.gameModesTotalElements == (int)ConstantsEnglishLandscape.gameModesTotalElements) ? Constants.gameModesTotalElements : ConstantsGetter.GetConstants().gameModesTotalElementsFct());i ++)
	{
		subSelector = (Selector)(mpSelectionItem[i].GetChild((((int)ConstantsEnglishPortrait.gameSetupSubSelectorChildIndex == (int)ConstantsEnglishLandscape.gameSetupSubSelectorChildIndex) ? Constants.gameSetupSubSelectorChildIndex : ConstantsGetter.GetConstants().gameSetupSubSelectorChildIndexFct())));

		 int subSelectorSubtype = subSelector.GetSubtype();

		
		if(subSelectorSubtype != 0&& subSelectorSubtype != (((int)ConstantsEnglishPortrait.menuAnyYesNoItemSelectionSubtype == (int)ConstantsEnglishLandscape.menuAnyYesNoItemSelectionSubtype) ? Constants.menuAnyYesNoItemSelectionSubtype : ConstantsGetter.GetConstants().menuAnyYesNoItemSelectionSubtypeFct()))
		{
			CreateElementList(subSelector, (int)subSelector.GetSubtype());
		}





subSelector.SetSingleSelection(0);
	}

	UpdateOptions();
	InitValues(); 

	((Selector)mpComponentWithFocus).ResetScroller();	

	super.Init();

}


public void GetResources () {



	super.GetResources();

	for(int i = 0;i < (((int)ConstantsEnglishPortrait.gameModesTotalElements == (int)ConstantsEnglishLandscape.gameModesTotalElements) ? Constants.gameModesTotalElements : ConstantsGetter.GetConstants().gameModesTotalElementsFct());i ++)
	{
		
		(mpSelectionItem[i])= (mpSelectionItem[i]).Cast((mpPackage).GetEntryPoint(RSRC_gameSetupMenuScenePackage.gameSetupModeTypeText_ID + 1+ i), null);
	}

	
	 int gameModeStrEntryPoint = 0;

	switch(mPlayerMode)
	{
	case kSinglePlayer :
		gameModeStrEntryPoint = RSRC_gameSetupMenuScenePackage.gameModeSinglePlayerString_ID;
		break;




default :

	}

	 Text pTitleText = null;
	 String pGameModeStr = null;
	(pTitleText)= (pTitleText).Cast((mpPackage).GetEntryPoint(RSRC_gameSetupMenuScenePackage.gameSetupMenuTitleText_ID), null);
	(pGameModeStr)= (pGameModeStr).Cast((mpPackage).GetEntryPoint(gameModeStrEntryPoint), null);
	pTitleText.SetCaption(new String(pGameModeStr));




	gameModeStrEntryPoint = 0;
	switch(mGameModesMenu)
	{




case kMarathon :
			gameModeStrEntryPoint = RSRC_gameSetupMenuScenePackage.gameModeMarathonString_ID;
			break;
		case kUltra :
			gameModeStrEntryPoint = RSRC_gameSetupMenuScenePackage.gameModeUltraString_ID;
			break;
		case k40Lines :
			gameModeStrEntryPoint = RSRC_gameSetupMenuScenePackage.gameMode40LinesString_ID;
			break;

		default : ;
	}


	
	(pTitleText)= (pTitleText).Cast((mpPackage).GetEntryPoint(RSRC_gameSetupMenuScenePackage.gameSetupModeTypeText_ID), null);
	(pGameModeStr)= (pGameModeStr).Cast((mpPackage).GetEntryPoint(gameModeStrEntryPoint), null);
	pTitleText.SetCaption(new String(pGameModeStr));	

}


public boolean HandleCommand (int command) {

	 boolean retval = true;


    switch(command)
	{
		case (((int)ConstantsEnglishPortrait.startGameCommand == (int)ConstantsEnglishLandscape.startGameCommand) ? Constants.startGameCommand : -123) :
		{
			SaveValues();



{
				super.HandleCommand((((int)ConstantsEnglishPortrait.startGameCommand == (int)ConstantsEnglishLandscape.startGameCommand) ? Constants.startGameCommand : ConstantsGetter.GetConstants().startGameCommandFct()));
			}
		}
		break;

		case (((int)ConstantsEnglishPortrait.gameSetupToggleSetupCommand == (int)ConstantsEnglishLandscape.gameSetupToggleSetupCommand) ? Constants.gameSetupToggleSetupCommand : -123) :
			mbChangedSetup = true;
			break;

		default :
		{
			retval = super.HandleCommand(command);
		}
		break;
	}

	return  retval;

}


public static int EGameModeStateToMenuVersion (int gameMode) {

	int newMode;


	switch(gameMode)
	{
	case TetrisState.kModeMarathon :
		newMode = kMarathon;
		break;
	case TetrisState.kModeUltra :
		newMode = kUltra;
		break;
	case TetrisState.kMode40Lines :
		newMode = k40Lines;
		break;




default : 

		newMode = kGameModesCount;
	}


	return  newMode;

}


public static int DeductPlayerMode (int gameMode, boolean isNetworkGame) {



int playerMode;

	switch(gameMode)
	{
		case TetrisState.kModeMarathon :
			playerMode = kSinglePlayer;
			break;

		case TetrisState.kModeUltra :		
			playerMode = kSinglePlayer;
			break;

		case TetrisState.kMode40Lines :	
			playerMode = kSinglePlayer;
			break;









default :

		playerMode = kPlayerModeCount;
	}
	
	return  playerMode;

}


public void UpdateOptions () {

	 int startIndex = 0;

	 int endIndex = 0;


	switch((int)mGameModesMenu)
	{











case kMarathon :
			startIndex = (((int)ConstantsEnglishPortrait.marathonGameStartIndex == (int)ConstantsEnglishLandscape.marathonGameStartIndex) ? Constants.marathonGameStartIndex : ConstantsGetter.GetConstants().marathonGameStartIndexFct());
			endIndex = (((int)ConstantsEnglishPortrait.marathonGameStartIndex == (int)ConstantsEnglishLandscape.marathonGameStartIndex) ? Constants.marathonGameStartIndex : ConstantsGetter.GetConstants().marathonGameStartIndexFct()) + (((int)ConstantsEnglishPortrait.marathonGameNumberOfItems == (int)ConstantsEnglishLandscape.marathonGameNumberOfItems) ? Constants.marathonGameNumberOfItems : ConstantsGetter.GetConstants().marathonGameNumberOfItemsFct());
			break;

		case kUltra :
			startIndex = (((int)ConstantsEnglishPortrait.ultraGameStartIndex == (int)ConstantsEnglishLandscape.ultraGameStartIndex) ? Constants.ultraGameStartIndex : ConstantsGetter.GetConstants().ultraGameStartIndexFct());
			endIndex = (((int)ConstantsEnglishPortrait.ultraGameStartIndex == (int)ConstantsEnglishLandscape.ultraGameStartIndex) ? Constants.ultraGameStartIndex : ConstantsGetter.GetConstants().ultraGameStartIndexFct()) + (((int)ConstantsEnglishPortrait.ultraGameNumberOfItems == (int)ConstantsEnglishLandscape.ultraGameNumberOfItems) ? Constants.ultraGameNumberOfItems : ConstantsGetter.GetConstants().ultraGameNumberOfItemsFct());
			break;

		case k40Lines :
			startIndex = (((int)ConstantsEnglishPortrait.fortyLinesGameStartIndex == (int)ConstantsEnglishLandscape.fortyLinesGameStartIndex) ? Constants.fortyLinesGameStartIndex : ConstantsGetter.GetConstants().fortyLinesGameStartIndexFct());
			endIndex = (((int)ConstantsEnglishPortrait.fortyLinesGameStartIndex == (int)ConstantsEnglishLandscape.fortyLinesGameStartIndex) ? Constants.fortyLinesGameStartIndex : ConstantsGetter.GetConstants().fortyLinesGameStartIndexFct()) + (((int)ConstantsEnglishPortrait.fortyLinesGameNumberOfItems == (int)ConstantsEnglishLandscape.fortyLinesGameNumberOfItems) ? Constants.fortyLinesGameNumberOfItems : ConstantsGetter.GetConstants().fortyLinesGameNumberOfItemsFct());
			break;
	}


	((Selector)mpComponentWithFocus).SetSingleSelection(startIndex);
	for(int i = 0;i < (((int)ConstantsEnglishPortrait.gameModesTotalElements == (int)ConstantsEnglishLandscape.gameModesTotalElements) ? Constants.gameModesTotalElements : ConstantsGetter.GetConstants().gameModesTotalElementsFct());i ++)
	{
		 Selection selectionItem = mpSelectionItem[i];
		if(i >= startIndex && i < endIndex)
		{
			selectionItem.SetVisible(true);
			selectionItem.SetEnabledState(true);
		}
		else
		{
			selectionItem.SetVisible(false);
			selectionItem.SetEnabledState(false);
		}
	}
	((Selector)mpComponentWithFocus).UpdateScroller();

}


public void CreateElementList (Selector subSelector, int selectionType) {
	
	 Array_int subitemsValues = null;	
	subitemsValues = GetSelectionSetupContentArray(selectionType);

	if(subitemsValues != null)
	{
		 Selection subSelection = null;
		 Text subText = null;
		 int subValue = 0;

		 Font subFont = null;
		 String captionString = null;

		 String anyString = null;
		(anyString)= (anyString).Cast((mpPackage).GetEntryPoint(RSRC_gameSetupMenuScenePackage.gameModeAnyString_ID), null);


		
		 Viewport subSelectorViewport = (Viewport)subSelector.GetChild((((int)ConstantsEnglishPortrait.gameSetupSubSelectorViewportIndex == (int)ConstantsEnglishLandscape.gameSetupSubSelectorViewportIndex) ? Constants.gameSetupSubSelectorViewportIndex : ConstantsGetter.GetConstants().gameSetupSubSelectorViewportIndexFct()));
		subSelection = (Selection)subSelectorViewport.GetChild(0);
		subText = (Text)(subSelection.GetChild((((int)ConstantsEnglishPortrait.gameSetupSubSelectionTextIndex == (int)ConstantsEnglishLandscape.gameSetupSubSelectionTextIndex) ? Constants.gameSetupSubSelectionTextIndex : ConstantsGetter.GetConstants().gameSetupSubSelectionTextIndexFct())));
		subSelection.SetVisible(false);
		subSelection.SetEnabledState(false);
		subText.SetVisible(false);

		
		 Package fontPackage = RessourcesManager.Get().GetPackage(PackageID.font);
		(subFont)= (subFont).Cast((fontPackage).GetEntryPoint(RSRC_fontPackage.menuSubSelectionFont_ID), null);

		 short textRect_left = (short)(0);
  short textRect_top = (short)(0);
  short textRect_width = (short)((((int)ConstantsEnglishPortrait.gameSetupMenuSubSelectorScrollingViewportWidth == (int)ConstantsEnglishLandscape.gameSetupMenuSubSelectorScrollingViewportWidth) ? Constants.gameSetupMenuSubSelectorScrollingViewportWidth : ConstantsGetter.GetConstants().gameSetupMenuSubSelectorScrollingViewportWidthFct()));
  short textRect_height = (short)((((int)ConstantsEnglishPortrait.gameSetupMenuLineHeight == (int)ConstantsEnglishLandscape.gameSetupMenuLineHeight) ? Constants.gameSetupMenuLineHeight : ConstantsGetter.GetConstants().gameSetupMenuLineHeightFct()));

for(int i = 0;i < subitemsValues.End();i ++)
		{
			subSelection = new Selection();
			subSelection.SetViewport(subSelectorViewport);
			subSelection.SetTopLeft((short)((((int)ConstantsEnglishPortrait.gameSetupMenuSubSelectorScrollingViewportWidth == (int)ConstantsEnglishLandscape.gameSetupMenuSubSelectorScrollingViewportWidth) ? Constants.gameSetupMenuSubSelectorScrollingViewportWidth : ConstantsGetter.GetConstants().gameSetupMenuSubSelectorScrollingViewportWidthFct()) * i), (short)0);
			subSelection.SetSize((short)((((int)ConstantsEnglishPortrait.gameSetupMenuSubSelectorScrollingViewportWidth == (int)ConstantsEnglishLandscape.gameSetupMenuSubSelectorScrollingViewportWidth) ? Constants.gameSetupMenuSubSelectorScrollingViewportWidth : ConstantsGetter.GetConstants().gameSetupMenuSubSelectorScrollingViewportWidthFct())), (short)((((int)ConstantsEnglishPortrait.gameSetupMenuLineHeight == (int)ConstantsEnglishLandscape.gameSetupMenuLineHeight) ? Constants.gameSetupMenuLineHeight : ConstantsGetter.GetConstants().gameSetupMenuLineHeightFct())));
			subSelection.SetSubtype((((int)ConstantsEnglishPortrait.submenuItemOfSelectionWithSubSelectorSubtype == (int)ConstantsEnglishLandscape.submenuItemOfSelectionWithSubSelectorSubtype) ? Constants.submenuItemOfSelectionWithSubSelectorSubtype : ConstantsGetter.GetConstants().submenuItemOfSelectionWithSubSelectorSubtypeFct()));
			subValue = (int)(subitemsValues.GetAt(i));

			if(subValue == -1)
			{
				captionString = new String(anyString);
			}
			else
			{
				captionString = new String(subValue);
			}

			subText = new Text(subSelection, subFont, captionString, textRect_left, textRect_top, textRect_width, textRect_height, Alignment.CENTER);
			subSelection.SetEnabledState(true);
			subSelector.SetSelectionAt(i, subSelection);
		}
		subSelector.UpdateScroller();
	}

}


public void ReleaseElementList (Selector subSelector, int selectionType) {

	Text subText = null;

	 Selection subSelection = null;
	 int subitemsValuesCount = 0;


	 Array_int subitemsValues = null;
	subitemsValues = GetSelectionSetupContentArray(selectionType);

	if(subitemsValues != null)
	{
		subitemsValuesCount = subitemsValues.GetCapacity();
	}

	for(int i = 0;i < subitemsValuesCount;i ++)
	{
		subSelection = (Selection)(subSelector.GetSelectionAt(i));
		subText = (Text)(subSelection.GetChild((((int)ConstantsEnglishPortrait.gameSetupSubSelectionTextIndex == (int)ConstantsEnglishLandscape.gameSetupSubSelectionTextIndex) ? Constants.gameSetupSubSelectionTextIndex : ConstantsGetter.GetConstants().gameSetupSubSelectionTextIndexFct())));
		subText.SetViewport(null);
		subText = null;
		subSelection.SetViewport(null);
		subSelection = null;
	}

}


public void InitValues () {

	UpdateValues(kUpdateMenu);

}


public void SaveValues () {

	UpdateValues(kUpdateSavedValues);

}


public void UpdateValues (int updateType) {


	
	
	
	if(mPlayerMode == kSinglePlayer)
	{
		switch(mGameModesMenu)
		{
			case kMarathon :
			{
				UpdateGameSetupItem((((int)ConstantsEnglishPortrait.marathonGameStartIndex == (int)ConstantsEnglishLandscape.marathonGameStartIndex) ? Constants.marathonGameStartIndex : ConstantsGetter.GetConstants().marathonGameStartIndexFct()), TetrisState.kSettingSingleMarathonStartingLevel, updateType);
			}
			break;

			case kUltra :
			{
				UpdateGameSetupItem((((int)ConstantsEnglishPortrait.ultraGameStartIndex == (int)ConstantsEnglishLandscape.ultraGameStartIndex) ? Constants.ultraGameStartIndex : ConstantsGetter.GetConstants().ultraGameStartIndexFct()), TetrisState.kSettingSingleUltraStartingLevel, updateType);
			}
			break;

			case k40Lines :
			{
				UpdateGameSetupItem((((int)ConstantsEnglishPortrait.fortyLinesGameStartIndex == (int)ConstantsEnglishLandscape.fortyLinesGameStartIndex) ? Constants.fortyLinesGameStartIndex : ConstantsGetter.GetConstants().fortyLinesGameStartIndexFct()), TetrisState.kSettingSingle40LinesStartingLevel, updateType);
			}
			break;

			default : ;
		}
	}


	
	
	





































else
	{

	}

}


public void UpdateGameSetupItem (int itemIndex, int setupOptionIndex, int updateType) {

	 TetrisState tetrisState = GetTetrisState();
	 Selector subSelector = ((Selector)(mpSelectionItem[itemIndex].GetChild((((int)ConstantsEnglishPortrait.gameSetupSubSelectorIndex == (int)ConstantsEnglishLandscape.gameSetupSubSelectorIndex) ? Constants.gameSetupSubSelectorIndex : ConstantsGetter.GetConstants().gameSetupSubSelectorIndexFct()))));

	switch(updateType)
	{
	case kUpdateMenu :
		{
			subSelector.SetSingleSelection(tetrisState.GetGameSetupOptions(setupOptionIndex), false);
		}
		break;

	case kUpdateSavedValues :
		{
			tetrisState.SetGameSetupOptions(setupOptionIndex, subSelector.GetSingleSelection());
		}
		break;

	default : ;
	}

}


public int GetStartLevelValue (int selectionId) {

	return  (int)(GetSelectorValue(selectionId, RSRC_commonPackage.gameLevelOptionValues_ID));

}


public int GetScoreLimitValue (int selectionId) {

	return  (int)(GetSelectorValue(selectionId, RSRC_commonPackage.scoreLimitOptionValues_ID));

}


public int GetTetriminosValue (int selectionId) {

	return  (int)(GetSelectorValue(selectionId, RSRC_commonPackage.tetriminosOptionValues_ID));

}


public int GetSelectorValue (int selectionId, int valueTabEntryPoint) {

	 Array_int subitemsValues = null;
	 Package commonPackageEntry = RessourcesManager.Get().GetPackage(PackageID.common);
	(subitemsValues)= (subitemsValues).Cast((commonPackageEntry).GetEntryPoint(valueTabEntryPoint), null);
	return  (int)(subitemsValues.GetAt(GetSingleSelectionFromSubSelection(selectionId)));

}


public int GetSingleSelectionFromSubSelection (int selectionId) {

	return  ((Selector)(mpSelectionItem[selectionId].GetChild((((int)ConstantsEnglishPortrait.gameSetupSubSelectorIndex == (int)ConstantsEnglishLandscape.gameSetupSubSelectorIndex) ? Constants.gameSetupSubSelectorIndex : ConstantsGetter.GetConstants().gameSetupSubSelectorIndexFct())))).GetSingleSelection();

}


public Array_int GetSelectionSetupContentArray (int selectionType) {

	 Array_int subitemsValues = null;

	 Package commonPackageEntry = RessourcesManager.Get().GetPackage(PackageID.common);

	 int networkGameValueOffset = 0;







switch(selectionType)
	{
	case (((int)ConstantsEnglishPortrait.menuStartLevelItemSelectionSubtype == (int)ConstantsEnglishLandscape.menuStartLevelItemSelectionSubtype) ? Constants.menuStartLevelItemSelectionSubtype : -123) :
		(subitemsValues)= (subitemsValues).Cast((commonPackageEntry).GetEntryPoint(RSRC_commonPackage.gameLevelOptionValues_ID + networkGameValueOffset), null);
		break;





case (((int)ConstantsEnglishPortrait.menuScoreLimitItemSelectionSubtype == (int)ConstantsEnglishLandscape.menuScoreLimitItemSelectionSubtype) ? Constants.menuScoreLimitItemSelectionSubtype : -123) :
		(subitemsValues)= (subitemsValues).Cast((commonPackageEntry).GetEntryPoint(RSRC_commonPackage.scoreLimitOptionValues_ID + networkGameValueOffset), null);
		break;

	case (((int)ConstantsEnglishPortrait.menuTetriminosItemSelectionSubtype == (int)ConstantsEnglishLandscape.menuTetriminosItemSelectionSubtype) ? Constants.menuTetriminosItemSelectionSubtype : -123) :
		(subitemsValues)= (subitemsValues).Cast((commonPackageEntry).GetEntryPoint(RSRC_commonPackage.tetriminosOptionValues_ID + networkGameValueOffset), null);
		break;
	}

	return  subitemsValues;

}


public Selection[] mpSelectionItem = new Selection[(((int)ConstantsEnglishPortrait.gameModesTotalElements == (int)ConstantsEnglishLandscape.gameModesTotalElements) ? Constants.gameModesTotalElements : -123)];

public int mPlayerMode;
public int mGameModesMenu;
public boolean mbChangedSetup;



}

