package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class MenuToolbox {

public static void RemoveSelectionInVerticalSelector (Selector theSelector, int selectionIndexToRemove) {

	
	
	

	 int numElem = theSelector.GetNumElements();



	 Selection removedSelection = theSelector.GetSelectionAt(selectionIndexToRemove);

	 boolean removingLastElement = selectionIndexToRemove == numElem - 1;

	 short liftPixel = 0;

	if(!removingLastElement)
	{
		 Selection s = theSelector.GetSelectionAt(selectionIndexToRemove + 1);
		liftPixel = (short)(s.GetRectTop() - removedSelection.GetRectTop());
	}

	
	for(int i = selectionIndexToRemove + 1;i < numElem;i ++)
	{
		 Selection s = theSelector.GetSelectionAt(i);
		s.SetTopLeft(s.GetRectLeft(), (short)(s.GetRectTop() - liftPixel));
	}

	 int indexThatWasSelected = theSelector.GetSingleSelection();

	 boolean wasSelected = indexThatWasSelected == selectionIndexToRemove;

	if(wasSelected)
	{
		
		 boolean foundNewSelection = false;


		if(!foundNewSelection)
		{
			 int directionSign = 1;

			for(int i = selectionIndexToRemove + directionSign;i < numElem;i += directionSign)
			{
				if(theSelector.GetSelectionAt(i).GetEnabledState())
				{
					foundNewSelection = true;
					theSelector.SetSingleSelection(i);
					break;
				}
			}
		}

		if(!foundNewSelection)
		{
			 int directionSign = -1;

			for(int i = selectionIndexToRemove + directionSign;i >= 0;i += directionSign)
			{
				if(theSelector.GetSelectionAt(i).GetEnabledState())
				{
					foundNewSelection = true;
					theSelector.SetSingleSelection(i);
					break;
				}
			}
		}
	}

	removedSelection.SetVisible(false);
	removedSelection.SetEnabledState(false);

}



/* One dimension array */
public static MenuToolbox[] InstArrayMenuToolbox(int size) {
	MenuToolbox[] newArray = new MenuToolbox[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new MenuToolbox();
	return newArray; }

/* Two dimension array */
public static MenuToolbox[][] InstArrayMenuToolbox(int size1, int size2) {
	MenuToolbox[][] newArray = new MenuToolbox[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new MenuToolbox[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new MenuToolbox(); }
	return newArray; }

/* Three dimension array */
public static MenuToolbox[][][] InstArrayMenuToolbox(int size1, int size2, int size3) {
	MenuToolbox[][][] newArray = new MenuToolbox[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new MenuToolbox[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new MenuToolbox[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new MenuToolbox(); } }
	return newArray; }

public MenuToolbox () { 
}




}

