package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class ParticleGenerator extends Viewport {

public  ParticleGenerator (short matrixAbsolutePosX, short matrixAbsolutePosY, short minoSize, BitmapMap hardDropParticlesBitmapMap) {
mkGravity = new F32((int)(((int)ConstantsEnglishPortrait.particlesGravity == (int)ConstantsEnglishLandscape.particlesGravity) ? Constants.particlesGravity : ConstantsGetter.GetConstants().particlesGravityFct()), 16);
mkLineClearParticleSpacing = new F32((int)(((int)ConstantsEnglishPortrait.particlesSpacingX == (int)ConstantsEnglishLandscape.particlesSpacingX) ? Constants.particlesSpacingX : ConstantsGetter.GetConstants().particlesSpacingXFct()), 16);
mkHardDropParticleSpacing = new F32((int)(((int)ConstantsEnglishPortrait.particlesHardDropSpacingX == (int)ConstantsEnglishLandscape.particlesHardDropSpacingX) ? Constants.particlesHardDropSpacingX : ConstantsGetter.GetConstants().particlesHardDropSpacingXFct()), 16);
mkMatrixAbsolutePosX = (matrixAbsolutePosX);
mkMatrixAbsolutePosY = (matrixAbsolutePosY);
mkMinoSize = (minoSize);

		
	SetRect((short)0, (short)0, (short)(((int)ConstantsEnglishPortrait.screenWidth == (int)ConstantsEnglishLandscape.screenWidth) ? Constants.screenWidth : ConstantsGetter.GetConstants().screenWidthFct()), (short)(((int)ConstantsEnglishPortrait.screenHeight == (int)ConstantsEnglishLandscape.screenHeight) ? Constants.screenHeight : ConstantsGetter.GetConstants().screenHeightFct()));	
	SetClipChildren(true);

	int i;


	
	for(i = 0;i < (((int)ConstantsEnglishPortrait.particlesLineClearMaxCount == (int)ConstantsEnglishLandscape.particlesLineClearMaxCount) ? Constants.particlesLineClearMaxCount : ConstantsGetter.GetConstants().particlesLineClearMaxCountFct());i ++)
	{
		
		mpLineClearParticles[i] = new Particle(null);
		mpLineClearParticles[i].SetViewport(this);
	}

	for(i = 0;i < (((int)ConstantsEnglishPortrait.particlesHardDropMaxCount == (int)ConstantsEnglishLandscape.particlesHardDropMaxCount) ? Constants.particlesHardDropMaxCount : ConstantsGetter.GetConstants().particlesHardDropMaxCountFct());i ++)
	{
		mpHardDropParticles[i] = new Particle(hardDropParticlesBitmapMap);
		mpHardDropParticles[i].SetViewport(this);
	}

}


public void destruct() {
	

}


public void InitializeClearLineParticles (int clearedLineCount) {

	
	
	if(mLineClearParticlesCount != 0)
	{		
		StopLineClearParticles();
	}

	mLineClearParticlesCount = clearedLineCount * (((int)ConstantsEnglishPortrait.particlesPerLine == (int)ConstantsEnglishLandscape.particlesPerLine) ? Constants.particlesPerLine : ConstantsGetter.GetConstants().particlesPerLineFct());


	
	
	mLineClearDurationMs = 0;

	
	 Well pWell = GetTetrisState().GetPlayer1GameState().GetWell();
	 int clearedLinesFlag = pWell.GetLastShotClearedLineFlags();

	 int particleCount = 0;

	 int clearedLineY = pWell.GetWellTop();
	

	F32 propulsionX = new F32();

	F32 propulsionY = new F32();

	
	
	for(int row = 0;row < clearedLineCount;row ++)
	{
		
		while(!pWell.IsClearedLineFromFlags(clearedLinesFlag, clearedLineY))
		{
			clearedLineY++;
		}



		for(int col = 0;col < (((int)ConstantsEnglishPortrait.particlesPerLine == (int)ConstantsEnglishLandscape.particlesPerLine) ? Constants.particlesPerLine : ConstantsGetter.GetConstants().particlesPerLineFct());col ++)
		{
			
			propulsionY = F32.FromInt(-FlMath.Random((short)(((int)ConstantsEnglishPortrait.particlesPropulsionYMin == (int)ConstantsEnglishLandscape.particlesPropulsionYMin) ? Constants.particlesPropulsionYMin : ConstantsGetter.GetConstants().particlesPropulsionYMinFct()), (short)(((int)ConstantsEnglishPortrait.particlesPropulsionYMax == (int)ConstantsEnglishLandscape.particlesPropulsionYMax) ? Constants.particlesPropulsionYMax : ConstantsGetter.GetConstants().particlesPropulsionYMaxFct())), 16);

			
			
			propulsionX = F32.FromInt(FlMath.Random((short)(((int)ConstantsEnglishPortrait.particlesPropulsionXMin == (int)ConstantsEnglishLandscape.particlesPropulsionXMin) ? Constants.particlesPropulsionXMin : ConstantsGetter.GetConstants().particlesPropulsionXMinFct()), (short)(((int)ConstantsEnglishPortrait.particlesPropulsionXMax == (int)ConstantsEnglishLandscape.particlesPropulsionXMax) ? Constants.particlesPropulsionXMax : ConstantsGetter.GetConstants().particlesPropulsionXMaxFct())), 16);		
			if((particleCount & 1) != 0)
			{
				propulsionX = propulsionX.Neg();
			}

			 int particleWellOffsetX = mkLineClearParticleSpacing.Mul(col).ToInt(16);

			mpLineClearParticles[particleCount].InitPropulsion((short)(mkMatrixAbsolutePosX + particleWellOffsetX), (short)(mkMatrixAbsolutePosY + (clearedLineY - (((int)ConstantsEnglishPortrait.wellVisibleHeight == (int)ConstantsEnglishLandscape.wellVisibleHeight) ? Constants.wellVisibleHeight : ConstantsGetter.GetConstants().wellVisibleHeightFct())) * mkMinoSize), propulsionX, propulsionY);			

			
			 int currentMinoCol = particleWellOffsetX / mkMinoSize;


			
			if(currentMinoCol >= (((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : ConstantsGetter.GetConstants().wellWidthFct()))
			{
				currentMinoCol = (((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : ConstantsGetter.GetConstants().wellWidthFct()) - 1;
			}			

			 byte blockColor = pWell.GetBlockColor(currentMinoCol, clearedLineY);


			mpLineClearParticles[particleCount].SetParticleBitmapMap(mpLineClearParticlesBitmapMaps[blockColor]);
			particleCount++;
		}

		clearedLineY++;
	}

	mLineClearParticlesDelayMs = (((int)ConstantsEnglishPortrait.particlesStartDelayMs == (int)ConstantsEnglishLandscape.particlesStartDelayMs) ? Constants.particlesStartDelayMs : ConstantsGetter.GetConstants().particlesStartDelayMsFct());

	
	
	RegisterInGlobalTime();

}


public void StartHardDropParticles (int col, int row, int fallingHeight) {
	

mHardDropDurationMs = 0;

	F32 propulsionX = new F32();

	F32 propulsionY = new F32();


	 short startLeft = (short)(mkMatrixAbsolutePosX + col * mkMinoSize);

	 short startTop = (short)(mkMatrixAbsolutePosY + (row - (((int)ConstantsEnglishPortrait.wellSkyline == (int)ConstantsEnglishLandscape.wellSkyline) ? Constants.wellSkyline : ConstantsGetter.GetConstants().wellSkylineFct())) * mkMinoSize);


	for(int i = 0;i < (((int)ConstantsEnglishPortrait.particlesPerHardDropMino == (int)ConstantsEnglishLandscape.particlesPerHardDropMino) ? Constants.particlesPerHardDropMino : ConstantsGetter.GetConstants().particlesPerHardDropMinoFct());i ++)
	{
		
		propulsionY = F32.FromInt(-FlMath.Random((short)(((int)ConstantsEnglishPortrait.particlesHardDropPropulsionYMin == (int)ConstantsEnglishLandscape.particlesHardDropPropulsionYMin) ? Constants.particlesHardDropPropulsionYMin : ConstantsGetter.GetConstants().particlesHardDropPropulsionYMinFct()), (short)(((int)ConstantsEnglishPortrait.particlesHardDropPropulsionYMax == (int)ConstantsEnglishLandscape.particlesHardDropPropulsionYMax) ? Constants.particlesHardDropPropulsionYMax : ConstantsGetter.GetConstants().particlesHardDropPropulsionYMaxFct())), 16);

		
		
		propulsionX = F32.FromInt(FlMath.Random((short)(((int)ConstantsEnglishPortrait.particlesHardDropPropulsionXMin == (int)ConstantsEnglishLandscape.particlesHardDropPropulsionXMin) ? Constants.particlesHardDropPropulsionXMin : ConstantsGetter.GetConstants().particlesHardDropPropulsionXMinFct()), (short)(((int)ConstantsEnglishPortrait.particlesHardDropPropulsionXMax == (int)ConstantsEnglishLandscape.particlesHardDropPropulsionXMax) ? Constants.particlesHardDropPropulsionXMax : ConstantsGetter.GetConstants().particlesHardDropPropulsionXMaxFct())), 16);
		if((i & 1) == 0)
		{
			propulsionX = propulsionX.Neg();
		}
		
		 F32 fallingRatio = new F32(F32.FromInt(fallingHeight, 16).Div(F32.FromInt((((int)ConstantsEnglishPortrait.particlesHardDropMaxHeightFactor == (int)ConstantsEnglishLandscape.particlesHardDropMaxHeightFactor) ? Constants.particlesHardDropMaxHeightFactor : ConstantsGetter.GetConstants().particlesHardDropMaxHeightFactorFct()), 16), 16));

		propulsionX = propulsionX.Mul(fallingRatio, 16);

		mpHardDropParticles[mHardDropParticlesCount].InitPropulsion((short)(startLeft + mkHardDropParticleSpacing.Mul(i).ToInt(16)), startTop, propulsionX, propulsionY);
		mpHardDropParticles[mHardDropParticlesCount].SetVisible(true);

		mHardDropParticlesCount++;


	}
	

	
	
	RegisterInGlobalTime();

}


public void StopLineClearParticles () {

	
	if(mHardDropParticlesCount == 0)
	{
		UnRegisterInGlobalTime();
	}	

	for(int i = 0;i < mLineClearParticlesCount;i ++)
	{
		mpLineClearParticles[i].SetVisible(false);
	}

	mLineClearParticlesCount = 0;

}


public void StopHardDropParticles () {

	
	if(mLineClearParticlesCount == 0)
	{
		UnRegisterInGlobalTime();
	}	

	for(int i = 0;i < mHardDropParticlesCount;i ++)
	{
		mpHardDropParticles[i].SetVisible(false);
	}

	mHardDropParticlesCount = 0;

}


public void OnTime (int timeMs, int deltaTimeMs) {


	if(mLineClearParticlesCount > 0)
	{
		 boolean updateParticles = true;


		
		if(mLineClearParticlesDelayMs > 0)
		{
			mLineClearParticlesDelayMs -= deltaTimeMs;

			
			if(mLineClearParticlesDelayMs <= 0)
			{
				for(int i = 0;i < mLineClearParticlesCount;i ++)
				{
					mpLineClearParticles[i].SetVisible(true);
				}
			}
			else
			{
				updateParticles = false;
			}
		}
		
		if(updateParticles)
		{
			mLineClearDurationMs += deltaTimeMs;

			if(mLineClearDurationMs < (((int)ConstantsEnglishPortrait.particlesLifeTimeMs == (int)ConstantsEnglishLandscape.particlesLifeTimeMs) ? Constants.particlesLifeTimeMs : ConstantsGetter.GetConstants().particlesLifeTimeMsFct()))
			{
				 F32 acceleration = new F32(GetIntegratedAcceleration(mLineClearDurationMs));
			

				for(int i = 0;i < mLineClearParticlesCount;i ++)
				{			
					mpLineClearParticles[i].UpdatePosition(acceleration, mLineClearDurationMs);
				}
			}
			else
			{
				StopLineClearParticles();
			}	
		}		
	}

	if(mHardDropParticlesCount > 0)
	{		
		mHardDropDurationMs += deltaTimeMs;

		if(mHardDropDurationMs < (((int)ConstantsEnglishPortrait.particlesHardDropLifeTimeMs == (int)ConstantsEnglishLandscape.particlesHardDropLifeTimeMs) ? Constants.particlesHardDropLifeTimeMs : ConstantsGetter.GetConstants().particlesHardDropLifeTimeMsFct()))
		{			
			 F32 acceleration = new F32(GetIntegratedAcceleration(mHardDropDurationMs));


			for(int i = 0;i < mHardDropParticlesCount;i ++)
			{			
				mpHardDropParticles[i].UpdatePosition(acceleration, mHardDropDurationMs);
			}
		}
		else
		{
			StopHardDropParticles();
		}		
	}

}


public void LoadLineClearParticlesBitmapMaps (Package pPackage) {

	for(int i = 0;i < (((int)ConstantsEnglishPortrait.particlesLineClearColorCount == (int)ConstantsEnglishLandscape.particlesLineClearColorCount) ? Constants.particlesLineClearColorCount : ConstantsGetter.GetConstants().particlesLineClearColorCountFct());i ++)
	{		
		(mpLineClearParticlesBitmapMaps[i])= (mpLineClearParticlesBitmapMaps[i]).Cast((pPackage).GetEntryPoint(RSRC_gameScenePackage.blockParticlesLightBlueBitmapMap_ID + i), null);
	}

}


public TetrisState GetTetrisState () {

	return  GetApp().GetTetrisState();

}


public static TetrisApp GetApp () {

	return  TetrisApp.Get();

}


public F32 GetIntegratedAcceleration (int totalTimeMs) {

	
	 F32 durationSec = new F32(F32.FromInt(totalTimeMs, 16).DivPower2(10));
  
	 F32 tt = new F32(durationSec.Mul(durationSec, 16));

	return  mkGravity.Mul(tt, 16).DivPower2(1);

}


public BitmapMap[] mpLineClearParticlesBitmapMaps = new BitmapMap[(((int)ConstantsEnglishPortrait.particlesLineClearColorCount == (int)ConstantsEnglishLandscape.particlesLineClearColorCount) ? Constants.particlesLineClearColorCount : -123)];

public Particle[] mpLineClearParticles = new Particle[(((int)ConstantsEnglishPortrait.particlesLineClearMaxCount == (int)ConstantsEnglishLandscape.particlesLineClearMaxCount) ? Constants.particlesLineClearMaxCount : -123)];

public Particle[] mpHardDropParticles = new Particle[(((int)ConstantsEnglishPortrait.particlesHardDropMaxCount == (int)ConstantsEnglishLandscape.particlesHardDropMaxCount) ? Constants.particlesHardDropMaxCount : -123)];

public int mLineClearParticlesCount;
public int mLineClearDurationMs;
public int mLineClearParticlesDelayMs;
public int mHardDropParticlesCount;
public int mHardDropDurationMs;
public F32 mkGravity;
public F32 mkLineClearParticleSpacing;
public F32 mkHardDropParticleSpacing;
public short mkMatrixAbsolutePosX;
public short mkMatrixAbsolutePosY;
public int mkMinoSize;



}

