package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class Piece extends Viewport {

public final static int kInvalidPiece = -2;
public final static int kIsometricV0 = -1;
public final static int kIsometricV1 = 0;
public final static int kIsometricV2 = 1;
public final static int kIsometricV3 = 2;
public final static int kPieceOutsideWell = 3;
public final static int kPieceFalling = 4;
public final static int kPieceHighlight = 5;
public final static int kPieceRebound = 6;
public final static int kPieceGhost = 7;

public  Piece (Package pMinoPackage, int pieceType, TimeSystem pHighlightTimeSystem) {
mPieceType = (pieceType);
mpHighlightAnimTimeSystem = pHighlightTimeSystem;




if(pHighlightTimeSystem != null)
	{
		
		pHighlightTimeSystem.Register(this);
	}	
for(int i = 0;i < (((int)ConstantsEnglishPortrait.minosPerTetrimino == (int)ConstantsEnglishLandscape.minosPerTetrimino) ? Constants.minosPerTetrimino : ConstantsGetter.GetConstants().minosPerTetriminoFct());i ++)
	{
		mpMinoSprites[i] = new MinoSprite(pMinoPackage);
		mpMinoSprites[i].SetViewport(this);
	}


	
	if(mPieceType == kPieceFalling)
	{
		
		int i;

		for(i = 0;i < (((int)ConstantsEnglishPortrait.softDropBitmapCount == (int)ConstantsEnglishLandscape.softDropBitmapCount) ? Constants.softDropBitmapCount : ConstantsGetter.GetConstants().softDropBitmapCountFct());i ++)
		{
			(mpSoftDropColorMinoBitmapGroup[i])= (mpSoftDropColorMinoBitmapGroup[i]).Cast((pMinoPackage).GetEntryPoint(RSRC_playerMinoPackage.softDropTrailLightBlueBitmapGrid_ID + i), null);
		}
		
		for(i = 0;i < (((int)ConstantsEnglishPortrait.minosPerTetrimino == (int)ConstantsEnglishLandscape.minosPerTetrimino) ? Constants.minosPerTetrimino : ConstantsGetter.GetConstants().minosPerTetriminoFct());i ++)
		{
			mpSoftDropCurrentIndexedSprite[i] = new IndexedSprite();
			mpSoftDropCurrentIndexedSprite[i].SetBitmapGroup(mpSoftDropColorMinoBitmapGroup[0]);
			mpSoftDropCurrentIndexedSprite[i].SetViewport(this);
		}	
	}
	else
	{
		for(int _i = 0;_i < mpSoftDropCurrentIndexedSprite.length;_i ++) mpSoftDropCurrentIndexedSprite[_i] = null;
	}
if(mPieceType < kPieceOutsideWell)
	{
		 BitmapGroup pIsometricBitmapGroup = null;
		
		(mpIsometricXOffset)= (mpIsometricXOffset).Cast((pMinoPackage).GetEntryPoint(RSRC_playerMinoPackage.isometricMinoOffsetX_ID), null);
		(mpIsometricXYOffset)= (mpIsometricXYOffset).Cast((pMinoPackage).GetEntryPoint(RSRC_playerMinoPackage.isometricMinoOffsetXY_ID), null);
		(mpIsometricYOffset)= (mpIsometricYOffset).Cast((pMinoPackage).GetEntryPoint(RSRC_playerMinoPackage.isometricMinoOffsetY_ID), null);

		(pIsometricBitmapGroup)= (pIsometricBitmapGroup).Cast((pMinoPackage).GetEntryPoint(RSRC_playerMinoPackage.isometricMinoBitmapMap_ID), null);

		for(int i = 0;i < (((int)ConstantsEnglishPortrait.minosPerTetrimino == (int)ConstantsEnglishLandscape.minosPerTetrimino) ? Constants.minosPerTetrimino : ConstantsGetter.GetConstants().minosPerTetriminoFct());i ++)
		{
			mpIsometricIndexedSprite[i] = new IndexedSprite();
			mpIsometricIndexedSprite[i].SetBitmapGroup(pIsometricBitmapGroup);
			mpIsometricIndexedSprite[i].SetViewport(this);
			if(mPieceType == kIsometricV0)
			{
				
				mpIsometricIndexedSprite[i].SetVisible(false);
			}
			else
			{
				
				mpMinoSprites[i].SetVisible(false);
			}
		}

		ClearIsoDrawingMatrix();
	}
SetSize((short) ((((int)ConstantsEnglishPortrait.pieceViewportSize == (int)ConstantsEnglishLandscape.pieceViewportSize) ? Constants.pieceViewportSize : ConstantsGetter.GetConstants().pieceViewportSizeFct())),

		mPieceType == kPieceFalling ? (short)(mpSoftDropCurrentIndexedSprite[0].GetRectHeight() + (((int)ConstantsEnglishPortrait.pieceViewportSize == (int)ConstantsEnglishLandscape.pieceViewportSize) ? Constants.pieceViewportSize : ConstantsGetter.GetConstants().pieceViewportSizeFct())) : (short)((((int)ConstantsEnglishPortrait.pieceViewportSize == (int)ConstantsEnglishLandscape.pieceViewportSize) ? Constants.pieceViewportSize : ConstantsGetter.GetConstants().pieceViewportSizeFct()))


);

	SetVisible(false);

}


public void destruct() {


}


public void OnTime (int totalTime, int deltaTime) {






	if(mpHighlightAnimTimeSystem.GetTotalTime() >= (((int)ConstantsEnglishPortrait.pieceHighlightAnimTimeMs == (int)ConstantsEnglishLandscape.pieceHighlightAnimTimeMs) ? Constants.pieceHighlightAnimTimeMs : ConstantsGetter.GetConstants().pieceHighlightAnimTimeMsFct()))
	{
		mpHighlightAnimTimeSystem.UnRegisterInGlobalTime();
		SetVisible(false);
	}

}


public void UpdatePosition () {

	if(mpTetrimino == null)
	{
		
		return ;
	}	

	 short tetriminoPixPosX = (short)((mpTetrimino.GetMatrixPosX() - (((int)ConstantsEnglishPortrait.tetriminoCenterOffset == (int)ConstantsEnglishLandscape.tetriminoCenterOffset) ? Constants.tetriminoCenterOffset : ConstantsGetter.GetConstants().tetriminoCenterOffsetFct())) * mpMinoSprites[0].GetRectWidth());

	 short tetriminoPixPosY = (short)((mpTetrimino.GetMatrixPosY() - (((int)ConstantsEnglishPortrait.tetriminoCenterOffset == (int)ConstantsEnglishLandscape.tetriminoCenterOffset) ? Constants.tetriminoCenterOffset : ConstantsGetter.GetConstants().tetriminoCenterOffsetFct()) - (((int)ConstantsEnglishPortrait.wellSkyline == (int)ConstantsEnglishLandscape.wellSkyline) ? Constants.wellSkyline : ConstantsGetter.GetConstants().wellSkylineFct())) * mpMinoSprites[0].GetRectHeight() - (mPieceType == kPieceFalling ? mpSoftDropCurrentIndexedSprite[0].GetRectHeight() : 0));

	
	if(IsInsideWell())
	{
		tetriminoPixPosX = (short)(tetriminoPixPosX + (((int)ConstantsEnglishPortrait.playerMatrixMarginSize == (int)ConstantsEnglishLandscape.playerMatrixMarginSize) ? Constants.playerMatrixMarginSize : ConstantsGetter.GetConstants().playerMatrixMarginSizeFct()));
		tetriminoPixPosY = (short)(tetriminoPixPosY + (((int)ConstantsEnglishPortrait.playerMatrixMarginSize == (int)ConstantsEnglishLandscape.playerMatrixMarginSize) ? Constants.playerMatrixMarginSize : ConstantsGetter.GetConstants().playerMatrixMarginSizeFct()));
	}


	if(mPieceType == kPieceFalling)
	{
		SetSoftDrop(mpTetrimino.IsSoftDropping());
	}
tetriminoPixPosX = (short)(tetriminoPixPosX + mLeftOffset);
	tetriminoPixPosY = (short)(tetriminoPixPosY + mTopOffset);

	if(GetRectLeft() != tetriminoPixPosX || GetRectTop() != tetriminoPixPosY)
	{
		SetTopLeft(tetriminoPixPosX, tetriminoPixPosY);
	}

}


public void UpdateFacing () {

	if(mpTetrimino == null)
	{
		
		return ;
	}	

	 short leftMost = (short)(((int)ConstantsEnglishPortrait.pieceViewportSize == (int)ConstantsEnglishLandscape.pieceViewportSize) ? Constants.pieceViewportSize : ConstantsGetter.GetConstants().pieceViewportSizeFct());

	 short topMost = (short)(((int)ConstantsEnglishPortrait.pieceViewportSize == (int)ConstantsEnglishLandscape.pieceViewportSize) ? Constants.pieceViewportSize : ConstantsGetter.GetConstants().pieceViewportSizeFct());



	topMost = (short)(topMost + (mPieceType == kPieceFalling ? mpSoftDropCurrentIndexedSprite[0].GetRectHeight() : 0));
 short rightMost = 0;

	 short bottomMost = 0;


	for(int i = 0;i < (((int)ConstantsEnglishPortrait.minosPerTetrimino == (int)ConstantsEnglishLandscape.minosPerTetrimino) ? Constants.minosPerTetrimino : ConstantsGetter.GetConstants().minosPerTetriminoFct());i ++)
	{

		mpMinoSprites[i].SetSticky((mpTetrimino.GetSticky(i, (int)mpTetrimino.GetFacingDir())));
 short left = 0;

		 short top = 0;


		if(IsInsideWell())
		{
		
			left = (short)((mpTetrimino.GetMinoX(i) + (((int)ConstantsEnglishPortrait.tetriminoCenterOffset == (int)ConstantsEnglishLandscape.tetriminoCenterOffset) ? Constants.tetriminoCenterOffset : ConstantsGetter.GetConstants().tetriminoCenterOffsetFct())) * mpMinoSprites[0].GetRectWidth());
			top = (short)((mPieceType == kPieceFalling ? mpSoftDropCurrentIndexedSprite[0].GetRectHeight() : 0) + 
(mpTetrimino.GetMinoY(i) + (((int)ConstantsEnglishPortrait.tetriminoCenterOffset == (int)ConstantsEnglishLandscape.tetriminoCenterOffset) ? Constants.tetriminoCenterOffset : ConstantsGetter.GetConstants().tetriminoCenterOffsetFct())) * mpMinoSprites[0].GetRectHeight());
		}
		else
		{
			left = (short)((mpTetrimino.GetMinoX(i) + (((int)ConstantsEnglishPortrait.tetriminoCenterOffset == (int)ConstantsEnglishLandscape.tetriminoCenterOffset) ? Constants.tetriminoCenterOffset : ConstantsGetter.GetConstants().tetriminoCenterOffsetFct())) * mpMinoSprites[0].GetRectWidth() + (mpTetrimino.GetType() == Tetrimino.kTetriminoI || mpTetrimino.GetType() == Tetrimino.kTetriminoO ? - (((int)ConstantsEnglishPortrait.minoHalfWidth == (int)ConstantsEnglishLandscape.minoHalfWidth) ? Constants.minoHalfWidth : ConstantsGetter.GetConstants().minoHalfWidthFct()) : 0));
			top = (short)((mpTetrimino.GetMinoY(i) + (((int)ConstantsEnglishPortrait.tetriminoCenterOffset == (int)ConstantsEnglishLandscape.tetriminoCenterOffset) ? Constants.tetriminoCenterOffset : ConstantsGetter.GetConstants().tetriminoCenterOffsetFct())) * mpMinoSprites[0].GetRectHeight() + (mpTetrimino.GetType() == Tetrimino.kTetriminoI ? 0 : (((int)ConstantsEnglishPortrait.minoHalfHeight == (int)ConstantsEnglishLandscape.minoHalfHeight) ? Constants.minoHalfHeight : ConstantsGetter.GetConstants().minoHalfHeightFct())));
		}

		mpMinoSprites[i].SetTopLeft(left, top);

		if(left < leftMost || leftMost == -1)
		{
			leftMost = left;
		}
		if(top < topMost || topMost == -1)
		{
			topMost = top;
		}
		if(left > rightMost || rightMost == -1)
		{
			rightMost = left;
		}
		if(top > bottomMost || bottomMost == -1)
		{
			bottomMost = top;
		}
	}

	if(mPieceType == kPieceFalling || mPieceType == kPieceGhost || mPieceType == kPieceRebound)
	{

		if(mPieceType == kPieceFalling)
		{
			topMost = (short)(topMost - mpSoftDropCurrentIndexedSprite[0].GetRectHeight());
		}
mLeftOffset = leftMost;
		mTopOffset = topMost;
		
		for(int i = 0;i < (((int)ConstantsEnglishPortrait.minosPerTetrimino == (int)ConstantsEnglishLandscape.minosPerTetrimino) ? Constants.minosPerTetrimino : ConstantsGetter.GetConstants().minosPerTetriminoFct());i ++)
		{
			mpMinoSprites[i].SetTopLeft((short)(mpMinoSprites[i].GetRectLeft() - leftMost), (short)(mpMinoSprites[i].GetRectTop() - topMost));
		}

		SetSize((short)(rightMost - leftMost + mpMinoSprites[0].GetRectWidth()), (short)(bottomMost - topMost + mpMinoSprites[0].GetRectHeight()));
	}

}


public void OnTetriminoLock ( Tetrimino lockedTetrimino, WindowViewport window) {
	



SetTetrimino(lockedTetrimino);
	UpdatePosition();	

	
	window.SetRect(GetRect());
	SetTopLeft((short)0, (short)0);
	window.Reset();


	mpHighlightAnimTimeSystem.RegisterInGlobalTime();
	mpHighlightAnimTimeSystem.SetTotalTime(0);
	mpHighlightAnimTimeSystem.OnTime(0, 0);
SetVisible(true);

}


public void SetTetrimino ( Tetrimino tetrimino, boolean ghost, int isometricPieceType) {
 


SetVisible(tetrimino != null);
	mpTetrimino = tetrimino; 

	if(tetrimino == null)
	{
		return ;
	}


	
	if(isometricPieceType > kIsometricV0 && isometricPieceType <= kIsometricV3)
	{



		mPieceType = (int)isometricPieceType;
		ClearIsoDrawingMatrix();
		SetIsoDrawingMatrix();

	}
	else
{
		for(int i = 0;i < (((int)ConstantsEnglishPortrait.minosPerTetrimino == (int)ConstantsEnglishLandscape.minosPerTetrimino) ? Constants.minosPerTetrimino : ConstantsGetter.GetConstants().minosPerTetriminoFct());i ++)
		{
			mpMinoSprites[i].SetMinoColor(ghost ? (byte)(((int)ConstantsEnglishPortrait.minoTypeGhost == (int)ConstantsEnglishLandscape.minoTypeGhost) ? Constants.minoTypeGhost : ConstantsGetter.GetConstants().minoTypeGhostFct()) : tetrimino.GetMinoColor());

			
			if(isometricPieceType == kIsometricV0)
			{
				mPieceType = (int)isometricPieceType;
				mpIsometricIndexedSprite[i].SetVisible(false);
				mpMinoSprites[i].SetVisible(true);
			}
}
		UpdateFacing();
	}

}


public Tetrimino GetTetrimino() {
 return  mpTetrimino; 
}


public void Term () {
  

	if(mPieceType == kPieceHighlight && mpHighlightAnimTimeSystem != null)
	{
		mpHighlightAnimTimeSystem.UnRegister(this);
		mpHighlightAnimTimeSystem.UnRegisterInGlobalTime();
	}
for(int i = 0;i < (((int)ConstantsEnglishPortrait.minosPerTetrimino == (int)ConstantsEnglishLandscape.minosPerTetrimino) ? Constants.minosPerTetrimino : ConstantsGetter.GetConstants().minosPerTetriminoFct());i ++)
	{
		mpMinoSprites[i].SetViewport(null);
		mpMinoSprites[i] = null;
	}


	if(mPieceType == kPieceFalling)
	{
		for(int i = 0;i < (((int)ConstantsEnglishPortrait.minosPerTetrimino == (int)ConstantsEnglishLandscape.minosPerTetrimino) ? Constants.minosPerTetrimino : ConstantsGetter.GetConstants().minosPerTetriminoFct());i ++)
		{
			mpSoftDropCurrentIndexedSprite[i].SetViewport(null);
			mpSoftDropCurrentIndexedSprite[i] = null;
		}
	}
if(mPieceType < kPieceOutsideWell)
	{
		for(int spriteIndex = 0;spriteIndex < (((int)ConstantsEnglishPortrait.minosPerTetrimino == (int)ConstantsEnglishLandscape.minosPerTetrimino) ? Constants.minosPerTetrimino : ConstantsGetter.GetConstants().minosPerTetriminoFct());spriteIndex ++)
		{
			mpIsometricIndexedSprite[spriteIndex].SetViewport(null);
			mpIsometricIndexedSprite[spriteIndex] = null;
		}
	}

}


public void SetEnabled (boolean enable) {

	if(mpTetrimino != null)
	{
		 byte minoColor = (byte)(enable ? mpTetrimino.GetMinoColor() : (((int)ConstantsEnglishPortrait.minoTypeSolid == (int)ConstantsEnglishLandscape.minoTypeSolid) ? Constants.minoTypeSolid : ConstantsGetter.GetConstants().minoTypeSolidFct()));


		for(int i = 0;i < (((int)ConstantsEnglishPortrait.minosPerTetrimino == (int)ConstantsEnglishLandscape.minosPerTetrimino) ? Constants.minosPerTetrimino : ConstantsGetter.GetConstants().minosPerTetriminoFct());i ++)
		{

			if(mPieceType > kIsometricV0 && mPieceType <= kIsometricV3)
			{
				mpIsometricIndexedSprite[i].SetCurrentFrame(mPieceType * (((int)ConstantsEnglishPortrait.isometricViewIndexOffset == (int)ConstantsEnglishLandscape.isometricViewIndexOffset) ? Constants.isometricViewIndexOffset : ConstantsGetter.GetConstants().isometricViewIndexOffsetFct()) + minoColor);
			}
			else
{
				mpMinoSprites[i].SetMinoColor(minoColor);
			}
		}

		Invalidate();
	}


}


public void ControlValue (int valueCode, boolean setValue, Controller controller) {














if(valueCode == (((int)ConstantsEnglishPortrait.isometricIndex == (int)ConstantsEnglishLandscape.isometricIndex) ? Constants.isometricIndex : ConstantsGetter.GetConstants().isometricIndexFct()))
	{


		if(setValue)
		{
			SetTetrimino(mpTetrimino, false, (int)(controller.GetLongValue()));
		}
		else
		{
			controller.SetValue((int)mPieceType);
		}
	}
	else
{
		super.ControlValue(valueCode, setValue, controller);
	}	

}


public void SetSoftDrop (boolean enable) {



	
	if(enable && mpTetrimino.CanFall())
	{
		UpdateSoftDropSprite();
	}
	else
	{
		for(int i = 0;i < (((int)ConstantsEnglishPortrait.minosPerTetrimino == (int)ConstantsEnglishLandscape.minosPerTetrimino) ? Constants.minosPerTetrimino : ConstantsGetter.GetConstants().minosPerTetriminoFct());i ++)
		{
			mpSoftDropCurrentIndexedSprite[i].SetVisible(false);
		}
	}

}


public void UpdateSoftDropSprite () {



	 int softDropBitmapIndex = mpTetrimino.GetMinoColor();


	for(int i = 0;i < (((int)ConstantsEnglishPortrait.minosPerTetrimino == (int)ConstantsEnglishLandscape.minosPerTetrimino) ? Constants.minosPerTetrimino : ConstantsGetter.GetConstants().minosPerTetriminoFct());i ++)
	{
		
		if((mpTetrimino.GetSticky(i, (int)mpTetrimino.GetFacingDir()) & 8) == 0)
		{
			SetSoftDropSprite(mpTetrimino.GetMatrixPosY() & 1, mpSoftDropCurrentIndexedSprite[i], i);
			mpSoftDropCurrentIndexedSprite[i].SetVisible(true);
			mpSoftDropCurrentIndexedSprite[i].SetBitmapGroup(mpSoftDropColorMinoBitmapGroup[softDropBitmapIndex]);
		}
		else
		{
			mpSoftDropCurrentIndexedSprite[i].SetVisible(false);
		}
	}

}


public void SetSoftDropSprite (int longTrail, IndexedSprite currentIndexedSprite, int indexMinos) {


	
	currentIndexedSprite.SetCurrentFrame((int)longTrail);
	
	
	currentIndexedSprite.SetTopLeft((short)((mpTetrimino.GetMinoX(indexMinos) + (((int)ConstantsEnglishPortrait.tetriminoCenterOffset == (int)ConstantsEnglishLandscape.tetriminoCenterOffset) ? Constants.tetriminoCenterOffset : ConstantsGetter.GetConstants().tetriminoCenterOffsetFct())) * mpMinoSprites[0].GetRectWidth() - mLeftOffset), (short)((mpTetrimino.GetMinoY(indexMinos) + (((int)ConstantsEnglishPortrait.tetriminoCenterOffset == (int)ConstantsEnglishLandscape.tetriminoCenterOffset) ? Constants.tetriminoCenterOffset : ConstantsGetter.GetConstants().tetriminoCenterOffsetFct())) * mpMinoSprites[0].GetRectHeight() - mTopOffset));

}


public boolean IsInsideWell() {
 return	mPieceType == kPieceFalling ||
													mPieceType == kPieceHighlight ||
													mPieceType == kPieceGhost ||
													mPieceType == kPieceRebound; 
}


public int mPieceType;
public Tetrimino mpTetrimino;
public short mLeftOffset;
public short mTopOffset;
public MinoSprite[] mpMinoSprites = new MinoSprite[(((int)ConstantsEnglishPortrait.minosPerTetrimino == (int)ConstantsEnglishLandscape.minosPerTetrimino) ? Constants.minosPerTetrimino : -123)];

public IndexedSprite[] mpSoftDropCurrentIndexedSprite = new IndexedSprite[(((int)ConstantsEnglishPortrait.minosPerTetrimino == (int)ConstantsEnglishLandscape.minosPerTetrimino) ? Constants.minosPerTetrimino : -123)];

public BitmapGroup[] mpSoftDropColorMinoBitmapGroup = new BitmapGroup[(((int)ConstantsEnglishPortrait.softDropBitmapCount == (int)ConstantsEnglishLandscape.softDropBitmapCount) ? Constants.softDropBitmapCount : -123)];

public void SetIsoDrawingMatrix () {



	 int x = 0;

	 int y = 0;


	for(int minoIndex = 0;minoIndex < (((int)ConstantsEnglishPortrait.minosPerTetrimino == (int)ConstantsEnglishLandscape.minosPerTetrimino) ? Constants.minosPerTetrimino : ConstantsGetter.GetConstants().minosPerTetriminoFct());minoIndex ++)
	{
		x = (mpTetrimino.GetMinoX(minoIndex) + 1);
		y = (mpTetrimino.GetMinoY(minoIndex) + 1);




		mpIsometricDrawingMatrice[x][y] = minoIndex;
	}

	 int height = 2;


	
	 int xAdjustFactor = 0;

	
	 int yAdjustFactor = 0;


	if(mpTetrimino.GetType() == Tetrimino.kTetriminoI)
	{
		height--;
		yAdjustFactor = -1;
	}

	
	
	if(mpTetrimino.GetType() == Tetrimino.kTetriminoO)
	{
		xAdjustFactor = -1;
	}
	
	 int width = 0;

	 int i = 0;

	for(i = (((int)ConstantsEnglishPortrait.minosPerTetrimino == (int)ConstantsEnglishLandscape.minosPerTetrimino) ? Constants.minosPerTetrimino : ConstantsGetter.GetConstants().minosPerTetriminoFct()) - 1;i >= 0;i --)
	{
		if(mpIsometricDrawingMatrice[i][0] != -1|| mpIsometricDrawingMatrice[i][1] != -1)
		{
			width++;
		}

		
		mpMinoSprites[i].SetVisible(false);
}

	
	mpIsometricIndexedSprite[0].SetCurrentFrame(mPieceType * (((int)ConstantsEnglishPortrait.isometricViewIndexOffset == (int)ConstantsEnglishLandscape.isometricViewIndexOffset) ? Constants.isometricViewIndexOffset : ConstantsGetter.GetConstants().isometricViewIndexOffsetFct()) + mpTetrimino.GetMinoColor());

	 int isoMinoHeight = mpIsometricIndexedSprite[0].GetRectHeight();

	 int isoMinoWidth = mpIsometricIndexedSprite[0].GetRectWidth();


	mCenterOffsetX = ((((int)ConstantsEnglishPortrait.pieceViewportSize == (int)ConstantsEnglishLandscape.pieceViewportSize) ? Constants.pieceViewportSize : ConstantsGetter.GetConstants().pieceViewportSizeFct()) - (width * isoMinoWidth - (width - 1) * mpIsometricXOffset.GetAt(mPieceType))) /2;
	mCenterOffsetY = ((((int)ConstantsEnglishPortrait.pieceViewportSize == (int)ConstantsEnglishLandscape.pieceViewportSize) ? Constants.pieceViewportSize : ConstantsGetter.GetConstants().pieceViewportSizeFct()) - isoMinoHeight - (width - 1) * mpIsometricXYOffset.GetAt(mPieceType) - (height - 1) * (isoMinoHeight - mpIsometricYOffset.GetAt(mPieceType))) /2;

	 int isoMinoIndex = 0;


	for(i = (((int)ConstantsEnglishPortrait.minosPerTetrimino == (int)ConstantsEnglishLandscape.minosPerTetrimino) ? Constants.minosPerTetrimino : ConstantsGetter.GetConstants().minosPerTetriminoFct()) - 1;i >= 0;i --)
	{
		for(int j = 1;j >= 0;j --)
		{
			if(mpIsometricDrawingMatrice[i][j] != -1)
			{
				mpIsometricIndexedSprite[isoMinoIndex].SetVisible(true);
				mpIsometricIndexedSprite[isoMinoIndex].SetCurrentFrame(mPieceType * (((int)ConstantsEnglishPortrait.isometricViewIndexOffset == (int)ConstantsEnglishLandscape.isometricViewIndexOffset) ? Constants.isometricViewIndexOffset : ConstantsGetter.GetConstants().isometricViewIndexOffsetFct()) + mpTetrimino.GetMinoColor());
				mpIsometricIndexedSprite[isoMinoIndex].SetTopLeft(ConvertIsoIndexToDrawingX(i + xAdjustFactor), ConvertIsoIndexToDrawingY(i, j + yAdjustFactor));
				
				isoMinoIndex++;
			}
		}
	}



}


public void ClearIsoDrawingMatrix () {

	for(int i = 0;i < (((int)ConstantsEnglishPortrait.minosPerTetrimino == (int)ConstantsEnglishLandscape.minosPerTetrimino) ? Constants.minosPerTetrimino : ConstantsGetter.GetConstants().minosPerTetriminoFct());i ++)
	{
		for(int j = 0;j < (((int)ConstantsEnglishPortrait.isometricMatrixHeight == (int)ConstantsEnglishLandscape.isometricMatrixHeight) ? Constants.isometricMatrixHeight : ConstantsGetter.GetConstants().isometricMatrixHeightFct());j ++)
		{
			mpIsometricDrawingMatrice[i][j] = -1;
		}
	}

}


public short ConvertIsoIndexToDrawingX (int xIndex) {

	return  (short)(mCenterOffsetX + (xIndex * (mpIsometricIndexedSprite[0].GetRectWidth() - mpIsometricXOffset.GetAt(mPieceType))));

}


public short ConvertIsoIndexToDrawingY (int xIndex, int yIndex) {

	 int indexMax = (((int)ConstantsEnglishPortrait.minosPerTetrimino == (int)ConstantsEnglishLandscape.minosPerTetrimino) ? Constants.minosPerTetrimino : ConstantsGetter.GetConstants().minosPerTetriminoFct()) - 1;

	return  (short)(mCenterOffsetY + ((yIndex * (mpIsometricIndexedSprite[0].GetRectHeight() - mpIsometricYOffset.GetAt(mPieceType))) + (indexMax - xIndex) * (mpIsometricXYOffset.GetAt(mPieceType))));

}


public Array_int mpIsometricXOffset;
public Array_int mpIsometricXYOffset;
public Array_int mpIsometricYOffset;
public IndexedSprite[] mpIsometricIndexedSprite = new IndexedSprite[(((int)ConstantsEnglishPortrait.minosPerTetrimino == (int)ConstantsEnglishLandscape.minosPerTetrimino) ? Constants.minosPerTetrimino : -123)];

public int[][] mpIsometricDrawingMatrice = new int[(((int)ConstantsEnglishPortrait.minosPerTetrimino == (int)ConstantsEnglishLandscape.minosPerTetrimino) ? Constants.minosPerTetrimino : -123)][(((int)ConstantsEnglishPortrait.isometricMatrixHeight == (int)ConstantsEnglishLandscape.isometricMatrixHeight) ? Constants.isometricMatrixHeight : -123)];

public int mCenterOffsetX;
public int mCenterOffsetY;
public TimeSystem mpHighlightAnimTimeSystem;
public Piece(Package pMinoPackage)
{
	this(pMinoPackage, kPieceOutsideWell);
}
public Piece(Package pMinoPackage, int pieceType)
{
	this(pMinoPackage, pieceType, null);
}
public void SetTetrimino(Tetrimino tetrimino)
{
	SetTetrimino(tetrimino, false);
}
public void SetTetrimino(Tetrimino tetrimino, boolean ghost)
{
	SetTetrimino(tetrimino, ghost, kInvalidPiece);
}



}

