package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class ScramblingText extends TimeControlled {

public  ScramblingText (Text overwrittenText, Font scramblingFont, int scramblingTimeLength) {


	mLifeLength = scramblingTimeLength;

	mpBackupString = new String(overwrittenText.GetCaption());
	mpAnimatedString = new String(mpBackupString);
	mpOverwrittenText = overwrittenText;

	mpBackupFont = mpOverwrittenText.GetFont();

	mLeft = overwrittenText.GetRectLeft();
	mOriginalWidth = overwrittenText.GetRectWidth();

	
	
	
	
	
	
	
	
	
	
	
	 int maxUsableWidthInRect = mOriginalWidth - (((int)ConstantsEnglishPortrait.scramblingTextMinPadding == (int)ConstantsEnglishLandscape.scramblingTextMinPadding) ? Constants.scramblingTextMinPadding : ConstantsGetter.GetConstants().scramblingTextMinPaddingFct());

	 int maxScramblingWidth = mpBackupFont.GetLineWidth(mpBackupString) + (((int)ConstantsEnglishPortrait.scramblingTextMinWidth == (int)ConstantsEnglishLandscape.scramblingTextMinWidth) ? Constants.scramblingTextMinWidth : ConstantsGetter.GetConstants().scramblingTextMinWidthFct());

	if(maxScramblingWidth > maxUsableWidthInRect)
	{
		maxScramblingWidth = maxUsableWidthInRect;
	}
	mMaxScramblingWidth = (short)(maxScramblingWidth);

	mpOverwrittenText.SetFont(scramblingFont);
	
	
	AnimText(FlMath.Random((short)(((int)ConstantsEnglishPortrait.scramblingRandomLowerLimit == (int)ConstantsEnglishLandscape.scramblingRandomLowerLimit) ? Constants.scramblingRandomLowerLimit : ConstantsGetter.GetConstants().scramblingRandomLowerLimitFct()), (short)(((int)ConstantsEnglishPortrait.scramblingRandomUpperLimit == (int)ConstantsEnglishLandscape.scramblingRandomUpperLimit) ? Constants.scramblingRandomUpperLimit : ConstantsGetter.GetConstants().scramblingRandomUpperLimitFct())));
	

}


public void destruct() {

	if(!mAnimFinish)
	{
		mpAnimatedString = null;
		mpBackupString = null;
	}

}


public void OnTime (int totalTime, int deltaTime) {


	if(!mAnimFinish)
	{
		mLifeLength -= deltaTime;
		if(mLifeLength <= 0)
		{
			RemoveScramblingText();
			return ;
		}

		mTimeAccumulator += deltaTime;

		if(mTimeAccumulator >= (((int)ConstantsEnglishPortrait.animScramblingTextStep == (int)ConstantsEnglishLandscape.animScramblingTextStep) ? Constants.animScramblingTextStep : ConstantsGetter.GetConstants().animScramblingTextStepFct()))
		{	
			AnimText(deltaTime);
			mTimeAccumulator -= (((int)ConstantsEnglishPortrait.animScramblingTextStep == (int)ConstantsEnglishLandscape.animScramblingTextStep) ? Constants.animScramblingTextStep : ConstantsGetter.GetConstants().animScramblingTextStepFct());
		}
	}

}


public void RemoveScramblingText () {

	mpOverwrittenText.SetFont(mpBackupFont);
	mpOverwrittenText.SetTopLeft(mLeft, mpOverwrittenText.GetRectTop());
	mpOverwrittenText.SetCaption(mpBackupString);

	 short currentTextWidth = (short)(mpOverwrittenText.GetFont().GetLineWidth(mpOverwrittenText.GetCaption()));

	if(mOriginalWidth < currentTextWidth)
	{
		mOriginalWidth = currentTextWidth;
	}

	
	mpOverwrittenText.SetSize(mOriginalWidth, mpOverwrittenText.GetRectHeight());	

	mAnimFinish = true;
	mpAnimatedString = null;

}


public void AnimText (int seed) {

	GetApp().GenerateRandomString(mpAnimatedString, mpOverwrittenText.GetCaption(), seed, mpBackupFont, mMaxScramblingWidth);

	 short lineWidth = (short)(mpOverwrittenText.GetFont()).GetLineWidth(mpAnimatedString);

	
	if(mpOverwrittenText.GetAlignment() == Alignment.CENTER)
	{
		 short currentWidth = mpOverwrittenText.GetRectWidth();

		 short left = (short)(mpOverwrittenText.GetRectLeft() + (currentWidth - lineWidth) / 2);

		mpOverwrittenText.SetTopLeft(left, mpOverwrittenText.GetRectTop());
	}
	mpOverwrittenText.SetSize(lineWidth, mpOverwrittenText.GetRectHeight());
	mpOverwrittenText.SetCaption(new String(mpAnimatedString));

}


public static TetrisApp GetApp () {

	return  TetrisApp.Get();

}


public Text mpOverwrittenText;
public String mpBackupString;
public Font mpBackupFont;
public String mpAnimatedString;
public int mLifeLength;
public int mTimeAccumulator;
public boolean mAnimFinish;
public short mLeft;
public short mOriginalWidth;
public short mMaxScramblingWidth;



}

