package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class SerializableContainer {

public final static int kOptionSettingsIndex = 0;
public final static int kTetrisStateIndex = 1;
public final static int kTetrisInputMappingIndex = 2;
public final static int kSerializableCount = 3;

public SerializableContainer () {

	for(int i = 0;i < kSerializableCount;i ++)
	{
		mSerializableObjectList[i] = null;
		mSerializableObjectSize[i] = 0;
	}

	mSerializableObjectList[kOptionSettingsIndex] = (Serializable)(new OptionSettings());
	mSerializableObjectSize[kOptionSettingsIndex] = (15);

	mSerializableObjectList[kTetrisStateIndex] = (Serializable)(new TetrisState());
	mSerializableObjectSize[kTetrisStateIndex] = (110);

	mSerializableObjectList[kTetrisInputMappingIndex] = (Serializable)(new TetrisInputMapping());
	mSerializableObjectSize[kTetrisInputMappingIndex] = (ScreenManager.orientationCount * Key.COUNT * InputMapping.kMappingElementCount * 4);


}


public void destruct() {

	for(int objectIndex = 0;objectIndex < kSerializableCount;objectIndex ++)
	{
		mSerializableObjectList[objectIndex] = null;
	}


}


public Serializable GetSerializableObject(int objectIndex) {
 return  mSerializableObjectList[objectIndex]; 
}


public Serializable[] mSerializableObjectList = new Serializable[kSerializableCount];

public int[] mSerializableObjectSize = new int[kSerializableCount];


/* One dimension array */
public static SerializableContainer[] InstArraySerializableContainer(int size) {
	SerializableContainer[] newArray = new SerializableContainer[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new SerializableContainer();
	return newArray; }

/* Two dimension array */
public static SerializableContainer[][] InstArraySerializableContainer(int size1, int size2) {
	SerializableContainer[][] newArray = new SerializableContainer[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new SerializableContainer[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new SerializableContainer(); }
	return newArray; }

/* Three dimension array */
public static SerializableContainer[][][] InstArraySerializableContainer(int size1, int size2, int size3) {
	SerializableContainer[][][] newArray = new SerializableContainer[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new SerializableContainer[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new SerializableContainer[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new SerializableContainer(); } }
	return newArray; }



}

