package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class SimPCScreenManager extends BaseScreenManager {

public SimPCScreenManager () {

	mUsingFirstScreenOrientation = true;
	mHardwareOrientation = orientationAutomatic;

}


public void OnScreenSizeChange () {

	mUsingFirstScreenOrientation = Application.GetInstance().GetRectWidth() == Constants.screenWidth;
	super.OnScreenSizeChange();

}


public boolean CalculateIsOrientationSettingSupported (byte ori) {

	if(false || ori == orientationAutomatic)
	{	
		return  true;
	}

	return  false;

}


public boolean CalculateIsNativeOrientationSupported (byte ori) {

	if(false || ori == orientationStraight || ori == orientationRight)
	{	
		return  true;
	}

	return  false;

}


public boolean IsHardwareRotationEnabled () {

	return  mHardwareOrientation == orientationAutomatic;

}


public byte GetCurrentHardwareRotation () {

	if(IsHardwareRotationEnabled())
	{
		if(mUsingFirstScreenOrientation)
		{
			return  orientationStraight;
		}
		return  orientationRight;
	}
	else
	{
		return  mHardwareOrientation;
	}

}


public void SetHardwareOrientation (byte ori) {


	mHardwareOrientation = ori;

}


public boolean mUsingFirstScreenOrientation;
public byte mHardwareOrientation;

/* One dimension array */
public static SimPCScreenManager[] InstArraySimPCScreenManager(int size) {
	SimPCScreenManager[] newArray = new SimPCScreenManager[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new SimPCScreenManager();
	return newArray; }

/* Two dimension array */
public static SimPCScreenManager[][] InstArraySimPCScreenManager(int size1, int size2) {
	SimPCScreenManager[][] newArray = new SimPCScreenManager[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new SimPCScreenManager[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new SimPCScreenManager(); }
	return newArray; }

/* Three dimension array */
public static SimPCScreenManager[][][] InstArraySimPCScreenManager(int size1, int size2, int size3) {
	SimPCScreenManager[][][] newArray = new SimPCScreenManager[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new SimPCScreenManager[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new SimPCScreenManager[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new SimPCScreenManager(); } }
	return newArray; }



}

