package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class TetrisInputMapping extends InputSingleMapping {

public static TetrisInputMapping Get () {

	return  GetApp().GetGameMapping();

}


public static TetrisApp GetApp () {

	return  TetrisApp.Get();

}


public  TetrisInputMapping () {
super(TetrisGameAction.kActionCount);


	SetAction(TetrisGameAction.kActionHardDrop, 0, 0);
	SetAction(TetrisGameAction.kActionHold, 0, 0);
	SetAction(TetrisGameAction.kActionMoveLeft, (((int)ConstantsEnglishPortrait.holdKeyDelayMs == (int)ConstantsEnglishLandscape.holdKeyDelayMs) ? Constants.holdKeyDelayMs : ConstantsGetter.GetConstants().holdKeyDelayMsFct()), (((int)ConstantsEnglishPortrait.holdKeyStepsMs == (int)ConstantsEnglishLandscape.holdKeyStepsMs) ? Constants.holdKeyStepsMs : ConstantsGetter.GetConstants().holdKeyStepsMsFct()));
	SetAction(TetrisGameAction.kActionMoveRight, (((int)ConstantsEnglishPortrait.holdKeyDelayMs == (int)ConstantsEnglishLandscape.holdKeyDelayMs) ? Constants.holdKeyDelayMs : ConstantsGetter.GetConstants().holdKeyDelayMsFct()), (((int)ConstantsEnglishPortrait.holdKeyStepsMs == (int)ConstantsEnglishLandscape.holdKeyStepsMs) ? Constants.holdKeyStepsMs : ConstantsGetter.GetConstants().holdKeyStepsMsFct()));
	SetAction(TetrisGameAction.kActionRotateClockwise, 0, 0);
	SetAction(TetrisGameAction.kActionRotateCounterClockwise, 0, 0);
	SetAction(TetrisGameAction.kActionSoftDrop, 0, 0);

	Reset();

}


public void SetDefault (int layoutIndex) {

	int currentAction;


	ClearInputMapping(layoutIndex);



	currentAction = TetrisGameAction.kActionMoveLeft;
	
				SetMapping((Key.UP_D), currentAction, 0, 0);
	SetMapping((Key.UP_J), currentAction, 0, 0);
	currentAction = TetrisGameAction.kActionMoveRight;
	
				SetMapping((Key.UP_G), currentAction, 0, 0);
	SetMapping((Key.UP_L), currentAction, 0, 0);
	currentAction = TetrisGameAction.kActionHardDrop;
	
				SetMapping((Key.UP_R), currentAction, 0, 0);
	SetMapping((Key.UP_I), currentAction, 0, 0);
	currentAction = TetrisGameAction.kActionSoftDrop;
	
				SetMapping((Key.UP_C), currentAction, 0, 0);
	SetMapping((Key.UP_M), currentAction, 0, 0);
	currentAction = TetrisGameAction.kActionRotateClockwise;
	
				SetMapping((Key.UP_T), currentAction, 0, 0);
	SetMapping((Key.UP_O), currentAction, 0, 0);
	SetMapping((Key.UP_F), currentAction, 0, 0);
	SetMapping((Key.UP_K), currentAction, 0, 0);
	SetMapping((Key.UP_X), currentAction, 0, 0);
	SetMapping((Key.UP_N), currentAction, 0, 0);
	currentAction = TetrisGameAction.kActionRotateCounterClockwise;
	
				SetMapping((Key.UP_E), currentAction, 0, 0);
	SetMapping((Key.UP_U), currentAction, 0, 0);
	SetMapping((Key.UP_V), currentAction, 0, 0);
	SetMapping((Key.PERIOD), currentAction, 0, 0);
	currentAction = TetrisGameAction.kActionHold;
	
				SetMapping((Key.SPACE), currentAction, 0, 0);
	
}


public void SetDefault()
{
	SetDefault((int)0);
}

/* One dimension array */
public static TetrisInputMapping[] InstArrayTetrisInputMapping(int size) {
	TetrisInputMapping[] newArray = new TetrisInputMapping[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new TetrisInputMapping();
	return newArray; }

/* Two dimension array */
public static TetrisInputMapping[][] InstArrayTetrisInputMapping(int size1, int size2) {
	TetrisInputMapping[][] newArray = new TetrisInputMapping[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new TetrisInputMapping[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new TetrisInputMapping(); }
	return newArray; }

/* Three dimension array */
public static TetrisInputMapping[][][] InstArrayTetrisInputMapping(int size1, int size2, int size3) {
	TetrisInputMapping[][][] newArray = new TetrisInputMapping[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new TetrisInputMapping[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new TetrisInputMapping[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new TetrisInputMapping(); } }
	return newArray; }



}

