package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class TetrisPlayer {

public final static int kEventGameSceneLoaded = 0;
public final static int kEventStartGame = 1;
public final static int kEventTetriminoStartsFalling = 2;
public final static int kEventStartPlayback = 3;
public final static int kEventTetriminoHardDrop = 4;
public final static int kEventTetriminoLock = 5;
public final static int kEventTetriminoHold = 6;
public final static int kEventLevelUp = 7;
public final static int kEventSoftDrop = 8;
public final static int kEventEndTurn = 9;
public final static int kEventGameOver = 10;
public final static int kEventGameOverResult = 11;

public final static int kInvalidateStartGame = 0;
public final static int kInvalidateTetriminoStartsFalling = 1;
public final static int kInvalidateTetriminoLock = 2;
public final static int kInvalidateTetriminoHold = 3;
public final static int kInvalidateLineAttack = 4;
public final static int kInvalidateLineAcceptAttack = 5;
public final static int kInvalidateLineCounterAttack = 6;
public final static int kInvalidateLineCancelAttack = 7;
public final static int kInvalidateLevelUp = 8;
public final static int kInvalidateSoftDrop = 9;
public final static int kInvalidateHardDrop = 10;
public final static int kInvalidateFacing = 11;
public final static int kInvalidateEndTurn = 12;
public final static int kInvalidateGameOver = 13;
public final static int kInvalidateGameOverResult = 14;
public final static int kInvalidateOpponentGameSceneLoaded = 15;
public final static int kInvalidateCount = 16;

public  TetrisPlayer (TetrisState state, byte playerId, Well pWell) {
mTetrisState = state;
mPlayerId = (playerId);


	

	
	for(int i = 0;i < kInvalidateCount;i ++)
	{
		mInvalidateState[i] = false;
	}

	mpTetrisGame = new TetrisGame(this, pWell);

}


public void destruct() {
	
	mpTetrisGame = null;

}


public void OnTime (int elapsedMs) {

	

	if(mpTetrisGame.GetGamePhase() != TetrisGame.kPhaseWaitingForStart)
	{


UpdatePlayTime(elapsedMs);

		UpdateGame(elapsedMs);
	}

}


public TetrisGame GetGameState() {
 return  mpTetrisGame; 
}


public void OnGameEvent (int gameEvent, int eventOccurTimeMs, int param) {

	



	switch(gameEvent)
	{
	case kEventStartGame :
		if(param != -1)
		{
			mpTetrisGame.SetTetriminoSeed(param);
		}	
		mpTetrisGame.Start();
		InvalidateState(kInvalidateStartGame);
		break;




case kEventSoftDrop :
		InvalidateState(kInvalidateSoftDrop);
		break;

	case kEventTetriminoHardDrop :
		InvalidateState(kInvalidateHardDrop);
		break;
case kEventTetriminoLock :
		InvalidateState(kInvalidateTetriminoLock);
		break;
	case kEventTetriminoStartsFalling :
		InvalidateState(kInvalidateTetriminoStartsFalling);
		break;	
	case kEventLevelUp :
		InvalidateState(kInvalidateLevelUp);
		break;














case kEventEndTurn :
		{






InvalidateState(kInvalidateEndTurn);			
		}
		break;
	case kEventTetriminoHold :





InvalidateState(kInvalidateTetriminoHold);
		break;
	case kEventGameOver :
		mGameOverTime = mpTetrisGame.GetPlayTimeMs();
		InvalidateState(kInvalidateGameOver);
		







{



































{
				GetPlayer1GameState().OnSingleplayerGameOver();
			}
		}
		break;

	case kEventGameOverResult :


{
			InvalidateState(kInvalidateGameOverResult);
			GetTetrisState().OnGameOver();
		}
		break;





default : ;
	}

}


public boolean OnActionPressed(int action, int keyPressCount) {
 ; ; return  false; 
}


public boolean OnActionRepeat(int action, int nthRepeatInThisOnTime) {
 ; ; return  false; 
}


public boolean OnActionReleased(int action, int keyPressCount) {
 ; ; return  false; 
}


public void Validate () {

	

	
	for(int i = 0;i < kInvalidateCount;i ++)
	{
		mInvalidateState[i] = false;
	}

}


public boolean GetInvalidatedState (int element) {

	

	return  mInvalidateState[element];

}


public Tetrimino GetGhostTetrimino() {
 return  null; 
}


public boolean IsPlayer1 () {

	

	return  mPlayerId == TetrisState.kPlayer1;

}


public void InvalidateState (int state) {

	

	mInvalidateState[state] = true;

}


public static TetrisApp GetApp () {

	return  TetrisApp.Get();

}


public TetrisState GetTetrisState () {

	return  GetApp().GetTetrisState();

}


public TetrisGame GetPlayer1GameState () {
 
	return  GetTetrisState().GetPlayerGameState(TetrisState.kPlayer1);

}


public TetrisGame GetPlayer2GameState () {

	return  GetTetrisState().GetPlayerGameState(TetrisState.kPlayer2);

}


public void UpdateGame (int elapsedMs) {

	

	mpTetrisGame.OnTime(elapsedMs);

}


public void UpdatePlayTime (int elapsedMs) {

	

	if(mpTetrisGame.GetGameOverType() == TetrisGame.kGameNotOver)
	{










{
			mpTetrisGame.SetPlayTimeMs(mpTetrisGame.GetPlayTimeMs() + elapsedMs);		
		}	
	}	

}


public TetrisState mTetrisState;
public TetrisGame mpTetrisGame;
public byte mPlayerId;
public int mGameOverTime;
public boolean[] mInvalidateState = new boolean[kInvalidateCount];

public TetrisPlayer(TetrisState state, byte playerId)
{
	this(state, playerId, null);
}
public void OnGameEvent(int gameEvent, int eventOccurTimeMs)
{
	OnGameEvent(gameEvent, eventOccurTimeMs, (int)-1);
}



}

