package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class TetrisPromptScene extends BaseScene {

public  TetrisPromptScene (byte packageID, int titleStringEntryPoint, int contentStringEntryPoint, int acceptSoftKeyStringEntryPoint, int acceptCommand, int declineSoftKeyStringEntryPoint, int declineCommand, boolean useSelector, int noCommand, int yesCommand, int defaultSelection, int noSelectionStringEntryPoint, int yesSelectionStringEntryPoint) {
super(packageID);
mTitleStringEntryPoint = (titleStringEntryPoint);
mContentStringEntryPoint = (contentStringEntryPoint);
mpAcceptSoftKeyStringEntryPoint = (acceptSoftKeyStringEntryPoint);
mAcceptCommand = (acceptCommand);
mpDeclineSoftKeyStringEntryPoint = (declineSoftKeyStringEntryPoint);
mDeclineCommand = (declineCommand);
mUseSelector = (useSelector);
mNoCommand = (noCommand);
mYesCommand = (yesCommand);
mDefaultSelection = (defaultSelection);
mNoSelectionStringEntryPoint = (noSelectionStringEntryPoint);
mYesSelectionStringEntryPoint = (yesSelectionStringEntryPoint);
mTitleString = new String();
mContentString = new String();


	mSkipScene = true;

}


public void destruct() {
	

}


public void SetTitleString(String title) {
 mTitleString.Assign(title); 
}


public void SetContentString(String content) {
 mContentString.Assign(content); 
}


public void Init () {
	

	 String tempString = null;
	 Text tempText = null;
	 Scroller tempScroller = null;
	 Selection tempSelection = null;

	
	(tempText)= (tempText).Cast((mpPackage).GetEntryPoint(RSRC_promptMenuScenePackage.promptTitleText_ID), null);
	if(mTitleString.GetLength() > 0)
	{
		tempString = new String();
		tempString.Assign(mTitleString);
		StringToolbox.AssignToUpper(tempString);
		StringToolbox.AssignToTrunc(tempString, tempText.GetRectWidth(), tempText.GetFont());

		tempText.SetCaption(tempString);
	}
	else
	{

		(tempString)= (tempString).Cast((mpPackage).GetEntryPoint(mTitleStringEntryPoint), null);
		tempText.SetCaption(new String(tempString));
	}

	
	(tempText)= (tempText).Cast((mpPackage).GetEntryPoint(RSRC_promptMenuScenePackage.promptText_ID), null);
	if(mContentString.GetLength() > 0)
	{
		tempString = new String(mContentString);
		StringToolbox.AssignToUpper(tempString);
		tempText.SetCaption(tempString);
	}
	else
	{

		(tempString)= (tempString).Cast((mpPackage).GetEntryPoint(mContentStringEntryPoint), null);
		tempText.SetCaption(new String(tempString));
	}










((Selector)mpComponentWithFocus).SetSingleSelection(mDefaultSelection);

	
	tempText.SetSize(tempText.GetRectWidth(), (short)(tempText.GetNbLines() * (((int)ConstantsEnglishPortrait.menuFontHeight == (int)ConstantsEnglishLandscape.menuFontHeight) ? Constants.menuFontHeight : ConstantsGetter.GetConstants().menuFontHeightFct())));
	(tempScroller)= (tempScroller).Cast((mpPackage).GetEntryPoint(RSRC_promptMenuScenePackage.promptScroller_ID), null);
	tempScroller.ResetScroller();
	
	mpComponentWithFocus.SetVisible(mUseSelector);	

	(tempSelection)= (tempSelection).Cast((mpPackage).GetEntryPoint(RSRC_promptMenuScenePackage.promptNoSelection_ID), null);
	tempSelection.SetCommand((byte)mNoCommand);

	(tempSelection)= (tempSelection).Cast((mpPackage).GetEntryPoint(RSRC_promptMenuScenePackage.promptYesSelection_ID), null);
	tempSelection.SetCommand((byte)mYesCommand);

	if(mUseSelector)
	{
		(tempText)= (tempText).Cast((mpPackage).GetEntryPoint(RSRC_promptMenuScenePackage.promptNoText_ID), null);
		(tempString)= (tempString).Cast((mpPackage).GetEntryPoint(mNoSelectionStringEntryPoint), null);
		 Font textFont = tempText.GetFont();		
		 int textWidthNo = textFont.GetLineWidth(tempString);

		tempText.SetCaption(new String(tempString));
		
		(tempText)= (tempText).Cast((mpPackage).GetEntryPoint(RSRC_promptMenuScenePackage.promptYesText_ID), null);
		(tempString)= (tempString).Cast((mpPackage).GetEntryPoint(mYesSelectionStringEntryPoint), null);	
		 int textWidthYes = textFont.GetLineWidth(tempString);
		
		tempText.SetCaption(new String(tempString));
	
		 int maxTextWidth = (textWidthYes > textWidthNo) ? textWidthYes : textWidthNo;

		 int previousArrowLeft = ((((int)ConstantsEnglishPortrait.promptMenuSelectorScrollingViewportWidth == (int)ConstantsEnglishLandscape.promptMenuSelectorScrollingViewportWidth) ? Constants.promptMenuSelectorScrollingViewportWidth : ConstantsGetter.GetConstants().promptMenuSelectorScrollingViewportWidthFct()) - maxTextWidth) / 2- (((int)ConstantsEnglishPortrait.horizontalNavigationArrowWidth == (int)ConstantsEnglishLandscape.horizontalNavigationArrowWidth) ? Constants.horizontalNavigationArrowWidth : ConstantsGetter.GetConstants().horizontalNavigationArrowWidthFct()) - (((int)ConstantsEnglishPortrait.horizontalArrowPaddingX == (int)ConstantsEnglishLandscape.horizontalArrowPaddingX) ? Constants.horizontalArrowPaddingX : ConstantsGetter.GetConstants().horizontalArrowPaddingXFct());

		
		(tempSelection)= (tempSelection).Cast((mpPackage).GetEntryPoint(RSRC_promptMenuScenePackage.promptPreviousArrowSelection_ID), null);
		tempSelection.SetTopLeft((short)previousArrowLeft, tempSelection.GetRectTop());

		 int nextArrowLeft = previousArrowLeft + maxTextWidth + (((int)ConstantsEnglishPortrait.horizontalNavigationArrowWidth == (int)ConstantsEnglishLandscape.horizontalNavigationArrowWidth) ? Constants.horizontalNavigationArrowWidth : ConstantsGetter.GetConstants().horizontalNavigationArrowWidthFct()) + 2* (((int)ConstantsEnglishPortrait.horizontalArrowPaddingX == (int)ConstantsEnglishLandscape.horizontalArrowPaddingX) ? Constants.horizontalArrowPaddingX : ConstantsGetter.GetConstants().horizontalArrowPaddingXFct());

		(tempSelection)= (tempSelection).Cast((mpPackage).GetEntryPoint(RSRC_promptMenuScenePackage.promptNextArrowSelection_ID), null);
		tempSelection.SetTopLeft((short)nextArrowLeft, tempSelection.GetRectTop());
	}

	super.Init();

}


public void InitSoftKeys () {

	 String tempString = null;
	
	(tempString)= (tempString).Cast((mpPackage).GetEntryPoint(mpAcceptSoftKeyStringEntryPoint), null);
	UpdateSoftKey(acceptSoftKey, tempString, mAcceptCommand);

	
	(tempString)= (tempString).Cast((mpPackage).GetEntryPoint(mpDeclineSoftKeyStringEntryPoint), null);
	UpdateSoftKey(declineSoftKey, tempString, mDeclineCommand);

}


public int mTitleStringEntryPoint;
public int mContentStringEntryPoint;
public int mpAcceptSoftKeyStringEntryPoint;
public int mAcceptCommand;
public int mpDeclineSoftKeyStringEntryPoint;
public int mDeclineCommand;
public boolean mUseSelector;
public int mNoCommand;
public int mYesCommand;
public int mDefaultSelection;
public int mNoSelectionStringEntryPoint;
public int mYesSelectionStringEntryPoint;
public String mTitleString;
public String mContentString;
public TetrisPromptScene(byte packageID, int titleStringEntryPoint, int contentStringEntryPoint, int acceptSoftKeyStringEntryPoint, int acceptCommand, int declineSoftKeyStringEntryPoint, int declineCommand, boolean useSelector, int noCommand, int yesCommand, int defaultSelection)
{
	this(packageID, titleStringEntryPoint, contentStringEntryPoint, acceptSoftKeyStringEntryPoint, acceptCommand, declineSoftKeyStringEntryPoint, declineCommand, useSelector, noCommand, yesCommand, defaultSelection, RSRC_promptMenuScenePackage.noString_ID);
}
public TetrisPromptScene(byte packageID, int titleStringEntryPoint, int contentStringEntryPoint, int acceptSoftKeyStringEntryPoint, int acceptCommand, int declineSoftKeyStringEntryPoint, int declineCommand, boolean useSelector, int noCommand, int yesCommand, int defaultSelection, int noSelectionStringEntryPoint)
{
	this(packageID, titleStringEntryPoint, contentStringEntryPoint, acceptSoftKeyStringEntryPoint, acceptCommand, declineSoftKeyStringEntryPoint, declineCommand, useSelector, noCommand, yesCommand, defaultSelection, noSelectionStringEntryPoint, RSRC_promptMenuScenePackage.yesString_ID);
}



}

