package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class TetrisState extends Serializable {

public final static byte kPlayer1 = 0;
public final static byte kPlayer2 = 1;
public final static byte kPlayerCount = 1;

public final static int kNoPlayerAttacking = 0;
public final static int kPlayer1Attacking = 1;
public final static int kPlayer2Attacking = 2;

public final static int kModeMarathon = 0;
public final static int kModeUltra = 1;
public final static int kMode40Lines = 2;
public final static int kModeCount = 3;

public final static byte kStatMarathonScore = 0;
public final static byte kStatMarathonLines = 1;
public final static byte kStatMarathonLevel = 2;
public final static byte kStatUltraScore = 3;
public final static byte kStatUltraLevel = 4;
public final static byte kStat40LinesTime = 5;
public final static byte kLocalPlayerStatsCount = 6;

public final static int kSettingSingleMarathonStartingLevel = 0;
public final static int kSettingSingleUltraStartingLevel = 1;
public final static int kSettingSingle40LinesStartingLevel = 2;
public final static int kSettingSingleChallengeTerimino = 3;
public final static int kSettingSingleChallengeStartingLevel = 4;
public final static int kSettingSingleChallengePieceAtBottom = 5;
public final static int kSettingSingleChallengeNumberOfPlayers = 6;
public final static int kSettingMultiClassicStartingLevel = 7;
public final static int kSettingMultiClassicSpecialAttacks = 8;
public final static int kSettingMultiChallengeTerimino = 9;
public final static int kSettingMultiChallengeStartingLevel = 10;
public final static int kSettingMultiChallengePieceAtBottom = 11;
public final static int kGameSetupOptionsCount = 12;

public final static int kGameSetupOptionsTypeLevel = 0;
public final static int kGameSetupOptionsTypeOffOn = 1;
public final static int kGameSetupOptionsTypeOffOnAny = 2;
public final static int kGameSetupOptionsTypeDifficulty = 3;
public final static int kGameSetupOptionsTypeScore = 4;
public final static int kGameSetupOptionsTypeChallengeTetrimino = 5;
public final static int kGameSetupOptionsTypeClashLevel = 6;
public final static int kGameSetupOptionsTypePlayerCount = 7;
public final static int kGameSetupOptionsTypeCount = 8;

public final static int kGameSetupOptionDataTypeBool = 0;
public final static int kGameSetupOptionDataTypeDifficulty = 1;
public final static int kGameSetupOptionDataTypeOffOnAny = 2;
public final static int kGameSetupOptionDataTypeInt = 3;
public final static int kGameSetupOptionDataTypeCount = 4;

public final static byte kOff = 0;
public final static byte kOn = 1;
public final static byte kAny = 2;

public final static byte kTutorialShowingAlways = 0;
public final static byte kTutorialShowingNever = 1;
public final static byte kTutorialShowingOnce = 2;
public final static byte kTutorialShowingNb = 3;

public final static byte kSeedTetrimino = (((int)ConstantsEnglishPortrait.seedTetriminoOrder == (int)ConstantsEnglishLandscape.seedTetriminoOrder) ? Constants.seedTetriminoOrder : -123);
public final static byte kSeedBrokenLines = (((int)ConstantsEnglishPortrait.seedBrokenLinesOrder == (int)ConstantsEnglishLandscape.seedBrokenLinesOrder) ? Constants.seedBrokenLinesOrder : -123);
public final static byte kSeedSpecialAttack = (((int)ConstantsEnglishPortrait.seedSpecialAttackOrder == (int)ConstantsEnglishLandscape.seedSpecialAttackOrder) ? Constants.seedSpecialAttackOrder : -123);
public final static byte kSeedCount = (((int)ConstantsEnglishPortrait.seedSpecialAttackOrder == (int)ConstantsEnglishLandscape.seedSpecialAttackOrder) ? Constants.seedSpecialAttackOrder : -123)+1;

public final static byte kPlaying = 0;
public final static byte kNotInit = 1;
public final static byte kDisplayPressStart = 2;

public final static byte kRankOperatorAny = 0;
public final static byte kRankOperatorBelow = 1;
public final static byte kRankOperatorSame = 2;
public final static byte kRankOperatorOver = 3;

public TetrisState () {

	

	Reset();

	int i;

	for(i = 0;i < kPlayerCount;i ++)
	{
		mpPlayers[i] = null;
	}

	for(i = 0;i < kLocalPlayerStatsCount;i ++)
	{
		mSinglePlayerStats[i] = 0;
		mNewRecord[i] = false;
	}

	
	for(i = 0;i < kSeedCount;i ++)
	{
		mMultiplayerSeeds[i] = 0;
	}

	for(i = 0;i < (((int)ConstantsEnglishPortrait.passNPlayMaxPlayerCount == (int)ConstantsEnglishLandscape.passNPlayMaxPlayerCount) ? Constants.passNPlayMaxPlayerCount : ConstantsGetter.GetConstants().passNPlayMaxPlayerCountFct());i ++)
	{
		mPassNPlayScore[i] = 0;
	}

	ResetTutorial();
	

}


public void destruct() {

	for(int i = 0;i < kPlayerCount;i ++)
	{
		mpPlayers[i] = null;
	}

}


public void OnTime (int elapsedMs) {

	



{
		mpPlayers[kPlayer1].OnTime(elapsedMs);
	}














}


public void Reset () {

	mGameMode = kModeMarathon;
	mLocalGameMode = kModeMarathon;
	mStartingLevel = 0; 
	mScoreLimit = 0;
	mTimeLimit = 0;
	mCurrentPlayer = 0;
	mPassNPlayWinnerId = 0;



for(int i = 0;i < kGameSetupOptionsCount;i ++)
	{
		mGameSetupOptions[i] = 0;
	}



mGameSetupOptions[kSettingSingleChallengePieceAtBottom] = (byte)(((int)ConstantsEnglishPortrait.YesNoAnySelectorNoIndex == (int)ConstantsEnglishLandscape.YesNoAnySelectorNoIndex) ? Constants.YesNoAnySelectorNoIndex : ConstantsGetter.GetConstants().YesNoAnySelectorNoIndexFct());
	mGameSetupOptions[kSettingMultiClassicSpecialAttacks] = (byte)(((int)ConstantsEnglishPortrait.YesNoAnySelectorAnyIndex == (int)ConstantsEnglishLandscape.YesNoAnySelectorAnyIndex) ? Constants.YesNoAnySelectorAnyIndex : ConstantsGetter.GetConstants().YesNoAnySelectorAnyIndexFct());
	mGameSetupOptions[kSettingMultiChallengePieceAtBottom] = (byte)(((int)ConstantsEnglishPortrait.YesNoAnySelectorAnyIndex == (int)ConstantsEnglishLandscape.YesNoAnySelectorAnyIndex) ? Constants.YesNoAnySelectorAnyIndex : ConstantsGetter.GetConstants().YesNoAnySelectorAnyIndexFct());

}


public void ResetStats () {

	

	for(int i = 0;i < kLocalPlayerStatsCount;i ++)
	{
		mSinglePlayerStats[i] = 0;
	}

	TetrisApp.Get().SetMustSave(true);

}


public void Write (FileSegmentStream outputStream) {

	

	 int i = 0;

	

	outputStream.WriteByte((byte)mTutorialShowingSetting);
outputStream.WriteByte((byte)mGameMode);
	outputStream.WriteByte((byte)mLocalGameMode);




for(i = 0;i < kLocalPlayerStatsCount;i ++)
	{
		outputStream.WriteInt(mSinglePlayerStats[i]);
	}

	for(i = 0;i < kGameSetupOptionsCount;i ++)
	{
		outputStream.WriteByte((byte)mGameSetupOptions[i]);
	}

	for(i = 0;i < kModeCount;i ++)
	{
		outputStream.WriteBoolean(mGameModeTutorialShown[i]);
	}

}


public void Read (FileSegmentStream inputStream) {

	

	 int i = 0;


	

	mTutorialShowingSetting = (byte)inputStream.ReadByte();
mGameMode = (int)inputStream.ReadByte();
	mLocalGameMode = (int)inputStream.ReadByte();





for(i = 0;i < kLocalPlayerStatsCount;i ++)
	{
		mSinglePlayerStats[i] = inputStream.ReadInt();
	}

	for(i = 0;i < kGameSetupOptionsCount;i ++)
	{
		mGameSetupOptions[i] = inputStream.ReadByte();
	}

	for(i = 0;i < kModeCount;i ++)
	{
		mGameModeTutorialShown[i] = inputStream.ReadBoolean();
	}

}


public void CreateAttractGame () {











}


public void CreateGame (boolean forceDefaultOptions) {

	



switch(GetGameMode())
	{





































case kModeMarathon :
		{
			CreateMarathonGame(GetGameSetupOptionsInt(kSettingSingleMarathonStartingLevel));
		}
		break;

		case kModeUltra :
		{
			CreateUltraGame(GetGameSetupOptionsInt(kSettingSingleUltraStartingLevel));
		}
		break;

		case kMode40Lines :
		{
			Create40LinesGame(GetGameSetupOptionsInt(kSettingSingle40LinesStartingLevel));
		}
		break;

		default : ;
	}

}


public TetrisPlayer GetPlayer(byte playerId) {
 return  mpPlayers[playerId]; 
}


public TetrisGame GetPlayerGameState (byte player) {

	 TetrisGame game = GetPlayer(player).GetGameState();

	return game;

}


public TetrisGame GetPlayer1GameState() {
 return  GetPlayerGameState(kPlayer1); 
}


public TetrisGame GetPlayer2GameState() {
 return  GetPlayerGameState(kPlayer2); 
}


public void CreateMarathonGame (int startingLevel) {

	

	CreateGameCommon(kModeMarathon, false);

	mStartingLevel = startingLevel;

	mpPlayers[kPlayer1].GetGameState().InitLevel(mStartingLevel);

}


public void CreateUltraGame (int startingLevel) {

	

	CreateGameCommon(kModeUltra, false);

	mStartingLevel = startingLevel;

	
	mTimeLimit = (((int)ConstantsEnglishPortrait.gameTime2Minutes == (int)ConstantsEnglishLandscape.gameTime2Minutes) ? Constants.gameTime2Minutes : ConstantsGetter.GetConstants().gameTime2MinutesFct());
	mpPlayers[kPlayer1].GetGameState().InitLevel(mStartingLevel);

}


public void Create40LinesGame (int startingLevel) {

	

	CreateGameCommon(kMode40Lines, false);

	mStartingLevel = startingLevel;

	
	mpPlayers[kPlayer1].GetGameState().InitLevel(mStartingLevel);
	mpPlayers[kPlayer1].GetGameState().SetLineCount(-40);

}


public void StartGame () {

	



int i;

	


{
		for(i = 0;i < GetPlayerCount();i ++)
		{
			mpPlayers[i].OnGameEvent(TetrisPlayer.kEventStartGame, 0);
		}
	}

}


public void RestartGame () {

	

	switch((int)mGameMode)
	{








case kModeMarathon :
		CreateMarathonGame(GetStartingLevel());
		break;

	case kModeUltra :
		CreateUltraGame(GetStartingLevel());
		break;

	case kMode40Lines :
		Create40LinesGame(GetStartingLevel());
		break;
	}

	StartGame();

}


public void DeleteGameState () {

	

	for(int i = 0;i < kPlayerCount;i ++)
	{
		mpPlayers[i] = null;
	}

}


public void OnGameOver () {

	


















{
		 boolean win = true;


		
		
		
		if(IsGameModeDecLine() && mpPlayers[kPlayer1].GetGameState().GetLineCount() != 0)
		{
			win = false;
		}

		UpdateLocalPlayerStats(win);
	}

}


public int GetStartingLevel() {
 return  mStartingLevel; 
}


public boolean IsAttractModeGame () {
 
	return  false;

}


public boolean IsNetworkGame() {
 return  false; 
}


public boolean MustSyncGameStart () {

	


	return  false;











}


public int GetSeed(byte seedType) {
 return  mMultiplayerSeeds[seedType]; 
}


public void SetSeed (byte seedType, int seed) {

	

	mMultiplayerSeeds[seedType] = seed;
	mpPlayers[kPlayer1].GetGameState().SetSeed(seedType, seed);






}


public int GetGameMode() {
 return  mGameMode; 
}


public void SetGameMode (boolean isNetworkGame) {
 



	mGameMode = mLocalGameMode; 

}


public int GetLocalGameMode() {
 return  mLocalGameMode; 
}


public void SetLocalGameMode (int gameMode) {

	

	mLocalGameMode = gameMode;


mGameMode = mLocalGameMode;

}


public int GetPlayerCount() {
 return  (IsMultiplayerMode() ? kPlayerCount : 1); 
}


public boolean IsSinglePlayerMode() {
 return	mGameMode == kModeMarathon ||
														mGameMode == kModeUltra ||
														mGameMode == kMode40Lines; 
}


public boolean IsMultiplayerMode () {

	

	return  false;

}


public boolean IsModeMarathon() {
 return  mGameMode == kModeMarathon; 
}


public boolean IsGameModeUsingTimeLimit() {
 return  mGameMode == kModeUltra; 
}


public boolean IsGameModeUsingTime () {

	return  false || mGameMode == kModeUltra;

}


public boolean IsGameModeDecLine() {
 return  mGameMode == kMode40Lines;  
}


public boolean IsGameModeUsingExtendedLockDown() {
 return  IsMultiplayerMode(); 
}


public boolean IsNeededToShowScore () {

	

	return  mGameMode == kModeMarathon || mGameMode == kModeUltra;

}


public boolean IsGameModeLevelingUp () {

	

	return  mGameMode == kModeMarathon;

}


public boolean IsNeededToShowTime() {
 return  mGameMode == kMode40Lines ||
														IsGameModeUsingTime(); 
}


public boolean IsNeededToShowLine() {
 return  mGameMode == kMode40Lines || mGameMode == kModeMarathon; 
}


public boolean IsTimeCountDown () {

	return  false || mGameMode == kModeUltra;

}


public int GetPassNPlayPlayerScore(int playerId) {
 return  mPassNPlayScore[playerId]; 
}


public int GetPassNPlayWinner() {
 return  mPassNPlayWinnerId; 
}


public int GetScoreLimit() {
 return  mScoreLimit; 
}


public int GetTimeLimit() {
 return  mTimeLimit; 
}


public boolean IsNewRecord(byte singlePlayerStat) {
 return  mNewRecord[singlePlayerStat]; 
}


public byte GetTutorialShowingSetting () {







{
		return  mTutorialShowingSetting;
	}

}


public void SetTutorialShowingSetting (byte state) {

	

	if(state == kTutorialShowingOnce && mTutorialShowingSetting != kTutorialShowingOnce)
	{
		ResetSeenTutorials();
	}

	mTutorialShowingSetting = state;

}


public void ResetTutorial () {

	

	mTutorialShowingSetting = kTutorialShowingOnce;

	for(int i = 0;i < kModeCount;i ++)
	{
		mGameModeTutorialShown[i] = false;
	}


}


public int GetGameSetupOptions(int index) {
 return  mGameSetupOptions[index]; 
}


public boolean GetGameSetupOptionsBool (int index) {

	






 int val = GetGameSetupOptions(index);


 boolean returnValue = val == (((int)ConstantsEnglishPortrait.YesNoAnySelectorYesIndex == (int)ConstantsEnglishLandscape.YesNoAnySelectorYesIndex) ? Constants.YesNoAnySelectorYesIndex : ConstantsGetter.GetConstants().YesNoAnySelectorYesIndexFct());


	return  returnValue;

}


public byte GetGameSetupOptionsOffOnAny (int index) {

	






 int val = GetGameSetupOptions(index);



 byte returnValue = (byte)val;


	return  returnValue;

}


public int GetGameSetupOptionsInt (int index) {

	

	 int type = GetGameSetupOptionType(index);



 int vali = GetGameSetupOptions(index);


	 int entryPoint = 0;

	switch(type)
	{
		case kGameSetupOptionsTypeLevel :			  entryPoint = RSRC_commonPackage.gameLevelOptionValues_ID; break;
		case kGameSetupOptionsTypeScore :			  entryPoint = RSRC_commonPackage.scoreLimitOptionValues_ID; break;
		case kGameSetupOptionsTypeChallengeTetrimino : entryPoint = RSRC_commonPackage.tetriminosOptionValues_ID; break;
		case kGameSetupOptionsTypeClashLevel :		  entryPoint = RSRC_commonPackage.clashGameLevelOptionValues_ID; break;
		case kGameSetupOptionsTypePlayerCount :		  entryPoint = RSRC_commonPackage.numberOfPlayersOptionValues_ID; break;






default : ;
	}

	 Array_int realValuesArray = null;
	 Package p = RessourcesManager.Get().GetPackage(PackageID.common);
	(realValuesArray)= (realValuesArray).Cast((p).GetEntryPoint(entryPoint), null);

	return  realValuesArray.GetAt(vali);

}


public void SetGameSetupOptions (int index, int value) {

	

	mGameSetupOptions[index] = (byte)value;



















}


public int GetGameSetupOptionType (int index) {

	

	 int type = kGameSetupOptionsTypeCount;
 

	switch(index)
	{
		case kSettingSingleMarathonStartingLevel :
		case kSettingSingleUltraStartingLevel :
		case kSettingSingle40LinesStartingLevel :


case kSettingSingleChallengeStartingLevel :
			type = kGameSetupOptionsTypeLevel; break;





case kSettingSingleChallengePieceAtBottom :
			type = kGameSetupOptionsTypeOffOn; break;







case kSettingSingleChallengeTerimino :
			type = kGameSetupOptionsTypeChallengeTetrimino; break;








case kSettingSingleChallengeNumberOfPlayers :
			type = kGameSetupOptionsTypePlayerCount; break;

	default : ;

	}

	return  type;

}


public int GetGameSetupOptionTypeDataType (int optType) {

	

	 int type = kGameSetupOptionDataTypeCount;
 

	switch(optType)
	{
		case kGameSetupOptionsTypeOffOn :	  type = kGameSetupOptionDataTypeBool; break;
		case kGameSetupOptionsTypeOffOnAny :	  type = kGameSetupOptionDataTypeOffOnAny; break;
		case kGameSetupOptionsTypeDifficulty : type = kGameSetupOptionDataTypeDifficulty; break;

		case kGameSetupOptionsTypeLevel :
		case kGameSetupOptionsTypeScore :
		case kGameSetupOptionsTypeChallengeTetrimino :
		case kGameSetupOptionsTypeClashLevel :
		case kGameSetupOptionsTypePlayerCount :





{
			type = kGameSetupOptionDataTypeInt;
		}
		break;

		default : ;

	}

	return  type;

}


public boolean IsGameModeTutorialShown(int gameMode) {
 return  mGameModeTutorialShown[gameMode]; 
}


public void ShownGameModeTutorial(int gameMode) {
 mGameModeTutorialShown[gameMode] = true; 
}


public int GetStatistic(int id) {
 return  mSinglePlayerStats[id]; 
}


public static TetrisApp GetApp () {

	return  TetrisApp.Get();

}


public void CreateGameCommon (int gameMode, boolean networkGame) {

	














DeleteGameState();

	int i;

	for(i = 0;i < kLocalPlayerStatsCount;i ++)
	{
		mNewRecord[i] = false;
	}










{
		mpPlayers[kPlayer1] = new HumanPlayer(this, kPlayer1);
	}
		
mpPlayers[kPlayer1].GetGameState().SetTetriminoSeed(FlMath.Rand());








































}


public void UpdateLocalPlayerStats (boolean win) {

	



if(IsAttractModeGame())
	{
		return ;
	}

	 TetrisGame game = mpPlayers[kPlayer1].GetGameState();

	switch(mGameMode)
	{
		case kModeMarathon :
			UpdateStat(kStatMarathonScore, game.GetScore(), true);
			UpdateStat(kStatMarathonLines, game.GetLineCount(), true, IsNewRecord(kStatMarathonScore));
			UpdateStat(kStatMarathonLevel, game.GetLevel(), true, IsNewRecord(kStatMarathonScore));
			break;
		case kModeUltra :
			UpdateStat(kStatUltraScore, game.GetScore(), true);
			UpdateStat(kStatUltraLevel, game.GetLevel(), true, IsNewRecord(kStatUltraScore));
			break;
		case kMode40Lines :
			
			if(win)
			{
				UpdateStat(kStat40LinesTime, (int)(game.GetPlayTimeMs() /1000), false); 
			}
			break;













default : ; 

	}

}


public void UpdateStat (byte singlePlayerStat, int value, boolean higherIsBetter, boolean forceHighScore) {

	

	 int currentValue = mSinglePlayerStats[singlePlayerStat];


	if(	(higherIsBetter && value > currentValue) ||
		(!higherIsBetter && (currentValue == 0|| value < currentValue)) ||
		forceHighScore)
	{
		mSinglePlayerStats[singlePlayerStat] = value;
		mNewRecord[singlePlayerStat] = true;
	}


}


public void ResetSeenTutorials () {

	

	for(int i = 0;i < kModeCount;i ++)
	{
		mGameModeTutorialShown[i] = false;
	}


}


public TetrisPlayer[] mpPlayers = new TetrisPlayer[kPlayerCount];

public boolean[] mNewRecord = new boolean[kLocalPlayerStatsCount];

public int[] mMultiplayerSeeds = new int[kSeedCount];

public int mGameMode;
public int mLocalGameMode;
public int mStartingLevel;
public int mScoreLimit;
public int mTimeLimit;
public int mCurrentPlayer;
public int[] mPassNPlayScore = new int[(((int)ConstantsEnglishPortrait.passNPlayMaxPlayerCount == (int)ConstantsEnglishLandscape.passNPlayMaxPlayerCount) ? Constants.passNPlayMaxPlayerCount : -123)];

public int mPassNPlayWinnerId;
public byte mTutorialShowingSetting;
public byte[] mGameSetupOptions = new byte[kGameSetupOptionsCount];

public int[] mSinglePlayerStats = new int[kLocalPlayerStatsCount];

public boolean[] mGameModeTutorialShown = new boolean[kModeCount];

public void UpdateStat(byte singlePlayerStat, int value, boolean higherIsBetter)
{
	UpdateStat(singlePlayerStat, value, higherIsBetter, false);
}

/* One dimension array */
public static TetrisState[] InstArrayTetrisState(int size) {
	TetrisState[] newArray = new TetrisState[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new TetrisState();
	return newArray; }

/* Two dimension array */
public static TetrisState[][] InstArrayTetrisState(int size1, int size2) {
	TetrisState[][] newArray = new TetrisState[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new TetrisState[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new TetrisState(); }
	return newArray; }

/* Three dimension array */
public static TetrisState[][][] InstArrayTetrisState(int size1, int size2, int size3) {
	TetrisState[][][] newArray = new TetrisState[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new TetrisState[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new TetrisState[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new TetrisState(); } }
	return newArray; }



}

