package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class Well {

public  Well () {
mLastShotTSpinX = (-1);
mLastShotTSpinY = (-1);
mWellTop = ((((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()));


	for(int row = 0;row < (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct());row ++)
	{
		mpLines[row] = new WellLine();
	}

	for(int column = 0;column < (((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : ConstantsGetter.GetConstants().wellWidthFct());column ++)
	{
		mColumnsHeights[column] = 0;
	}

}


public void destruct() {

	
	for(int row = 0;row < (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct());row ++)
	{
		mpLines[row] = null;
	}

}


public void Assign ( Well well) {

	for(int i = 0;i < (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct());i ++)
	{
		mpLines[i].Assign(well.mpLines[i]);
	}
	mLastShotClearedLineFlags = well.mLastShotClearedLineFlags;
	mLastShotAddedLineCount = well.mLastShotAddedLineCount;
	mWellTop = well.mWellTop;
	for(int column = 0;column < (((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : ConstantsGetter.GetConstants().wellWidthFct());column ++)
	{
		mColumnsHeights[column] = well.mColumnsHeights[column];
	}

}


public boolean IsBlockUsed (int column, int row) {


	
	return  mpLines[row].IsBlockUsed(column);

}


public boolean IsMaskUsed (int pieceMask, int pieceCol, int row) {



	
	return  mpLines[row].IsMaskUsed(pieceMask <<pieceCol);

}


public byte GetBlockColor (int column, int row) {

	return  mpLines[row].GetBlock(column);

}


public byte GetSticky (int column, int row) {

	return  mpLines[row].GetSticky(column);

}


public int ComputeClearedLines (boolean eliminate) {



	 int lineFlags = 0;

	for(int i = mWellTop;i < (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct());i ++)
	{
		if(mpLines[i].IsComplete()) 
		{
			if(eliminate)
			{
				CollapseLine(i);
			}			
			 int line = i - (((int)ConstantsEnglishPortrait.wellHighestPossibleClearLine == (int)ConstantsEnglishLandscape.wellHighestPossibleClearLine) ? Constants.wellHighestPossibleClearLine : ConstantsGetter.GetConstants().wellHighestPossibleClearLineFct());

			if(line >= 0)
			{
				lineFlags |= (1<< line);
			}
		}
	}

	mLastShotAddedLineCount = 0;
	mLastShotClearedLineFlags = lineFlags;

	return  lineFlags;

}


public static int GetClearedLineCountFromFlags (int clearedLineFlags, int firstRow, int lastRow) {

	firstRow -= (((int)ConstantsEnglishPortrait.wellHighestPossibleClearLine == (int)ConstantsEnglishLandscape.wellHighestPossibleClearLine) ? Constants.wellHighestPossibleClearLine : ConstantsGetter.GetConstants().wellHighestPossibleClearLineFct());
	lastRow -= (((int)ConstantsEnglishPortrait.wellHighestPossibleClearLine == (int)ConstantsEnglishLandscape.wellHighestPossibleClearLine) ? Constants.wellHighestPossibleClearLine : ConstantsGetter.GetConstants().wellHighestPossibleClearLineFct());

	 int count = 0;


	for(int i = firstRow;i < lastRow;i ++)
	{
		
		if((clearedLineFlags & (1<< i)) != 0)
		{
			count++;
		}
	}

	return  count;

}


public static boolean IsClearedLineFromFlags (int clearedLineFlags, int row) {
		
	
	if(row <= (((int)ConstantsEnglishPortrait.wellHighestPossibleClearLine == (int)ConstantsEnglishLandscape.wellHighestPossibleClearLine) ? Constants.wellHighestPossibleClearLine : ConstantsGetter.GetConstants().wellHighestPossibleClearLineFct()))
	{
		return  false;
	}
	
	 int line = row - (((int)ConstantsEnglishPortrait.wellHighestPossibleClearLine == (int)ConstantsEnglishLandscape.wellHighestPossibleClearLine) ? Constants.wellHighestPossibleClearLine : ConstantsGetter.GetConstants().wellHighestPossibleClearLineFct());


	return  (clearedLineFlags & (1<< line)) != 0;

}


public boolean HasCompleteLines () {
	
	for(int i = mWellTop;i < (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct());i ++)
	{
		if(mpLines[i].IsComplete())
		{
			return  true;
		}
	}

	return  false;

}


public WellLine GetLine (int row) {



	return mpLines[row];

}


public WellLine GetLineConst (int row) {



	return mpLines[row];

}


public boolean AddLine (short lineMask, boolean triggerAnimation) {

    
	if(mpLines[0].HasBlock())
	{
		
		return  false;
	}

	
	for(int i = 0;i < (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) - 1;i ++)
	{
		mpLines[i].Assign(mpLines[i + 1]);
	}

	
	mpLines[(((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) - 1].SetLineFromMask(lineMask);

	
	if(triggerAnimation)
	{
		mLastShotAddedLineCount++;
	}
	
	mWellTop--; 



RecomputeColumnsHeights();

	return  true;

}


public void Clear () {

	for(int i = 0;i < (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct());i ++)
	{
		mpLines[i].Clear();
	}
	
	mWellTop = (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct());
	for(int column = 0;column < (((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : ConstantsGetter.GetConstants().wellWidthFct());column ++)
	{
		mColumnsHeights[column] = 0;
	}

	mLastShotAddedLineCount = 0;


}


public int[] GetColumnsHeights () {



return  mColumnsHeights;

}


public int GetWellTop() {
 return  mWellTop; 
}


public void SetWellTop(int top) {
 mWellTop = top; 
}


public void NoticeAddedMino (int column, int row) {

	 int height = (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) - row;

	if(height > mColumnsHeights[column])
	{
		mColumnsHeights[column] = height;

		
		if(row < mWellTop)
		{
			mWellTop = row;
		}
	}

}


public void NoticeRemovedMino (int column, int row) {

	 int height = (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) - row;

	if(height == mColumnsHeights[column])
	{
		
		RecomputeColumnHeight(column, row + 1);
	}

}


public int GetLastShotClearedLineFlags() {
 return  mLastShotClearedLineFlags; 
}


public int GetLastShotAddedLineCount() {
 return  mLastShotAddedLineCount; 
}


public boolean IsDoingAnimation() {
 return  mDoingAnimation; 
}


public void SetDoingAnimation(boolean doingAnimation) {
 mDoingAnimation = doingAnimation; 
}


public void ResetLastShotTSpinPos() {
 SetLastShotTSpinPos((short)-1, (short)-1); 
}


public void SetLastShotTSpinPos(short x, short y) {
 mLastShotTSpinX = x; mLastShotTSpinY = y; 
}


public short GetLastShotTSpinX() {
 return  mLastShotTSpinX; 
}


public short GetLastShotTSpinY() {
 return  mLastShotTSpinY; 
}


public boolean IsLastShotTSpin() {
 return  mLastShotTSpinX != -1|| mLastShotTSpinY != -1; 
}


public void SetLastShotBackToBack(boolean backToBack) {
 mLastShotBackToBack = backToBack; 
}


public boolean GetLastShotBackToBack() {
 return  mLastShotBackToBack; 
}


public void CollapseLine (int row) {



	for(int i = row;i > 0;i --) 
	{
		mpLines[i].Assign(mpLines[i-1]);
	}

	mpLines[0].Clear();

	mWellTop++; 
	RecomputeColumnsHeights();
	

	
	mpLines[row].WipeSticky((byte)0x2);
	
	if(row < (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) - 1)
	{
		mpLines[row+1].WipeSticky((byte)0x8);
	}

}


public void RecomputeColumnHeight (int column, int startRow) {

	mColumnsHeights[column] = 0;

	for(int row = startRow;row < (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct());row ++)
	{
		if(mpLines[row].IsBlockUsed(column))
		{
			mColumnsHeights[column] = (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) - row;
			break;
		}
	}

}


public void RecomputeColumnsHeights () {



	for(int column = 0;column < (((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : ConstantsGetter.GetConstants().wellWidthFct());column ++)
	{
		RecomputeColumnHeight(column, mWellTop);
	}

}


public WellLine[] mpLines = new WellLine[(((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : -123)];

public int mLastShotClearedLineFlags;
public int mLastShotAddedLineCount;
public short mLastShotTSpinX;
public short mLastShotTSpinY;
public boolean mLastShotBackToBack;
public int mWellTop;
public int[] mColumnsHeights = new int[(((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : -123)];

public boolean mDoingAnimation;
public static int GetClearedLineCountFromFlags(int clearedLineFlags)
{
	return GetClearedLineCountFromFlags(clearedLineFlags, (((int)ConstantsEnglishPortrait.wellHighestPossibleClearLine == (int)ConstantsEnglishLandscape.wellHighestPossibleClearLine) ? Constants.wellHighestPossibleClearLine : ConstantsGetter.GetConstants().wellHighestPossibleClearLineFct()));
}
public static int GetClearedLineCountFromFlags(int clearedLineFlags, int firstRow)
{
	return GetClearedLineCountFromFlags(clearedLineFlags, firstRow, (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()));
}

/* One dimension array */
public static Well[] InstArrayWell(int size) {
	Well[] newArray = new Well[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new Well();
	return newArray; }

/* Two dimension array */
public static Well[][] InstArrayWell(int size1, int size2) {
	Well[][] newArray = new Well[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Well[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new Well(); }
	return newArray; }

/* Three dimension array */
public static Well[][][] InstArrayWell(int size1, int size2, int size3) {
	Well[][][] newArray = new Well[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Well[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new Well[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new Well(); } }
	return newArray; }



}

